/////////////////////////////////////////////////////////////////////////////
// bt848.c: Hardware-Parts for the BT-Chips
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  Originally based on code by:
//   BT-Parts
//
//   Copyright (C) 1996,97,98 Ralph  Metzler (rjkm@thp.uni-koeln.de)
//                          & Marcus Metzler (mocm@thp.uni-koeln.de)
//   msp34XX
//
//  Copyright (C) 1997,1998 Gerd Knorr <kraxel@goldbach.in-berlin.de>
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "bt848.h"
#include "btaudio.h"
#include "bt_io.h"
#include "K!TV-XP.h"
#include "hardwaremisc.h"
#include "plugin.h"
#include "settings.h"


int ColourFormat = 4;
char TunerStatus[64];
BYTE INIT_PLL=1;
static BYTE PLL_SET;
static WORD m_wWindowWidth,m_wWindowHeight;
static int CAudioSource=0;
static BYTE TunerDeviceWrite, TunerDeviceRead;

struct ParamCarte ParametreCarte[16] = 
{
	{ TRUE,		0x00,		0x00,		0x00,		0x00,		0x00,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,1,FALSE,"Carte TV Personnalise"},
	{ FALSE,	0x02,		0x00,		0x00,		0x00,		0x0a,		0x00,		0x00,		0x00,		2,0,3,2,FALSE,0,FALSE,"Miro PCTV (Bt848)"},
	{ FALSE,	0x02,		0x00,		0x00,		0x00,		0x0a,		0x00,		0x00,		0x00,		2,0,3,2,FALSE,1,FALSE,"Miro PCTV / PCTV Rave (Bt878)"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,1,TRUE ,"Hauppauge WinTV Go/Primio (Bt878)"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,7,3,2,TRUE ,0,TRUE ,"Hauppauge WinTV Nicam (Bt848)"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,7,3,2,TRUE ,1,TRUE ,"Hauppauge WinTV Nicam (Bt878)"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,7,3,2,TRUE ,1,FALSE,"ATI TV WONDER (Bt878) "},
	{ TRUE,		0x551E00,	0x9CE500,	0x00,		0x00,		0x00,		0x9CE500,	0x00,		0x00,		0,0,3,2,FALSE,1,FALSE,"Askey Magic TView / Anubis Typhoon (Bt878)"},
	{ TRUE,		0xFFFF,		0x00,		0x00,		0xC00,		0x800,		0x400,		0xC00,		0x00,		0,0,3,2,FALSE,0,FALSE,"Guillemot MaxiTV PCI2 (Bt848)"},
	{ TRUE,		0xFFFF,		0x00,		0x00,		0x1000,		0x1000,		0x800,		0x00,		0x00,		0,0,3,2,FALSE,1,FALSE,"Guillemot MaxiTV PCI2 (Bt878)"},
	{ TRUE,		0x551E00,	0xFFE5FF,	0x00,		0x00,		0x00,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,1,FALSE,"Guillemot MaxiTV PCI3 (Bt878)"},
	{ TRUE,		0xB33000,	0x00,		0xCED01,	0x00,		0x00,		0x00,		0x8CED01,	0x00,		0,0,3,2,FALSE,1,FALSE,"Leadtek WinFast TV 2000 (Bt878)"},
	{ FALSE,	0x0c,		0x00,		0x0b,		0x0b,		0x00,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,0,FALSE,"AVerMedia TVPhone"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,0,FALSE,"Diamond DTV2000"},
	{ FALSE,	0x00,		0x01,		0x02,		0x03,		0x04,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,0,FALSE,"Intel"},
	{ FALSE,	0x04,		0x00,		0x02,		0x03,		0x01,		0x00,		0x00,		0x00,		0,0,3,2,FALSE,0,FALSE,"STB"},
};


struct TTunerType Tuners[9] =
{
    { "Temic Pal",0,2244/*16*140.25*/,7412/*16*463.25*/,0x02,0x04,0x01,0x8e,0xc2,623},		//Temic PAL
	{ "Philips Pal I",0,2244/*16*140.25*/,7412/*16*463.25*/,0xa0,0x90,0x30,0x8e,0xc0,623},		//Philips PAL I
	{ "Philips NTSC",1,2516/*16*157.25*/,7220/*16*451.25*/,0xA0,0x90,0x30,0x8e,0xc0,732},		//Philips NTSC
	{ "Philips SECAM",2,2692/*16*168.25*/,7156/*16*447.25*/,0xA7,0x97,0x37,0x8e,0xc0,623, 0x02},//Philips SECAM
	{ "Pas de tuner - Chgt de source",0,0				 ,0				   ,0x00,0x00,0x00,0x00,0x00,000},		//Pas de tuner (chgt de source)
	{ "Philips Pal",0,2692/*16*168.25*/,7156/*16*447.25*/,0xA0,0x90,0x30,0x8e,0xc0,623},		//Philips Pal
	{ "Temic NTSC",1,2516/*16*157.25*/,7412/*16*463.25*/,0x02,0x04,0x01,0x8e,0xc2,732},		//Temic NTSC
	{ "Temic Pal I",0,2720/*16*170.00*/,7200/*16*450.00*/,0xa0,0x90,0x30,0x8e,0xc2,623},		//Temic PAL I
	{ "Tuner Manuel...",0,0        ,0        ,0x00,0x00,0x00,0x00,0x00,000},						//Tuner Manuel

};


struct TTVSetting TVSettings[7] =
{
	// PAL-BDGHI
	{ "PAL-BDGHI", 0, 768, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, TRUE, 19 },
	// NTSC
	{ "NTSC", 1, 640, 480,  910, 0x68, 0x5c, (BT848_IFORM_NTSC|BT848_IFORM_XT0),
	    780, 640, 137, 754, 0x1a, FALSE, 13 },
	// SECAM
	{ "SECAM", 2, 768, 576, 1135, 0x7f, 0xA0, (BT848_IFORM_SECAM|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, TRUE, 19 },
	// PAL-M
	{ "PAL-M", 0, 640, 480, 910, 0x68, 0x5c, (BT848_IFORM_PAL_M|BT848_IFORM_XT0),
	    780, 640, 186, 922, 0x1a, FALSE, 13 },
	// PAL-N
	{ "PAL-N", 0, 768, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_N|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, TRUE, 19 },
	// NTSC Japan
	{ "NTSC Japan", 1, 640, 480,  910, 0x70, 0x5c, (BT848_IFORM_NTSC_JAP|BT848_IFORM_XT0),
	    780, 640, 137, 754, 0x1a, FALSE, 13 },
	// PAL-60
	{ "PAL-60", 0, 640, 480, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    780, 640, 186, 922, 0x20, TRUE, 16 },
};


void BT8X8_Reset_Hardware()
{
    BT8X8_SetDMA(FALSE);
	BT8X8_WriteByte( BT848_SRESET,0);
	Sleep(100);
	BT8X8_WriteDword(BT848_RISC_STRT_ADD, RiscBasePhysical);

	BT8X8_WriteByte(BT848_CAP_CTL,0x00);
//	BT8X8_WriteByte(BT848_COLOR_CTL,0x10);
	BT8X8_WriteByte(BT848_VBI_PACK_SIZE,(VBI_SPL/4)&0xff);
	BT8X8_WriteByte(BT848_VBI_PACK_DEL,(VBI_SPL/4)>>8);
	BT8X8_WriteWord(BT848_GPIO_DMA_CTL,0xfc);
    BT8X8_WriteByte(BT848_IFORM,BT848_IFORM_MUX1 | BT848_IFORM_XTAUTO | BT848_IFORM_PAL_BDGHI);
	BT8X8_SetVideoSource(VideoSource);
    BT8X8_WriteByte(BT848_TDEC,0x00);

    BT8X8_WriteDword(BT848_INT_STAT, (DWORD) 0x0fffffff);
    BT8X8_WriteDword(BT848_INT_MASK, 0);

    BT8X8_Set_PLL(INIT_PLL);
    BT8X8_SetColourFormat(ColourFormat);

	BT8X8_WriteByte(BT848_ADC,BT848_ADC_RESERVED|BT848_ADC_CRUSH);

	BT8X8_WriteByte(BT848_E_CONTROL,BT848_CONTROL_LDEC);
	BT8X8_WriteByte(BT848_O_CONTROL,BT848_CONTROL_LDEC);

    BT8X8_WriteByte(BT848_E_SCLOOP,    0x60);//Si mauvais format de couleur passage en NB
    BT8X8_WriteByte(BT848_O_SCLOOP,    0x60);
    BT8X8_WriteByte(BT848_E_VSCALE_HI, 0x20);
    BT8X8_WriteByte(BT848_O_VSCALE_HI, 0x20);
    BT8X8_WriteByte(BT848_O_VSCALE_LO, 0x00);
    BT8X8_WriteByte(BT848_E_VSCALE_LO, 0x00);

    BT8X8_WriteByte(BT848_E_CONTROL,   0x03);
    BT8X8_WriteByte(BT848_O_CONTROL,   0x03);

	BT8X8_SetBrightness(InitialBrightness[TVSettings[TVTYPE].format]);
	BT8X8_SetContrast(InitialContrast[TVSettings[TVTYPE].format]);
	BT8X8_SetHue(InitialHue);
	BT8X8_SetSaturationU(InitialSaturationU[TVSettings[TVTYPE].format]);  
	BT8X8_SetSaturationV(InitialSaturationV[TVSettings[TVTYPE].format]);
	return;
}


void BT8X8_Set_PLL( int PLL )
{
	int i = 6;

	// reset the TGCKI bits
	BT8X8_MaskDataByte(BT848_TGCTRL, BT848_TGCTRL_TGCKI_NOPLL, 0x18);

	switch(PLL)
	{
	case 0:
		BT8X8_WriteByte(BT848_PLL_XCI, 0x00);
		return;
		break;
	case 1:
		BT8X8_WriteByte(BT848_PLL_F_LO, 0xf9);
		BT8X8_WriteByte(BT848_PLL_F_HI, 0xdc);
		BT8X8_WriteByte(BT848_PLL_XCI, 0x8e);
		break;
	case 2:
		BT8X8_WriteByte(BT848_PLL_F_LO, 0x39);
		BT8X8_WriteByte(BT848_PLL_F_HI, 0xB0);
		BT8X8_WriteByte(BT848_PLL_XCI, 0x89);
		break;
	}

	// wait for the PLL to lock
	while(i-- > 0 && BT8X8_ReadByte(BT848_DSTATUS) & BT848_DSTATUS_PLOCK)
	{
		BT8X8_WriteByte(BT848_DSTATUS, 0x00);
		Sleep(100);
	}

	// Set the TGCKI bits to use PLL rather than xtal
	BT8X8_MaskDataByte(BT848_TGCTRL, BT848_TGCTRL_TGCKI_PLL, 0x18);
	BT8X8_WriteByte(BT848_VTOTAL_LO, 0x00);
	BT8X8_WriteByte(BT848_VTOTAL_HI, 0x00);
	BT8X8_WriteByte(BT848_DVSIF, 0x00);
}


void BT8X8_SetDMA(BOOL bState)
{
	if(bState)
		BT8X8_OrDataWord(BT848_GPIO_DMA_CTL,3);
	else
		BT8X8_AndDataWord(BT848_GPIO_DMA_CTL,~3);
}


BOOL BT8X8_SetColourFormat(int nColourFormat)
{
	if(nColourFormat>10) return FALSE;

	if (nColourFormat==BT848_COLOR_FMT_RGB8)
		BT8X8_AndDataByte(BT848_CAP_CTL,~0x10);
	else
		BT8X8_OrDataByte(BT848_CAP_CTL,0x10);
	ColourFormat=nColourFormat;
	BT8X8_SetGeometry(m_wWindowWidth,m_wWindowHeight,TVTYPE,(ColourFormat<<4)|ColourFormat);
	return TRUE;
}


BOOL BT8X8_SetBrightness(unsigned char bBrightness)
{
	if (IsPluginVideoRunning)
	{
		PluginVideo->SetLow(bBrightness);

	}
	BT8X8_WriteByte(BT848_BRIGHT, bBrightness);
	return TRUE;
}


BOOL BT8X8_SetHue(char bHue)
{
	BT8X8_WriteByte( BT848_HUE, bHue);
	return TRUE;
}


BOOL BT8X8_SetContrast(int wContrast)
{
	BYTE bContHi;

	bContHi=(BYTE)(wContrast>>6)&4;
	BT8X8_WriteByte(BT848_CONTRAST_LO,(BYTE)(wContrast&0xff));
	BT8X8_MaskDataByte(BT848_E_CONTROL,bContHi,4);
	BT8X8_MaskDataByte(BT848_O_CONTROL,bContHi,4);
	return TRUE;
}


BOOL BT8X8_SetSaturationU(int wData)
{
	BYTE bDataHi;

	bDataHi=(BYTE)(wData>>7)&2;
	BT8X8_WriteByte(BT848_SAT_U_LO,(BYTE)(wData&0xff));
	BT8X8_MaskDataByte(BT848_E_CONTROL,bDataHi,2);
	BT8X8_MaskDataByte(BT848_O_CONTROL,bDataHi,2);
	return TRUE;
}


BOOL BT8X8_SetSaturationV(int wData)
{
	BYTE bDataHi;

	bDataHi=(BYTE)(wData>>8)&1;
	BT8X8_WriteByte(BT848_SAT_V_LO,(BYTE)(wData&0xff));
	BT8X8_MaskDataByte(BT848_E_CONTROL,bDataHi,1);
	BT8X8_MaskDataByte(BT848_O_CONTROL,bDataHi,1);
	return TRUE;
}


BOOL BT8X8_SetVideoSource(int nInput)
{
	int tInput=0;
	
	BT8X8_AndDataByte(BT848_IFORM,~(3<<5));

	switch(nInput)
	{
		case 0: //Tuner
			tInput=2;
			BT8X8_AndDataByte(BT848_E_CONTROL,~BT848_CONTROL_COMP);
			BT8X8_AndDataByte(BT848_O_CONTROL,~BT848_CONTROL_COMP);
			break;

		case 1: //Composite
			BT8X8_AndDataByte(BT848_E_CONTROL,~BT848_CONTROL_COMP);
			BT8X8_AndDataByte(BT848_O_CONTROL,~BT848_CONTROL_COMP);
			tInput=4;
			break;

		case 2: //S-Vido
			BT8X8_OrDataByte(BT848_E_CONTROL,BT848_CONTROL_COMP);
			BT8X8_OrDataByte(BT848_O_CONTROL,BT848_CONTROL_COMP);
			tInput=5;
			break;

		case 3: //Composite via S-Vido
			BT8X8_AndDataByte(BT848_E_CONTROL,~BT848_CONTROL_COMP);
			BT8X8_AndDataByte(BT848_O_CONTROL,~BT848_CONTROL_COMP);
			tInput=5;
			break;

		case 4: //Externe1
			BT8X8_AndDataByte(BT848_E_CONTROL,~BT848_CONTROL_COMP);
			BT8X8_AndDataByte(BT848_O_CONTROL,~BT848_CONTROL_COMP);
			tInput=3;
			break;
	}

	VideoSource=nInput;
	BT8X8_MaskDataByte(BT848_IFORM,(BYTE)(((tInput)&3)<<5), (BYTE)(3<<5));
	return TRUE;
}


void BT8X8_SetGeometryEvenOdd(BOOL bOdd, BYTE bVtc,
					int wHScale, int wVScale,
					int wHActive,int wVActive,
					int wHDelay, int wVDelay,
				    BYTE bCrop)
{
	int nOff=bOdd?0x80:0x00;

	BT8X8_WriteByte(BT848_E_VTC+nOff,bVtc);
	BT8X8_WriteByte(BT848_E_HSCALE_HI+nOff,(BYTE)(wHScale>>8));
	BT8X8_WriteByte(BT848_E_HSCALE_LO+nOff,(BYTE)(wHScale&0xFF));
    BT8X8_MaskDataByte(BT848_E_VSCALE_HI + nOff, (BYTE) (wVScale >> 8), 0x1F);
	BT8X8_WriteByte(BT848_E_VSCALE_LO+nOff,(BYTE)(wVScale&0xFF));
	BT8X8_WriteByte(BT848_E_HACTIVE_LO+nOff,(BYTE)(wHActive&0xFF));
	BT8X8_WriteByte(BT848_E_HDELAY_LO+nOff,(BYTE)(wHDelay&0xFF));
	BT8X8_WriteByte(BT848_E_VACTIVE_LO+nOff,(BYTE)(wVActive&0xFF));
	BT8X8_WriteByte(BT848_E_VDELAY_LO+nOff,(BYTE)(wVDelay&0xFF));
	BT8X8_WriteByte(BT848_E_CROP+nOff,bCrop);
}


BOOL BT8X8_SetGeometry(int width, int height, int Type,int CF)
{
    int vscale, hscale;
	DWORD xsf, sr;
	int hdelay, vdelay;
	int hactive, vactive;
	BYTE crop, vtc, ColourFormat;  
	
	if (!width || !height)
	        return FALSE;

	m_wWindowHeight=height;
	m_wWindowWidth=width;

    // Reglage du PLL de la carte si necessaire
    if(TVSettings[Type].NeedsPLL && INIT_PLL != PLL_SET)
    {
        BT8X8_Set_PLL(INIT_PLL);
		PLL_SET=INIT_PLL;
    }
    else if(!TVSettings[Type].NeedsPLL)
    {
        BT8X8_Set_PLL(0);
		PLL_SET=0;
    }

	BT8X8_WriteByte(BT848_WC_UP, 0xcf);
	BT8X8_WriteByte(BT848_WC_DOWN, 0x7f);
	
	BT8X8_WriteByte(BT848_ADELAY, TVSettings[Type].bDelayA);
	BT8X8_WriteByte(BT848_BDELAY, TVSettings[Type].bDelayB);
	BT8X8_MaskDataByte(BT848_IFORM, TVSettings[Type].bIForm, BT848_IFORM_NORM|BT848_IFORM_XTBOTH);

    ColourFormat = (BYTE)((BT848_COLOR_FMT_YUY2 << 4) | BT848_COLOR_FMT_YUY2);

    BT8X8_WriteByte(BT848_COLOR_FMT, ColourFormat);

	hactive=width;
	vtc = 0;//(hactive < 193) ? 2 : ((hactive < 385) ? 1 : 0); 

	xsf = (width*TVSettings[Type].dwXsfNum)/TVSettings[Type].dwXsfDen;
	hscale = (WORD)((TVSettings[Type].wTotalWidth*4096UL)/xsf-4096);
	vdelay=TVSettings[Type].wVDelay;

	hdelay=((hactive*TVSettings[Type].wHDelayx1)/TVSettings[Type].wHActivex1)&0x3fe;

	if(Type==6)	//Pal 60
	{
		BT8X8_WriteByte(BT848_VTOTAL_LO, (BYTE)(525 & 0xff));
		BT8X8_WriteByte(BT848_VTOTAL_HI, (BYTE)(525 >> 8));
	}

	sr=(TVSettings[Type].wCropHeight*512)/height-512;
	vscale=(WORD)(0x10000UL-sr)&0x1fff;
	vactive=TVSettings[Type].wCropHeight;
	crop=((hactive>>8)&0x03)|((hdelay>>6)&0x0c)|
	  ((vactive>>4)&0x30)|((vdelay>>2)&0xc0);
	
	BT8X8_SetGeometryEvenOdd(FALSE, vtc, hscale, vscale, hactive, vactive, hdelay, vdelay, crop);
	BT8X8_SetGeometryEvenOdd(TRUE, vtc, hscale, vscale, hactive, vactive,	hdelay, vdelay, crop);
	return TRUE;
}


BOOL BT8X8_SetGeoSize(int wWidth, int wHeight)
{
	if(!BT8X8_SetGeometry(wWidth,wHeight,TVTYPE,(ColourFormat<<4)|ColourFormat))
		return FALSE;

	return TRUE;
}


BOOL BT8X8_SetAudioSource(int nChannel)
{
	BYTE B3;
	unsigned short B1;
    int i=0;
/*	Audio_Tuner,
	Audio_Radio,
	Audio_External,
	Audio_Internal,
	Audio_Off,
	Audio_On,
	Audio_Mute = 0x80,
	Audio_UnMute = 0x81
*/	

	if ( ParametreCarte[CardType].cfgsonperso)
	{
		B1=ParametreCarte[CardType].GPIO_OUT_EN;
		B3=(ParametreCarte[CardType].GPIO_OUT_EN >> 16 );
		BT8X8_WriteByte(BT848_GPIO_OUT_EN_HIBYTE,B3);
		BT8X8_WriteWord(BT848_GPIO_OUT_EN, B1);      
		B1=ParametreCarte[CardType].GPIO_DATA_On;
		B3=(ParametreCarte[CardType].GPIO_DATA_On >> 16 );
		BT8X8_WriteWord(BT848_GPIO_REG_INP_HIBYTE, B3);        // 3Bytes
		BT8X8_WriteWord(BT848_GPIO_REG_INP, B1);        // 3Bytes
		
		switch(nChannel)
		{
		case 0:
			Audio_Init(0x80,0x81);
			B1=ParametreCarte[CardType].GPIO_REG_INP;
			B3=(ParametreCarte[CardType].GPIO_REG_INP >> 16 );
			break;

		case 1:
			B1=ParametreCarte[CardType].GPIO_DATA_Tuner;
			B3=(ParametreCarte[CardType].GPIO_DATA_Tuner >> 16 );
			break;

		case 2:
			B1=ParametreCarte[CardType].GPIO_DATA_Radio;
			B3=(ParametreCarte[CardType].GPIO_DATA_Radio >> 16 );
			break;

		case 3:
			B1=ParametreCarte[CardType].GPIO_DATA_Externe;
			B3=(ParametreCarte[CardType].GPIO_DATA_Externe >> 16 );
			break;
	
		case 4:
			B1=ParametreCarte[CardType].GPIO_DATA_Interne;
			B3=(ParametreCarte[CardType].GPIO_DATA_Interne >> 16 );
			break;
	
		case 5:
			B1=ParametreCarte[CardType].GPIO_DATA_Off;
			B3=(ParametreCarte[CardType].GPIO_DATA_Off >> 16 );
			break;
		}

		BT8X8_WriteByte(BT848_GPIO_DATA_HIBYTE, B3);
		BT8X8_WriteWord(BT848_GPIO_DATA, B1);        // 3Bytes
		return(TRUE);
	}


	switch (nChannel)
	{
	    case 0x80:
			CAudioSource=(int)((CAudioSource)|(int)0x80);
			nChannel=ParametreCarte[CardType].GPIO_DATA_Externe;
			break;
 		case 0x81:
			CAudioSource=(int)((CAudioSource)&~(int)0x80);
			nChannel=AudioSource;
			break;
		case 0x00:
			i=ParametreCarte[CardType].GPIO_OUT_EN;
			CAudioSource=(int)( CAudioSource &( int)0x80);
			CAudioSource=(int)( CAudioSource |  i);
			break;
		case 0x01:
			Audio_Init(0x80,0x81);
			CAudioSource=(int)( CAudioSource &( int)0x80);
			CAudioSource=(int)( CAudioSource |  ParametreCarte[CardType].GPIO_REG_INP);
			break;
		case 0x02:
			CAudioSource=(int)( CAudioSource &( int)0x80);
			CAudioSource=(int)( CAudioSource |  ParametreCarte[CardType].GPIO_DATA_Tuner);
			break;
		case 0x03:
			CAudioSource=(int)( CAudioSource &( int)0x80);
			CAudioSource=(int)( CAudioSource |  ParametreCarte[CardType].GPIO_DATA_Radio);
			break;
		case 0x04:
			nChannel=ParametreCarte[CardType].GPIO_DATA_Externe;
			break;
		case 0x05:
			nChannel=AudioSource;
			break;
	}


    /* enable least significant GPIO output byte */
    BT8X8_WriteWord(BT848_GPIO_OUT_EN,0xffff);

	i=0;
	while ((i < 20 ) && (!(BT8X8_ReadByte(BT848_DSTATUS)&BT848_DSTATUS_HLOC)))
	{
		i++;
		Sleep(50);
	}

    /* if audio mute or not in H-lock, turn audio off */
	if ((nChannel != 1 ) && ((CAudioSource&0x80) || !(BT8X8_ReadByte(BT848_DSTATUS)&BT848_DSTATUS_HLOC)))
		nChannel=ParametreCarte[CardType].GPIO_DATA_Externe;


    /* select direct input */
	BT8X8_WriteWord(BT848_GPIO_REG_INP, 0x00);        // 3Bytes
	BT8X8_MaskDataWord(BT848_GPIO_DATA,(unsigned short)(0xfff0|nChannel), (unsigned short)0x0ffff);                // 3Bytes
	return TRUE;
}


BOOL VideoPresent()
{
	return ((BT8X8_ReadByte(BT848_DSTATUS)&(BT848_DSTATUS_PRES|BT848_DSTATUS_HLOC))==(BT848_DSTATUS_PRES|BT848_DSTATUS_HLOC))?TRUE:FALSE;
}


BOOL Tuner_Init(int TunerNr )
{
	unsigned char j;

	TunerStatus[0]=0x00;
	sprintf(TunerStatus,Langue_GetString(ID_TUNERFAILED));
	
	if ( !USETUNER ) return(TRUE);
	
	j=0xc0;
	TunerDeviceRead=Tuners[TunerNr].I2C=j;
	TunerDeviceWrite=Tuners[TunerNr].I2C=j;
	
	while ( ( j <= 0xce ) && (!I2CBus_AddDevice((BYTE)j)) )
	{
		j++;
		TunerDeviceRead=Tuners[TunerNr].I2C=j;
		TunerDeviceWrite=Tuners[TunerNr].I2C=j;
	}

	if ( j > 0xce )
	{
		return(FALSE);
	}
	sprintf(TunerStatus, Langue_GetString(ID_TUNERI2C), j);
	if(CurrentProgram,Program[CurrentProgram].Source==0)
		Tuner_SetFrequency(TunerNr,MulDiv(Program[CurrentProgram].freq*1000,16,1000000));
	return(TRUE);
}


BOOL Tuner_SetFrequency(int TunerTyp, int wFrequency)
{
	static int bFrequency=0;
	BYTE config;
	WORD div;
	BOOL bAck;

	if ( !USETUNER ) return(TRUE);

	if (wFrequency < Tuners[TunerTyp].thresh1) 
		config = Tuners[TunerTyp].VHF_L;
	else if (wFrequency < Tuners[TunerTyp].thresh2) 
		config = Tuners[TunerTyp].VHF_H;
	else
		config = Tuners[TunerTyp].UHF;

	if (TunerTyp == 3)
	{
	    // Handle Mode on Philips SECAM tuners
	    // They can also receive PAL if the Mode is set properly
        if (TVSettings[TVTYPE].format==2)
        {
            config |= Tuners[TunerTyp].mode;
        }
        else
        {
            config &= ~Tuners[TunerTyp].mode;
        }
	}
	div=wFrequency+Tuners[TunerTyp].IFPCoff;

	div&=0x7fff;
	I2CBus_Lock();

	if ( (TunerTyp == 3) && (wFrequency < bFrequency) )
	{
	    // Philips FI1216MK2 remark from specification :
	    // for channel selection involving band switching, and to ensure
	    // smooth tuning to the desired channel without causing
	    // unnecessary charge pump action, it is recommended to consider
	    // the difference between wanted channel frequency and the
	    // current channel frequency.  Unnecessary charge pump action
	    // will result in very low tuning voltage which may drive the
	    // oscillator to extreme conditions.
	    //
	    //
	    // Progfou: specification says to send config data before
	    // frequency in case (wanted frequency < current frequency).

		if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
		{
			Sleep(1);
			if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
			{
				Sleep(1);
				if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
				{
					RealErrorBox(Langue_GetString(ID_TUNERWRITE));
				}
			}
		}
	
		if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
		{
			Sleep(1);
			if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
			{
	 			Sleep(1);
				if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
				{
	       		    RealErrorBox(Langue_GetString(ID_TUNERWRITE));
              		I2CBus_Unlock();
					return(FALSE);
				}
			}
		}
	}
	else
	{
		if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
		{
			Sleep(1);
			if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
			{
	 			Sleep(1);
				if(!I2CBus_Write((BYTE)TunerDeviceWrite,(BYTE)((div>>8)&0x7f),(BYTE)(div&0xff),TRUE))
				{
	       		    RealErrorBox(Langue_GetString(ID_TUNERWRITE));
              		I2CBus_Unlock();
					return(FALSE);
				}
			}
		}
		if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
		{
			Sleep(1);
			if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
			{
				Sleep(1);
				if(!(bAck=I2CBus_Write(TunerDeviceWrite,Tuners[TunerTyp].config,config,TRUE)))
				{
					RealErrorBox(Langue_GetString(ID_TUNERWRITE));
				}
			}
		}
	
	}
		
	I2CBus_Unlock();
	bFrequency=wFrequency;
	if(!bAck) return FALSE;
	return TRUE;

}

