/////////////////////////////////////////////////////////////////////////////
// DebugLog.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "DebugLog.h"

BOOL WRITE_LOG=FALSE;
static void __cdecl SaveToFile (char* String2Display, ...);
extern HWND hWnd;
extern HWND SplashWnd;


void __cdecl LOG(int DebugLevel, LPCSTR Format, ...)
{
    char szMessage[2048];
    va_list Args;

    va_start(Args, Format);
    vsprintf(szMessage, Format, Args);
    va_end(Args);

	// DebugLevel = 1 : messages importants
	if (DebugLevel > 1) return;

	if ( WRITE_LOG ) SaveToFile (szMessage);
#ifdef _DEBUG
	OutputDebugString(szMessage);
	OutputDebugString("\n");
#endif
}

// Meme chose que LOG mais on n'ajoute pas '\n'
// Utilis lors de la fermeture de K!TV.
void __cdecl LOG_(int DebugLevel, LPCSTR Format, ...)
{
	int Colonne = 50;
    char szMessage[2048], ChaineFinale[255];
    va_list Args;

    va_start(Args, Format);
    vsprintf(szMessage, Format, Args);
    va_end(Args);

	// DebugLevel = 1 : message important
	if (DebugLevel > 1) return;

	memset(ChaineFinale, '.', sizeof(char) * 255);
	strncpy(ChaineFinale, szMessage, strlen(szMessage) );
	ChaineFinale[strlen(szMessage)] = '.';
	ChaineFinale[50] = '\0';

	if ( WRITE_LOG ) SaveToFile (ChaineFinale);
#ifdef _DEBUG
	OutputDebugString(ChaineFinale);
#endif
}


static void __cdecl SaveToFile (char* String2Display, ...)
{
	FILE* iniFile;
	int nBuf;
	char szBuffer[512];

	va_list args;
	va_start(args, String2Display);
	
	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer) / sizeof(WCHAR), String2Display, args);

	if ((iniFile=fopen("K!TV-XP.log", "a")) == NULL )
	{
		return;
	}
	fprintf(iniFile,"%s\n",szBuffer);
	fclose(iniFile);
	
	va_end(args);
}


void RealErrorBox(char * msg) 
{ 
	// Cache la SplashBox en cas d'erreur
	if (SplashWnd)
		EndDialog(SplashWnd,0);
    MessageBox(hWnd, msg, "K!TV XP - ERREUR", MB_ICONSTOP | MB_OK);
	LOG(1, msg);
}
