/////////////////////////////////////////////////////////////////////////////
// IR_haup.c 
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "K!TV-XP.h"
#include "bt_io.h"
#include "IR_haup.h"
#include "plugin.h"
#include "misc.h"
#include "VBI_VideoText.h"

char* IR_Start[255];
static unsigned char last_b1;
static BOOL bRepeat_IR;
BOOL bIRACtive=FALSE;
int IRSampling=20;

void IR_Hauppauge_Stop()
{
	HWND wndIR;
	wndIR = FindWindow("IRRemote", 0);	
	if (wndIR)
	{
		SendMessage(wndIR, WM_CLOSE, 0, 0);//Kille l'application IR Hauppauge
	}
}


void IR_Hauppauge_Start()
{
	STARTUPINFO StartIR;
	PROCESS_INFORMATION ProcIR;

	ZeroMemory(&StartIR, sizeof(STARTUPINFO));
	StartIR.cb = sizeof(STARTUPINFO);
	CreateProcess(NULL,(LPTSTR)&IR_Start,(LPSECURITY_ATTRIBUTES)NULL,(LPSECURITY_ATTRIBUTES)NULL,FALSE,(DWORD)0,NULL,NULL,&StartIR,&ProcIR);
	CloseHandle(ProcIR.hThread);
	CloseHandle(ProcIR.hProcess);
}


static void IR_Hauppauge_Process_Key(int key_IR)
{
	switch (key_IR) 
	{
		case REMOTE_0:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'0',0);
			}
			return;

		case REMOTE_1:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'1',0);
			}
			return;

		case REMOTE_2:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'2',0);
			}
			return;

		case REMOTE_3:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'3',0);
			}
			return;

		case REMOTE_4:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'4',0);
			}
			return;

		case REMOTE_5:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'5',0);
			}
			return;

		case REMOTE_6:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'6',0);
			}
			return;

		case REMOTE_7:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'7',0);
			}
			return;

		case REMOTE_8:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'8',0);
			}
			return;

		case REMOTE_9:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CHAR,'9',0);
			}
			return;

		case REMOTE_RADIO:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				if(AutoProcessVideo)
					PostMessage(hWnd,WM_COMMAND,IDM_PLUGIN_VIDEO_FORCE,0);

				else
				{
					if(IsPluginVideoRunning)	PostMessage(hWnd,WM_COMMAND,IDM_PLUGIN_VIDEO_OFF,0);
					else	PostMessage(hWnd,WM_COMMAND,IDM_PLUGIN_VIDEO_ON,0);
				}
			}
			return;

		case REMOTE_MUTE:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_MUTE,0);
			}
			return;

		case REMOTE_TV:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_CLOSE,0,0);
			}
			return;

		case REMOTE_VOL_PLUS:
			SetForegroundApp(FALSE);
			if ( VTState==VT_OFF )	PostMessage(hWnd,WM_COMMAND,IDM_VOLUMEPLUS,0);
			else if(!bRepeat_IR)	PostMessage(hWnd,WM_COMMAND,IDM_VT_PAGE_UP,0);
			return;

		case REMOTE_VOL_MINUS:
			SetForegroundApp(FALSE);
			if ( VTState==VT_OFF )	PostMessage(hWnd,WM_COMMAND,IDM_VOLUMEMINUS,0);
			else if(!bRepeat_IR)	PostMessage(hWnd,WM_COMMAND,IDM_VT_PAGE_DOWN,0);
			return;

		case REMOTE_RESERVED:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_SOUSTITRES,0);
			}
			return;

		case REMOTE_CHAN_PLUS:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_CHANNELPLUS,0);
			}
			return;

		case REMOTE_CHAN_MINUS:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_CHANNELMINUS,0);
			}
			return;

		case REMOTE_SOURCE:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
			if ( VTState==VT_OFF )	PostMessage(hWnd,WM_COMMAND,IDM_NXTV_INFO,0);
			else	PostMessage(hWnd,WM_COMMAND,IDM_HOME,0);
			}
			return;

		case REMOTE_MINIMIZE:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_VIDEOTEXT,0);
			}
			return;

		case REMOTE_FULL_SCREEN:
			if(!bRepeat_IR)
			{
				SetForegroundApp(FALSE);
				PostMessage(hWnd,WM_COMMAND,IDM_FULLSCREEN,0);  
			}
			return;
		
		default:
			return;  
	}
}
  

void IR_Hauppauge_Read_Key(BOOL bReset) 
{
	unsigned char b1, b2, b3;
//	int repeat_bit;
	int ir_read;

	for(ir_read=0x31;ir_read<0x36;ir_read+=0x04)
	{
		I2CBus_Lock();
		// Starting bus 
		I2CBus_Start();
		// Resetting bus
		I2CBus_SendByte(ir_read, 0);

		// Read first byte: Toggle byte (192 or 224)
		b1 = I2CBus_ReadByte(0);
		// Read 2. byte: Key pressed by user
		b2 = I2CBus_ReadByte(0);
		// Read 3. byte: Firmware version
		b3 = I2CBus_ReadByte(0);
		// Stopping bus
		I2CBus_Stop();
	
		// Turn off the red light: Read 5 bytes from the bus
		I2CBus_Read(ir_read);
		I2CBus_Read(ir_read);
		I2CBus_Read(ir_read);
		I2CBus_Read(ir_read);
	
		I2CBus_Unlock();
	
		if (b1 == REPEAT_TOGGLE_0 || b1 == REPEAT_TOGGLE_1)
		{
			if (b1 == last_b1)
		{	
				bRepeat_IR = TRUE;
			}
			else
			{
				last_b1 = b1;
				bRepeat_IR = FALSE;
			}
		}
		else
		{
			b1 = b2 = 0xff;
		}
//		repeat_bit=(b1&0x20) ? 0x800:0;
		if(!bReset)	IR_Hauppauge_Process_Key(b2);
	}
}

void IR_Hauppauge_Reset()
{
	IR_Hauppauge_Read_Key(TRUE);
}