/////////////////////////////////////////////////////////////////////////////
// K!TV-XP.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <commctrl.h>
#include "resource.h"

#include "..\Plugins\ResCommun.h"
#include "externe/HtmlHelp.H"

#include "K!TV-XP.h"     
#include "bt848.h"
#include "audiocapture.h"
#include "thread.h"
#include "mixerdev.h"
#include "btaudio.h"
#include "vbi-vt.h"
#include "ddraw.h"
#include "procs.h"
#include "misc.h"
#include "osd.h"
#include "hardwaremisc.h"
#include "IR_haup.h"
#include "nextview.h"
#include "plugin.h"
#include "VBI_VideoText.h"
#include "settings.h"


// Test prsence du DDK W2K sinon dfinition de la variable
#ifndef ABOVE_NORMAL_PRIORITY_CLASS
	#define ABOVE_NORMAL_PRIORITY_CLASS 0x00008000
#endif

#ifndef WM_MOUSEWHEEL
	#define WM_MOUSEWHEEL	0x020A
#endif


char Text[255];
SYSTEMTIME SystemTime,LocalTime;
struct TShutdown Shutdown;
struct TLButton LButton;

int emsizex,  emsizey;
int emstartx, emstarty;

HWND hWnd;
HINSTANCE hInst;
HACCEL hAccel;

int CurrentProgram=1;
int LastProgram=1;

unsigned char InitialHue=0x00;
unsigned char InitialBrightness[3]={30,20,00};
int InitialContrast[3]={0xd8,0xcf,0xd8};
int InitialSaturationU[3]={0xFE,0xFE,0x80};
int InitialSaturationV[3]={0xB4,0xDB,0x80};
int InitialVolume=800;
BOOL Has_MSP=FALSE;

// Paramtres matriels
char ChannelString[10];
int CardType, TunerType, VideoSource, TVTYPE, AudioSource;
char *ChaineVideoSource[] = { "Tuner", "Composite", "S-Vido","Composite via S-Vido", "Externe 1" };
BOOL USETUNER=TRUE;
BOOL Capture_Video = TRUE, Capture_VBI=TRUE;

int MainProcessor=0, DisplayProcessor=0;
int PriorClassId;

// Paramtres de l'affichage
int CurrentFrame=1;
int CurrentX,CurrentY;
int Res_X,Res_Y;
int MovieBoost;
struct ZZoom Zoom={0,5,5};

BOOL OutDib=FALSE;
BOOL ModeOverlay=TRUE;
BOOL Overlay_NBB=FALSE;
BOOL VIA_FIX=FALSE;
BOOL FullField = TRUE;
int VIA_FIX_X=638;
int WindowStyle = 0;

int RES_MAX_X=768;
int RES_list[] = {768, 754, 720, 640, 512, 384, 320}; 
int RES_index = 0;

// Proprit de la fentre
BOOL bBorderless=FALSE;
BOOL bAutoMovieBoost=FALSE;
BOOL AutoMovieBoostEnable=FALSE;
BOOL bWindow43=TRUE;
BOOL bShowMenu=TRUE;
BOOL bMinimized=FALSE;
BOOL bMaximized=FALSE;
BOOL bAlwaysOnTop=FALSE;
BOOL bDisplayStatusBar=TRUE;
BOOL bIsFullScreen = FALSE;
BOOL bSplashBox=TRUE;
BOOL bDoResize = FALSE;			// autoriser le move/resize ? (si traitement en cours)

//code Souris
BOOL bAutoHideCursor = FALSE;
BOOL bShowCursor = TRUE;
BOOL bInMenuOrDialogBox = FALSE;
int mousewheel=0;
int MoveXDist=-1;
int MoveYDist=-1;

BOOL ChangeCH=TRUE;

int Fail_Start=0;
HCURSOR hCursorDefault = NULL;
HCURSOR hCursorHand = NULL;

LONG APIENTRY MainWndProc(HWND hWnd,UINT message,UINT wParam,LONG lParam);

/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop

****************************************************************************/

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS        wc;
    MSG             msg;
    HWND Load;
	hInst=hInstance;

	HANDLE KastorMutex=CreateMutex(NULL,FALSE,"The K!TV XP MUTEX");
	
	WaitForSingleObject(KastorMutex,INFINITE);

	Load=FindWindow((LPCTSTR)"K!TV XP",(LPCTSTR)"K!TV XP"); // On recherche si K!TV n'est pas lance...
	if ( Load != NULL )
	{
		SetFocus(Load);
		SetActiveWindow(Load);
		SetForegroundWindow(Load);
		return FALSE;
	}  
    SetDirectoryToExe();

	InitCommonControls(); // Initialisation des controls

	GetLocalTime(&LocalTime);// Obtention de l'heure locale
	GetSystemTime(&SystemTime);// Obtention de l'heure GMT

	//Initialisation des variables...
	
	Shutdown.H = 0xff;		Shutdown.M = 0xff;
	Shutdown.Process=FALSE;	Shutdown.Flag=EWX_POWEROFF;

	emsizex=520;			emsizey=452;
	emstartx=50;			emstarty=100;

	CardType=5;				TunerType=3;	
	VideoSource=0;			AudioSource=0;	

	TVTYPE=2;

	LButton.dbclk=FALSE;
	LButton.x=0;			LButton.y=0;

	strcpy((char *)IR_Start,"C:/Program Files/WinTV/ir.exe /QUIET");//Init localisation IR...

	Fail_Start+= !INI_Charger("K!TV-XP.ini"); // Chargement des parametres issus du fichier ini
	CommandLine(lpCmdLine);
	Langue_ChargerTousPlugins();
	LastProgram=CurrentProgram; // Canal/preselection precedent(e)

	if(bIRACtive && ParametreCarte[CardType].IR_Haup)	IR_Hauppauge_Stop(); // arrete l'application IR Hauppauge pour que K!TV prenne le relais

    // Charge le curseur par dfaut
    hCursorDefault = LoadCursor(NULL, IDC_ARROW);

	// Definition de la fenetre de K!TV XP
    wc.style = CS_DBLCLKS;
    wc.lpfnWndProc = (WNDPROC) MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(LONG);
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "K!TV-XP");
    wc.hCursor = hCursorDefault;
    wc.hbrBackground = CreateSolidBrush(0);  
    wc.lpszMenuName =  NULL;
    wc.lpszClassName = "K!TV XP";

	if (!RegisterClass (&wc))	return FALSE;

	hWnd = CreateWindow(wc.lpszClassName,"K!TV XP",WS_OVERLAPPEDWINDOW,emstartx,emstarty,emsizex,emsizey,NULL,NULL,hInstance,NULL);
	if (!hWnd)	return (FALSE);

	ReleaseMutex(KastorMutex);
	CloseHandle(KastorMutex);

	StatusBar_Create();
	OnCreateAppli();
	PostMessage(hWnd,INIT_HARDWARE,0,0);

	if (!(hAccel = LoadAccelerators (hInstance, "K!TV_ACCEL")))
    {
		RealErrorBox(Langue_GetString(ID_ERROR_NOACCEL));
	}

    while (GetMessage(&msg, NULL, 0, 0))
	{			
		if( !TranslateAccelerator(hWnd, hAccel, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (msg.wParam);
}

/****************************************************************************

    FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages

    MESSAGES:

        WM_COMMAND    - application menu (About dialog box)
        WM_CREATE     - create window and objects
        WM_PAINT      - update window, draw objects
        WM_DESTROY    - destroy window

    COMMENTS:

        Handles to the objects you will use are obtained when the WM_CREATE
        message is received, and deleted when the WM_DESTROY message is
        received.  The actual drawing is done whenever a WM_PAINT message is
        received.

****************************************************************************/
LONG APIENTRY MainWndProc(HWND hWnd,UINT message,UINT wParam,LONG lParam)
{
	int i,j;
	static RECT rectscreen;

	switch (message)
	{

		case WM_COMMAND:
			switch( LOWORD( wParam ))
			{
//CANAUX
				case IDM_LASTCHANNEL:
						ChangementCanal(LastProgram);
						break;

				case IDM_CHANNELPLUS:
						if ( VTState!=VT_OFF )
							SetVTPage(VT_GetNextPage(VTPage - 100) + 100, 0, false, false);
						else	Channel_Plus();
						break;

				case IDM_CHANNELMINUS:
						if ( VTState!=VT_OFF )
							SetVTPage(VT_GetPreviousPage(VTPage - 100) + 100, 0, false, false);
						else	Channel_Minus();
						break;

				case IDM_HOME: // Touche HOME; retour page 100 du teletexte (index) ou lancement bdd liste des canaux
						if ( VTState!=VT_OFF )
						{
				            if ( VTPage > 100 )
							{
								VTSubPage = 0;
								SetVTPage(100, 0, FALSE, FALSE);
							}
						}
						else 
							Langue_DialogBox(hInst,"CANAUX_LISTE",hWnd,(DLGPROC)ProgramListProc);
						UpdateMenuBar();
						break;

				case IDM_PLUGIN_VIDEO_OFF: // Arret du plugin video
						Plugin_Video_Stopper();
						break;

				case IDM_PLUGIN_VIDEO_ON: // Activation plugin video
						Plugin_Video_Demarrer();
						break;

				case IDM_PLUGIN_VIDEO_FORCE: // Forcer l'activation du plugin video
						if (AutoProcessVideo)
						{
							ForcePluginVideo = !ForcePluginVideo;
							if (ForcePluginVideo)
								Plugin_Video_Demarrer();
						}
						UpdateMenuBar();
						break;

				case IDM_FullFields: // Commutation Mode de capture du plugin video simple ou double trame
						if (IsPluginVideoRunning)
						{
							Stop_Capture(OutDib);
							PluginVideo->Stop();
							FullField=!FullField;
							StatusBar_And_OSD_Display(Langue_GetString(FullField ? ID_FULLFRAME : ID_HALFFRAME));
							if (!PluginVideo->Start()) IsPluginVideoRunning=FALSE;
							Affichage_Init_Screen_Struct();
							Start_Capture(OutDib);
							UpdateMenuBar();
						}				
						break;

				case IDM_PLUGIN_AUDIO: //Activation/arret plugin audio
						Plugin_Audio_StartStop();
						break;

				case IDM_PLUGIN_VIDEO_SETUP: // bdd reglages du plugin video
						if (!PluginVideoPresent)
							break;
						PluginVideo->FullField = FullField;
						PluginVideo->VIA_FIX = VIA_FIX;
						PluginVideo->VIA_FIX_X = VIA_FIX_X;
						PluginVideo->hwndParent = hWnd;

						PluginVideo->ShowDialog();
						
						// Mettre  jour certaines infos
						FullField=PluginVideo->FullField;
						VIA_FIX   = PluginVideo->VIA_FIX;
						VIA_FIX_X = PluginVideo->VIA_FIX_X;
						AutoProcessVideo = PluginVideo->AutoProcessVideo;
						
						if(AutoProcessVideo)	
							EnableMenuItem(GetMenu(hWnd),IDM_PLUGIN_VIDEO_FORCE,MF_ENABLED);
						else
						{
							ForcePluginVideo=FALSE;
							CheckMenuItem( GetMenu(hWnd), IDM_PLUGIN_VIDEO_FORCE, MF_UNCHECKED );
							EnableMenuItem(GetMenu(hWnd),IDM_PLUGIN_VIDEO_FORCE,MF_GRAYED);
						}
						break;

				case IDM_PLUGIN_AUDIO_SETUP: // bdd reglages du plugin audio
						if (!PluginAudioPresent) 
							break;	
						// Si le plugin n'est pas en cours d'utilisation, relire le fichier INI
						if (!IsPluginAudioRunning)
							PluginAudio->Init();
						PluginAudio->hwndParent = hWnd;
						PluginAudio->ShowDialog(); 
						AutoProcessAudio = PluginAudio->AutoProcessAudio;
                        break;

//AFFICHAGE
				case IDM_AUTOMB: // Bandes noires automatiques
						bAutoMovieBoost = !bAutoMovieBoost;
						if (bAutoMovieBoost)
							StatusBar_And_OSD_Display(Langue_GetString(ID_BLACKAUTO));
						UpdateMenuBar();
						break;

				case IDM_MOVIEBOOST_NUL:// Pas de bandes noires
				case IDM_MOVIEBOOST_169:// Bandes noires format 16:9
				case IDM_MOVIEBOOST_209:// Bandes noires format 20:9
				case IDM_MOVIEBOOST_MINUS:// Bandes noires-1
				case IDM_MOVIEBOOST_PLUS:// Bandes noires+1
						SetMovieBoost(LOWORD(wParam));
						break;

				case IDM_OVERSCAN_PLUS:
				case IDM_OVERSCAN_MINUS:
						SetZoomAvecPrecision(LOWORD(wParam));
						break;

				case IDM_ZOOM_RESET:
						Zoom.Actif=3;
				case IDM_ZOOM:
						SetZoom();
						break;

				case IDM_TOGGLE_BORDER: // Basculement avec ou sans bordure pour la fenetre en mode sans menus
						bBorderless=!bBorderless;
						UpdateMenuBar();
                        break;

				case IDM_TOGGLE_MENU: //Basculement avec ou sans menu dans la fenetre
						if (!bIsFullScreen && !bMaximized)
							Affichage_ToggleMenu();
						else if( bIsFullScreen || (!bIsFullScreen && bMaximized) )
							Affichage_ToggleFullScreen();
						break;

				case IDM_TOGGLE_DI: //Commutation entre les differents plugins de desentrelacement
						Stop_Capture(FALSE);
						Sleep(50);
						if(DeInterlace>=0 && DeInterlace<6)
							DeInterlace++;
						else
							DeInterlace=0;
						Plugin_DScaler_Decharger();
						Plugin_DScaler_Charger();
						if(DeInterlace==0) StatusBar_And_OSD_Display(Langue_GetString(ID_NODEINTER));
						else if(DeInterlace==1) StatusBar_And_OSD_Display(Langue_GetString(ID_DEINTERHW1));
						else if(DeInterlace==2) StatusBar_And_OSD_Display(Langue_GetString(ID_DEINTERHW2));
						else StatusBar_And_OSD_Display(DScalerMethod->szName);
						Start_Capture(FALSE);
						Affichage_Overlay_Workout(FALSE);
						break;

				case IDM_ECHAP: // Retour en mode fenetre si plein ecran
						if (bIsFullScreen) 
							Affichage_ToggleFullScreen();
						break;

				case IDM_FULLSCREEN: //Commutation mode plein ecran
						Affichage_ToggleFullScreen();
						break;

				case IDM_CAPTURE_PAUSE: //Activation/pause de la capture video
						if ( !CapturePaused )
							Stop_Capture(TRUE);
						else
							Start_Capture(TRUE);
						UpdateMenuBar();
						break;

				case IDM_OVERLAY: // Mode d'affichage Overlay
				case IDM_OVERLAY_NBB:
				case IDM_DIB: // Mode d'affichage DIB
						Affichage_Format(hWnd, LOWORD(wParam));
						break;

				case IDM_AFFICHAGE_STOP:
						Affichage_Stop(hWnd);
						break;
	
				case IDM_AFFICHAGE_START:
						Affichage_Start(hWnd);
						break;

				case IDM_PIXELWIDTH_768: // Selection de la resolution en X... Permet de resoudre des problemes avec d'anciennes cartes video...
				case IDM_PIXELWIDTH_754:
				case IDM_PIXELWIDTH_720:
				case IDM_PIXELWIDTH_640:
				case IDM_PIXELWIDTH_512:
				case IDM_PIXELWIDTH_384:
				case IDM_PIXELWIDTH_320:
						Stop_Capture(OutDib);
						RES_index = LOWORD(wParam) - IDM_PIXELWIDTH_768;
						RES_MAX_X = RES_list[RES_index];
                        Affichage_Init_Screen_Struct();
			            Start_Capture(OutDib);
						UpdateMenuBar();
						break;

	 			case IDM_FFORMAT43:// Format d'affichage 4:3
						bWindow43 = !bWindow43;
						if(bWindow43)
							OSD_ShowText_Center(hWnd, Langue_GetString(ID_MODE_43));
						UpdateMenuBar();
			 			break;
		 
				case IDM_STATUSBAR: // Commutation affichage de la barre de status
						if(bIsFullScreen)	break;	
						if(!bShowMenu)	Affichage_ToggleMenu();
						else	Affichage_ToggleStatusBar();
					    break;

				case IDM_ON_TOP: // Commutation toujours en avant plan
						Affichage_ToggleOnTop();
			            break;

				case IDM_OSD: // Commutation activation de l'OSD (Affichage sur l'ecran
						Enable_OSD=!Enable_OSD;
						break;

				case IDM_FENETRE: // Commutation modes d'affichages en mode fenetre 
				case IDM_FENETRE768x576: 
				case IDM_FENETRE512x384: 
				case IDM_FENETRE392x294: 
						bIsFullScreen = FALSE; 
						Affichage_ModeFenetre(hWnd, LOWORD(wParam));
						break;

				case IDM_640x480:// Commutation modes d'affichages en mode plein ecran avec changement de resolution
				case IDM_800x600:
				case IDM_1024x768:
				case IDM_OWN_RES:
						bIsFullScreen = FALSE; 
						Affichage_ModeDDrawExclusif(hWnd, LOWORD(wParam));
						break;

				case IDM_SETUP_OWN_RES : // ouverture bdd permettant de choisir la resolution personalisee
 			            Langue_DialogBox(hInst,"RESOLUTION_PERSO",hWnd,(DLGPROC)ResSettingProc);
						break;     	 

//AUDIO
  				case IDM_MUTE: // Commutation son muet/non muet
						if ( !System_In_Mute )
						{
							System_In_Mute = TRUE ;
							if(Has_MSP)// Coupure son
							{
								TVolume=InitialVolume;
								Audio_MSP_SetVolume(0);
							}
							else	BT8X8_SetAudioSource(4);
							if ( USE_MIXER )
							{			
								Mixer_Mute();
								StatusBar_Display(Langue_GetString(ID_MUTE));
							}	
							OSD_ShowText_TopMini(hWnd,Langue_GetString(ID_MUTE), 10, TRUE);
							if (IsPluginVideoRunning && AutoProcessAudio && IsPluginAudioRunning)
							{
								SendMessage(hWnd,WM_COMMAND,IDM_PLUGIN_AUDIO,0);
							}
						}
						else
						{
							System_In_Mute = FALSE ;
							if(Has_MSP)// restauration son aprs changement de canal
							{
								Audio_MSP_SetVolume(TVolume);
							}
							else	BT8X8_SetAudioSource(AudioSource);
							if ( USE_MIXER )
							{
								Mixer_UnMute();
								StatusBar_Display(Langue_GetString(ID_UNMUTE));
							}
							OSD_Clear(hWnd,2);

							if (IsPluginVideoRunning && AutoProcessAudio)
							{
								SendMessage(hWnd,WM_COMMAND,IDM_PLUGIN_AUDIO,0);
							}
						}
						break;

				case IDM_L_BALANCE: // Balance mixer/msp34xx vers la gauche
						if ( !USE_MIXER )
						{
							if(!Has_MSP) break;
							if ( InitialBalance > -127 ) InitialBalance--;
							Audio_MSP_SetBalance(InitialBalance); // -127 - +128
							StatusBar_And_OSD_Display(Langue_GetString(ID_MSPBALANCE),InitialBalance);
						}
						else
						{
							i=2184;//((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep; // Pas de 3%
							if ( MIXER_CANAL_GAUCHE+i <= MixerVolumeMax ) MIXER_CANAL_GAUCHE+=i;
							if ( MIXER_CANAL_DROIT-i >= 0 ) MIXER_CANAL_DROIT-=i;
							Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
							StatusBar_And_OSD_Display(Langue_GetString(ID_BAL_L),(int)(((float)(MIXER_CANAL_GAUCHE)/65535.0)*100),(int)(((float)(MIXER_CANAL_DROIT)/65535.0)*100));						}
						break;

				case IDM_R_BALANCE: // Balance mixer/msp34xx vers la droite
						if ( !USE_MIXER )
						{
							if(!Has_MSP) break;
							if ( InitialBalance < 128 ) InitialBalance++;
							Audio_MSP_SetBalance(InitialBalance); // -127 - +128
							StatusBar_And_OSD_Display(Langue_GetString(ID_MSPBALANCE),InitialBalance);
						}
						else
						{
							i=2184;//((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep; // Pas de 3%
							if ( MIXER_CANAL_GAUCHE-i >= 0 ) MIXER_CANAL_GAUCHE-=i;
							if ( MIXER_CANAL_DROIT+i <= MixerVolumeMax ) MIXER_CANAL_DROIT+=i;
							Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
							StatusBar_And_OSD_Display(Langue_GetString(ID_BAL_L),(int)(((float)(MIXER_CANAL_GAUCHE)/65535.0)*100),(int)(((float)(MIXER_CANAL_DROIT)/65535.0)*100));
						}
						break;

  				case IDM_VOLUMEPLUS: // Augmentation du volume sonore
						if ( !USE_MIXER )
						{
							if(!Has_MSP) break;
							if ( InitialVolume < 1000 ) InitialVolume+=20;
							Audio_MSP_SetVolume(InitialVolume);
							StatusBar_Display(Langue_GetString(ID_MSPVOLUME),InitialVolume);
						}
						else
						{
							i=2184;//((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep; // Pas de 3%
							if(IsPluginAudioRunning)
							{
								if ( i+VolumeOut > MixerVolumeMax )
									i=MixerVolumeStep;
								if ( VolumeOut+i <= MixerVolumeMax ) VolumeOut+=i;
								Mixer_Set_Volume(VolumeOut,VolumeOut,TRUE);
								sprintf(Text,Langue_GetString(ID_VOLUME),(int)(((float)(VolumeOut)/65535.0)*100));
							}
							else
							{
								if (( i+MIXER_CANAL_GAUCHE > MixerVolumeMax ) || ( i+MIXER_CANAL_DROIT > MixerVolumeMax ))
									i=MixerVolumeStep;
								if ( MIXER_CANAL_GAUCHE+i <= MixerVolumeMax ) MIXER_CANAL_GAUCHE+=i;
								if ( MIXER_CANAL_DROIT+i <= MixerVolumeMax ) MIXER_CANAL_DROIT+=i;
								Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
								sprintf(Text,Langue_GetString(ID_VOLUME),(int)(((float)(MIXER_CANAL_GAUCHE)/65535.0)*100));
							}
							OSD_ShowText_Center(hWnd,Text);
							strcat(Text," %%");
							StatusBar_Display(Text);
						}
						break;

  				case IDM_VOLUMEMINUS: // Diminution du volume sonore
						if ( !USE_MIXER )
						{
							if(!Has_MSP) break;
							if ( InitialVolume > 0 ) InitialVolume-=20;
							Audio_MSP_SetVolume(InitialVolume);
							StatusBar_Display(Langue_GetString(ID_MSPVOLUME),InitialVolume);
						}
						else
						{
							i=2184;//((MixerVolumeMax/MixerVolumeStep)/100)*MixerVolumeStep; // Pas de 3%
							if(IsPluginAudioRunning)
							{
								if (( VolumeOut-i < 0) || ( VolumeOut-i < 0))
									i=MixerVolumeStep;
								if ( VolumeOut-i >= 0 ) VolumeOut-=i;
								Mixer_Set_Volume(VolumeOut,VolumeOut,TRUE);
								sprintf(Text,Langue_GetString(ID_VOLUME),(int)(((float)(VolumeOut)/65535.0)*100));
							}
							else
							{
								if (( MIXER_CANAL_GAUCHE-i < 0) || ( MIXER_CANAL_DROIT-i < 0)) i=MixerVolumeStep;
								if ( MIXER_CANAL_GAUCHE-i >= 0 ) MIXER_CANAL_GAUCHE-=i;
								if ( MIXER_CANAL_DROIT-i >= 0 ) MIXER_CANAL_DROIT-=i;
								Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
								sprintf(Text,Langue_GetString(ID_VOLUME),(int)(((float)(MIXER_CANAL_GAUCHE)/65535.0)*100));
							}
							OSD_ShowText_Center(hWnd,Text);
							strcat(Text," %%");
							StatusBar_Display(Text);
						}	 
						break;						

				case IDM_MSPMODE_0:// Commutation differents modes MSP34xx
				case IDM_MSPMODE_1:
				case IDM_MSPMODE_2:
				case IDM_MSPMODE_3:
				case IDM_MSPMODE_4:
				case IDM_MSPMODE_5:
				case IDM_MSPMODE_6:
				case IDM_MSPMODE_7:
		 				Audio_MSP_SetMode( wParam-IDM_MSPMODE_0);
						break;
		 
				case IDM_MAJOR_CARRIER_0:// Commutation differentes porteuses principales du MSP34xx
				case IDM_MAJOR_CARRIER_1:
				case IDM_MAJOR_CARRIER_2:
				case IDM_MAJOR_CARRIER_3:
						Audio_MSP_Set_MajorMinor_Mode(wParam-IDM_MAJOR_CARRIER_0,MSPMinorMode);
						break;
		 
				case IDM_MINOR_CARRIER_0:// Commutation differentes porteuses secondaires du MSP34xx
				case IDM_MINOR_CARRIER_1:
				case IDM_MINOR_CARRIER_2:
				case IDM_MINOR_CARRIER_3:
				case IDM_MINOR_CARRIER_4:
				case IDM_MINOR_CARRIER_5:
				case IDM_MINOR_CARRIER_6:
				case IDM_MINOR_CARRIER_7:
						Audio_MSP_Set_MajorMinor_Mode(MSPMajorMode,wParam-IDM_MINOR_CARRIER_0  );
						break;

				case IDM_MSPSTEREO_1:// Commutation formats (stereo, mono, lang1, lang2) du MSP34xx
				case IDM_MSPSTEREO_2:
				case IDM_MSPSTEREO_3:
				case IDM_MSPSTEREO_4:
						Audio_MSP_SetStereo(MSPMajorMode, MSPMinorMode, wParam - (IDM_MSPSTEREO_1-1) );
						break;

				case IDM_AUTOSTEREO: // Commutation auto des differents formats ci dessus du MSP34xx
						AutoStereoSelect=!AutoStereoSelect;
						break;

				case IDM_AUDIO_0: // Commutation sources audio du bt8x8
				case IDM_AUDIO_1:
				case IDM_AUDIO_2:
				case IDM_AUDIO_3:
				case IDM_AUDIO_4:
				case IDM_AUDIO_5:
						AudioSource=wParam-IDM_AUDIO_0;
						Stop_Capture(FALSE);
						BT8X8_SetAudioSource(AudioSource);
						Start_Capture(FALSE);
						break;

				case IDM_AUDIOSETTINGS_MSP:	//Reglages audio MSP34xx		             
						Langue_DialogBox(hInst,"AUDIO_REGLAGES",hWnd,AudioSettingProc_MSP);
                        break;

				case IDM_AUDIOSETTINGS_MSP_EQ: //Reglages egaliseur sonore du MSP34xx
						Langue_DialogBox(hInst,"AUDIO_REGLAGES_EGALISEUR",hWnd,AudioSettingProc_MSP_EQ);
                        break;

				case IDM_AUDIO_MIXER: // ouverture bdd Reglages du mixer
						Langue_DialogBox(hInst,"MIXER_REGLAGES",hWnd,MixerSettingProc);
                        break;

//VIDEO

				case IDM_BRIGHTNESSPLUS: // Augmenter la luminosite
 						if ( InitialBrightness[TVSettings[TVTYPE].format] < 128 ) i=InitialBrightness[TVSettings[TVTYPE].format];
              			else i=-(256-InitialBrightness[TVSettings[TVTYPE].format]);
		                if (( i >= -128 ) && ( i < 127 )) i++;
						if ( i < 0 ) InitialBrightness[TVSettings[TVTYPE].format]=256+i;
					    else InitialBrightness[TVSettings[TVTYPE].format]=i;
						BT8X8_SetBrightness(InitialBrightness[TVSettings[TVTYPE].format]);
						StatusBar_And_OSD_Display(Langue_GetString(ID_BRIGHTNESS),i);
						break;

				case IDM_BRIGHTNESSMINUS: // Diminuer la luminosite
 						if ( InitialBrightness[TVSettings[TVTYPE].format] < 128 ) i=InitialBrightness[TVSettings[TVTYPE].format];
              			else i=-(256-InitialBrightness[TVSettings[TVTYPE].format]);
						if (( i > -128 ) && ( i <= 127 )) i--;
						if ( i < 0 ) InitialBrightness[TVSettings[TVTYPE].format]=256+i;
						else InitialBrightness[TVSettings[TVTYPE].format]=i;
						BT8X8_SetBrightness(InitialBrightness[TVSettings[TVTYPE].format]);
						StatusBar_And_OSD_Display(Langue_GetString(ID_BRIGHTNESS),i);
		                break;

				case IDM_COLORPLUS: // Augmenter la saturation (couleur)
						if (( InitialSaturationU[TVSettings[TVTYPE].format] < 511 ) && (InitialSaturationV[TVSettings[TVTYPE].format] < 511 ))
						{
							InitialSaturationU[TVSettings[TVTYPE].format]++;
							InitialSaturationV[TVSettings[TVTYPE].format]++;
							StatusBar_And_OSD_Display(Langue_GetString(ID_COLOR),InitialSaturationU[TVSettings[TVTYPE].format],InitialSaturationV[TVSettings[TVTYPE].format]);
							BT8X8_SetSaturationU(InitialSaturationU[TVSettings[TVTYPE].format]);
							BT8X8_SetSaturationV(InitialSaturationV[TVSettings[TVTYPE].format]);
						}
						break;
         
				case IDM_COLORMINUS: // diminuerer la saturation (couleur)
						if (( InitialSaturationU[TVSettings[TVTYPE].format] > 0 ) && (InitialSaturationV[TVSettings[TVTYPE].format] > 0 ))
						{
							InitialSaturationU[TVSettings[TVTYPE].format]--;
							InitialSaturationV[TVSettings[TVTYPE].format]--;
							StatusBar_And_OSD_Display(Langue_GetString(ID_COLOR),InitialSaturationU[TVSettings[TVTYPE].format],InitialSaturationV[TVSettings[TVTYPE].format]);
							BT8X8_SetSaturationU(InitialSaturationU[TVSettings[TVTYPE].format]);
							BT8X8_SetSaturationV(InitialSaturationV[TVSettings[TVTYPE].format]);
						}
						break;

				case IDM_CONTRASTPLUS: // Augmenter le contraste
						if ( InitialContrast[TVSettings[TVTYPE].format] < 511 ) InitialContrast[TVSettings[TVTYPE].format]++;
 		     			BT8X8_SetContrast(InitialContrast[TVSettings[TVTYPE].format]); 
 						StatusBar_And_OSD_Display(Langue_GetString(ID_CONTRAST),InitialContrast[TVSettings[TVTYPE].format]);
						break;
         
				case IDM_CONTRASTMINUS: // Diminuer le contraste
       					if ( InitialContrast[TVSettings[TVTYPE].format] > 0 ) InitialContrast[TVSettings[TVTYPE].format]--;
 		     			BT8X8_SetContrast(InitialContrast[TVSettings[TVTYPE].format]);    
 						StatusBar_And_OSD_Display(Langue_GetString(ID_CONTRAST),InitialContrast[TVSettings[TVTYPE].format]);
						break;

				case IDM_VIDEOSETTINGS: // Affichage bdd reglages video
						Langue_DialogBox(hInst,"VIDEO_REGLAGES",hWnd,VideoSettingProc);
						break;
//HARDWARE

				case IDM_COMPOSITE:  // Selection source video du bt8x8
				case IDM_SVIDEO: 
				case IDM_COMPVIASVIDEO: 
				case IDM_EXTERN1:
						VideoSource = wParam - (IDM_COMPOSITE - 1);
						Stop_Capture(FALSE);
						BT8X8_SetVideoSource(VideoSource);
						StatusBar_Display_KeyField(ChaineVideoSource[VideoSource]);
						Start_Capture(FALSE);
						break;

				case IDM_VIDEO: //Capture ou non du signal video du bt8x8
						Capture_Video = !Capture_Video;
						Stop_Capture(TRUE);
						Start_Capture(TRUE);
						UpdateMenuBar();
						break;
		 
				case IDM_TUNER_0: //Commutation differents types de tuners du bt8x8
				case IDM_TUNER_1: 
				case IDM_TUNER_2: 
				case IDM_TUNER_3: 
				case IDM_TUNER_4:
				case IDM_TUNER_5: 
				case IDM_TUNER_6:
				case IDM_TUNER_7:
				case IDM_TUNER_8:
						VideoSource=0;
						TunerType = wParam - IDM_TUNER_0;
						Stop_Capture(FALSE);
						if (TunerType != 4 )	// Pas de Tuner (=> Composite, SVido ..)
							Tuner_Init(TunerType);
						BT8X8_SetVideoSource(VideoSource);
						StatusBar_Display_KeyField("%d. %s ",CurrentProgram,Program[CurrentProgram].Name);
						Start_Capture(FALSE);
						break;

				case IDM_MANUELL_TUNER: // tuner manuel; bdd de reglage de celui-ci
			            Langue_DialogBox(hInst,"TUNER_REGLAGES_MANUELS",hWnd,(DLGPROC)TunerSettingProc);
						break;

				case IDM_TYPEFORMAT_PAL: // Formats video du bt8x8
				case IDM_TYPEFORMAT_NTSC:
				case IDM_TYPEFORMAT_SECAM:
				case IDM_TYPEFORMAT_PAL_M:
				case IDM_TYPEFORMAT_PAL_N:
				case IDM_TYPEFORMAT_NTSC_JAPAN:
				case IDM_TYPEFORMAT_PAL60:
						TVTYPE=wParam-IDM_TYPEFORMAT_PAL;
						Stop_Capture(FALSE);
						Affichage_Init_Screen_Struct();
   						Start_Capture(FALSE);
						BT8X8_SetBrightness(InitialBrightness[TVSettings[TVTYPE].format]);
						BT8X8_SetContrast(InitialContrast[TVSettings[TVTYPE].format]);
						BT8X8_SetHue(InitialHue);
						BT8X8_SetSaturationU(InitialSaturationU[TVSettings[TVTYPE].format]);
						BT8X8_SetSaturationV(InitialSaturationV[TVSettings[TVTYPE].format]);
						UpdateMenuBar();
						break; 

				case IDM_BT8X8SETUP: // Affichage bdd reglages generaux de K!TV
			            Langue_DialogBox(hInst,"REGLAGES_GENERAUX",hWnd,(DLGPROC)Reglages_GeneralSetupProc);
						break;

				case IDM_MANUELL_CARD: // Carte personalisee; bdd de reglage de celle-ci
 			            Langue_DialogBox(hInst,"CARTE_PERSO",hWnd,(DLGPROC)CardSettingProc);
						break;

				case IDM_SHUTDOWN_OPTION: // Reglages des types d'arret de K!TV
						Langue_DialogBox(hInst,"EXTINCTION_TYPE",hWnd,ShutdownOptionProc);
						break;

				case IDM_SHUTDOWN_TIME: // Reglage heure d'arret de K!TV
						Langue_DialogBox(hInst,"EXTINCTION_HEURE",hWnd,ShutdownSetProc);
						break;

				case IDM_RESET: // reinitialisation du bt8x8   
						Reset_Capture();
			 			break;
						
				case IDM_HWINFO : //Affichage bdd infos sur le materiel
			            Langue_DialogBox(hInst,"HARDWARE_INFOS",hWnd,(DLGPROC)ChipSettingProc);
						break;
         
// Teletexte
				case IDM_VBI: // Commutation capture des donnees VBI
						Capture_VBI = !Capture_VBI;
						Stop_Capture(TRUE);	
						Start_Capture(TRUE);
						UpdateMenuBar();
					    break;

				case IDM_SOUSTITRES_ALT: // Commutation entre les differents sous-titres teletexte
						if(Sous_Titres.bActif)
						{
							if(Sous_Titres.STCount<2 || Sous_Titres.bTeleTexte) break;
							else
							{
								if(Sous_Titres.PageActive<Sous_Titres.STCount-1)
									Sous_Titres.PageActive++;
								else Sous_Titres.PageActive=0;
							}
						}
						break;


				case IDM_SOUSTITRES: // Commutation sous-titrage teletexte
						Toggle_SousTitres();
						break;

				case IDM_VIDEOTEXT: // Commutation affichage teletexte/TV
						switch(VTState)
						{
							case VT_OFF:
								Sous_Titres.bTeleTexte=TRUE;
								VTPage = 100;
								VTSubPage = 0;
								VTState = VT_BLACK;
								SetVTPage(VTPage, VTSubPage, TRUE, FALSE);
								if(!Sous_Titres.bActif)	SetTimer(hWnd, TIMER_VTUPDATE, TIMER_VTUPDATE_MS, NULL);
								InvalidateRect(hWnd,NULL,FALSE);
								break;
							case VT_BLACK:
								VTState = VT_MIX;
								break;
							case VT_MIX:
							default:
								VTState = VT_OFF;
								Sous_Titres.bTeleTexte=FALSE;
								Cursor_VTUpdate(FALSE, 0, 0);
								if(!Sous_Titres.bActif || (Sous_Titres.bActif && !Sous_Titres.bRun))
								{
									KillTimer(hWnd,TIMER_VTUPDATE);
									InvalidateRect(hWnd,NULL,FALSE);
								}
								Sous_Titres.bRun=FALSE;
								break;
						}
						Affichage_Overlay_Workout(FALSE);
						UpdateMenuBar();
						break;
            
				case IDM_VT_RESET: // Reinitialisation du teletexte
			            VT_Reset();
						InvalidateRect(hWnd, NULL, FALSE);
                        break;

				case IDM_TELETEXT_KEY1:
				case IDM_TELETEXT_KEY2:
				case IDM_TELETEXT_KEY3:
				case IDM_TELETEXT_KEY4:
				case IDM_TELETEXT_KEY5:
						if(VTState != VT_OFF && VTPage >= 100)
						{ 
							//TODO: VT_GetFlofPageNumber do not return SubPage...
							i = VT_GetFlofPageNumber(VTPage-100, VTSubPage, LOWORD(wParam) - IDM_TELETEXT_KEY1);
							if(i >= 100 && i <= 899) 
							{
								SetVTPage(i, 0, FALSE, TRUE);
							}
						}
						break;

				case IDM_TELETEXT_KEY6:
						if (VTState != VT_OFF)
							SetVTShowHidden(!VTShowHidden);
						break;
				
				case IDM_VT_PAGE_MINUS: // Page precedente du teletexte
						if ( VTState!=VT_OFF && VTPage > 100)
							SetVTPage(VTPage-1, 0, FALSE, FALSE);
						break;
                     
				case IDM_VT_PAGE_PLUS: // Page suivante du teletexte
						if ( VTState!=VT_OFF && VTPage >= 100)
							SetVTPage(VTPage+1, 0, FALSE, FALSE);
						break;

				case IDM_VT_PAGE_DOWN: //Sous-page precedente du teletexte
						if ( VTState!=VT_OFF )
			                SetVTPage(VTPage, VT_SubPageNext(VTPage - 100, VTSubPage, -1, TRUE), TRUE, TRUE);
						break;

				case IDM_VT_PAGE_UP: //Sous-page suivante du teletexte
						if ( VTState!=VT_OFF )
			                SetVTPage(VTPage, VT_SubPageNext(VTPage - 100, VTSubPage, +1, TRUE), TRUE, TRUE);
						break;

				case IDM_VT_SEARCH:
						if(VTState != VT_OFF)
						{
							//Get searchstring dialog, search only if user pressed OK button/enter key
							if (Langue_DialogBox(hInst, "TELETEXTE_RECHERCHE", hWnd, VTSearchProc))
							{
								//Search all pages and act
								SearchGotoVTPage(true);
							}
						}
						break;

				case IDM_VT_SEARCHNEXT:
						if(VTState != VT_OFF)
							SearchGotoVTPage(false);
						break;
						
				case IDM_VT_INFO: // Affichage bdd informations sur le teletexte, pdc, sous titrage, vps...
						Langue_DialogBox(hInst,"TELETEXTE_INFOS",hWnd,VTInfoProc);
						break;

				case IDM_NXTV_INFO:
						NexTView_ChannelChange();
						break;

				case IDM_NXTV:
						if(!PluginNextViewPresent) break;
						bNXTVactive= !bNXTVactive;
						if(bNXTVactive)	NexTView_Demarrer(FALSE);
						else NexTView_Fermer();
						UpdateMenuBar();
						break;

				case IDM_NXTV_PATH:
						NexTView_Chemin();
						break;

//DIVERS
				case IDM_UPDATEMENU: // Mise a jour des menus
						ModifyAppMenu();
						break;

				case IDM_AUTOHIDE_CURSOR: // Commutation du curseur intuitif
						bAutoHideCursor = !bAutoHideCursor;
						Cursor_UpdateVisibility();
						UpdateMenuBar();
						break;

		        case IDM_TOGGLECURSOR: // Commutation affichage du curseur
						if(!bAutoHideCursor && !bIsFullScreen)
						{
							bShowCursor = !bShowCursor;
							Cursor_UpdateVisibility();
						}
						break;
				
				case IDM_DISPLAYINFO:
						OSD_GeneralInfo();
						break;

				case IDM_HELP: //Affichage de l'aide en ligne de K!TV
			            HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/k!tv.htm", HH_DISPLAY_TOPIC, 0);
						break;

				case IDM_ABOUT: // Affichage bdd a propos
						DialogBox(hInst,"ABOUT",hWnd,AboutProc);
						break;

				case IDM_END: // Quitter K!TV
						PostMessage(hWnd,WM_CLOSE,wParam,lParam);
						break;

				case IDM_END_WIN: // Quitter K!TV avec options d'arret du systeme
						RestoreBeforeClosing();
						sprintf(Shutdown.Text, Langue_GetString(ID_SHTDWN) );
						Langue_DialogBox(hInst,"EXTINCTION",NULL,Stop_SystemProc);
						break;

				case IDM_TREADPRIOR_0: // Commutation reglage priorite threads affichage et traitement de K!TV
				case IDM_TREADPRIOR_1:
				case IDM_TREADPRIOR_2:
				case IDM_TREADPRIOR_3:
				case IDM_TREADPRIOR_4:
			            ThreadClassId = wParam - IDM_TREADPRIOR_0;
						Stop_Capture(TRUE);
                        Sleep(100);
						Start_Capture(TRUE);
						UpdateMenuBar();
						break;

				case IDM_PRIORCLASS_0: // Commutation reglage priorite de K!TV
				case IDM_PRIORCLASS_1:
				case IDM_PRIORCLASS_2:
				case IDM_PRIORCLASS_3:
						{
							int TabPriorite[] =
							{
								NORMAL_PRIORITY_CLASS,	ABOVE_NORMAL_PRIORITY_CLASS,
								HIGH_PRIORITY_CLASS,	REALTIME_PRIORITY_CLASS
							};
							PriorClassId = wParam - IDM_PRIORCLASS_0;
							SetPriorityClass(GetCurrentProcess(), TabPriorite[PriorClassId]);
							UpdateMenuBar();
						}
						break;

				case IDM_NEXTVIEW_EVENT :
						NexTView_HandleEpgEvent();
						break;

				default :
					{
						// Si le message n'est pas trait par l'appli nous le transmettons aux plugins
						// D'abord le plugin vido puis le plugin audio.
						if ( PluginVideoPresent && PluginVideo->ProcessMessage(message, wParam, lParam, Text) )
							StatusBar_And_OSD_Display (Text);
						else
						if (PluginAudioPresent && PluginAudio->ProcessMessage(message, wParam, lParam, Text) )
							StatusBar_And_OSD_Display (Text);
					}
					break;

				break;
            }
			break ;

///////////

		case WM_CREATE: // Creation de la fenetre...
			//PostMessage(hWnd,INIT_HARDWARE,0,0);
			break;

		case INIT_HARDWARE: // Initialisation du hardware
			OnInitHardware();
			break;

		case WM_LBUTTONDBLCLK: // Passage plein ecran
			LButton.dbclk=TRUE;
			break;

		case WM_LBUTTONUP: // Bouton gauche relache...Comme il est multifonction, timer pour determiner son comportement
			LButton.x=LOWORD(lParam);
			LButton.y=HIWORD(lParam);
			SetTimer(hWnd,TIMER_LBUTTONUP,250,NULL);
			break;

		case WM_MOUSEWHEEL: // roulette de la souris: changement de chaine ou changement sous-page dans le teletexte
			GetWindowRect(hWnd,&rectscreen);// On verifie que la souris est bien dans la fenetre de K!TV XP et pas ailleurs...
			if( ( ((short)LOWORD(lParam))>=rectscreen.left ) && ( ((short)LOWORD(lParam))<=rectscreen.right)
			 && ( ((short)HIWORD(lParam))>=rectscreen.top ) && ( ((short)HIWORD(lParam))<=rectscreen.bottom) )
			{
				if ((short)HIWORD(wParam)>0)
				{
					mousewheel=-1;
				}
				else
				{
					mousewheel=1;
				}
				SetTimer(hWnd,TIMER_MOUSEWHEEL,150,NULL);	
			}
			break;
			
		case WM_MOUSEMOVE:
			if (VTState!=VT_OFF) // Commutation differents affichages du curseur pour le teletexte
				Cursor_VTUpdate(TRUE, LOWORD(lParam), HIWORD(lParam));

			if (( wParam == MK_LBUTTON ) && (!bIsFullScreen)) //Deplacement de la fenetre
			{
				if (( MoveXDist==-1 ) && ( MoveYDist==-1))
				{ 
					GetWindowRect(hWnd,&rectscreen);
					MoveXDist = LOWORD(lParam); 
					MoveYDist = HIWORD(lParam);
					emsizex=rectscreen.right-rectscreen.left;
					emsizey=rectscreen.bottom-rectscreen.top;
				}
				else
				{
					GetWindowRect(hWnd,&rectscreen);
					i=(MoveXDist-LOWORD(lParam));
					j=(MoveYDist-HIWORD(lParam));

					// On veille a ne pas sortir de l'ecran lors des deplacements de fenetre...
					if(rectscreen.left-i<0) // On ne sort plus par le cote gauche de l'ecran...
						i=rectscreen.left;

					if(rectscreen.right-i>GetSystemMetrics(SM_CXSCREEN))// On ne sort plus par le cote droit de l'ecran...
						i=rectscreen.right-GetSystemMetrics(SM_CXSCREEN);

					if(rectscreen.top-j<0) // On ne sort plus par le haut de l'ecran...
						j=rectscreen.top;

					if(rectscreen.bottom-j>GetSystemMetrics(SM_CYSCREEN)) // On ne sort plus par le bas de l'ecran...
						j=rectscreen.bottom-GetSystemMetrics(SM_CYSCREEN);

					SetWindowPos(hWnd,NULL,rectscreen.left-i,rectscreen.top-j,0,0,SWP_NOSIZE | SWP_NOZORDER );
				}
			}
			break;

			
		case WM_MBUTTONUP: // Bouton du milieu de la souris;  
			if(VTState!=VT_OFF)	SendMessage(hWnd,WM_COMMAND,IDM_HOME,0); // Si teletexte retour index (page 100)
			else SendMessage(hWnd,WM_COMMAND,IDM_TOGGLECURSOR,0); // Sinon commutation affichage du curseur
            break;

		case WM_CONTEXTMENU:// Affichage du menu contextuel (bouton droit de la souris)
			ModifyAppContextMenu(lParam);
			break;

		case WM_POWERBROADCAST: // Gestion du mode veille
			// Handing to keep K!TV running during computer suspend/resume
			switch ((DWORD) wParam)
			{
			case PBT_APMSUSPEND:
	            // Stops video overlay upon suspend operation.
				Affichage_Stop(hWnd);
				break;
			case PBT_APMRESUMESUSPEND:
	            // Restarts video overlay upon resume operation.
				// The following crashes unless we do either a HWND_BROADCAST
				// or a Sleep() operation.  To be on the safe side, I do both
				// here.  Perhaps the video overlay drivers needed to reinitialize.
				SendMessage(HWND_BROADCAST, WM_PAINT, 0, 0);
				Sleep(500);
	            Affichage_Start(hWnd);
				break;
			}
			break;


		case WM_NCHITTEST: // Gestion visibilite de la Souris si ni dans menu ni dans bdd 
			if (!bInMenuOrDialogBox)
				Cursor_UpdateVisibility();
	        break;

		case WM_ENTERMENULOOP: // Gestion visibilite de la Souris : menu ouvert => curseur active
		    bInMenuOrDialogBox = TRUE;
	        Cursor_UpdateVisibility();
			break;

		case WM_EXITMENULOOP: // Gestion visibilite de la Souris : menu ferme => curseur desactive
		    bInMenuOrDialogBox = FALSE;
	        Cursor_UpdateVisibility();
			break;

		case WM_KILLFOCUS: // Gestion visibilite de la Souris : bdd presente => curseur active
			bInMenuOrDialogBox = TRUE;
			Cursor_UpdateVisibility();
			break;

	    case WM_SETFOCUS: // Gestion visibilite de la Souris : Plus de bdd => curseur desactive
			bInMenuOrDialogBox = FALSE;
			Cursor_UpdateVisibility();
			break;


		case WM_TIMER: // Gestions des timers de K!TV
			OnTimer(LOWORD(wParam));
			return (TRUE);

		case WM_SYSCOMMAND:
			switch(wParam&0xFFF0)
			{
				case SC_SCREENSAVE: // Empeche le systeme d'activer l'ecran de veille
				case SC_MONITORPOWER: // Empeche le systeme de paser l'ecran en mode veille
				return 0;
			}
			break;

		case WM_MOVING: // Fenetre de K!TV en cours de deplacement, on controle ce qui est fait...
			Affichage_Geo_Fenetre(wParam, (RECT *)lParam, TRUE);
			break;

		case WM_SIZING: // Fenetre de K!TV en cours de dimensionnement, on controle ce qui est fait...
			Affichage_Geo_Fenetre(wParam, (RECT *)lParam, FALSE);
			break;

        case WM_SIZE: // Fenetre de K!TV redimensionnee : on initialise l'affichage
			StatusBar_Adjust();
			switch(wParam)
			{
            case SIZE_MAXIMIZED: // Gestion de l'agrandissement de la fenetre
				bMaximized=TRUE;
                break;
            case SIZE_MINIMIZED: // Gestion de la mise en icone de la fenetre
                Affichage_Overlay_Update(0,0,NULL, DDOVER_HIDE,FALSE);
				Stop_Capture(TRUE);
				bMinimized=TRUE;
                break;
            case SIZE_RESTORED:
				if(bMinimized)
				{
					bMinimized=FALSE;
					Start_Capture(TRUE);
				}
				if(bMaximized) bMaximized=FALSE;
                break;
            default:
                break;
			}
			if ( OutDib && !CapturePaused)
			{
				Stop_Capture(TRUE);
	            Affichage_Init_Screen_Struct();
				Start_Capture(TRUE);
				break;
			}

		case WM_MOVE: // Fenetre de K!TV deplacee : on initialise l'affichage
			if (!bDoResize) break;
			if ( OutDib ) break;
			Affichage_Overlay_Workout(FALSE);
			break;

		case WM_KEYUP: // Si touche systeme enfoncee on ne fait rien
			return(FALSE);

		case WM_CHAR: // Gestion du pave numerique pour changement de chaine/page du teletexte
			if ( ((char) wParam  >= '0' ) && ((char) wParam  <= '9' ))
			{
				sprintf(Text,"%c",wParam);
				strcat(ChannelString, Text);

				if (VTState!=VT_OFF)	sprintf(Text,"Page:%s",ChannelString);
				else strcpy(Text,ChannelString);
					
				OSD_ShowText_Top(hWnd,Text);
				if (strlen(ChannelString) > 2)
				{
					SetTimer(hWnd,TIMER_CHAR,1,NULL);
				}
				else
				{
					if(VTState!=VT_OFF)	SetTimer(hWnd,TIMER_CHAR,1500,NULL);
					else SetTimer(hWnd,TIMER_CHAR,500,NULL);
				}
			}
			break;

		case WM_PAINT: // Gestion Affichage de l'OSD et du teletexte
			PAINTSTRUCT sPaint;
			BeginPaint(hWnd, &sPaint);
			if (VTState != VT_OFF || (Sous_Titres.bRun))
			{
				Affichage_Overlay_PaintColorkey(hWnd, TRUE, sPaint.hdc, &sPaint.rcPaint, true);
				VT_Redraw(hWnd, sPaint.hdc, FALSE, FALSE);
			}
			else
			{
				Affichage_Overlay_PaintColorkey(hWnd, TRUE, sPaint.hdc, &sPaint.rcPaint, false);
			}
			OSD_Redraw(hWnd, sPaint.hdc);
			EndPaint(hWnd, &sPaint);
			break;

		case WM_VIDEOTEXT:
			if(VTState != VT_OFF || (Sous_Titres.bRun) )
			{
				switch(LOWORD(wParam))
				{
				case VTM_REDRAWHEADER:
					{
						HDC hDC = GetDC(hWnd);
						VT_RedrawClock(hWnd, hDC, !VT_ContainsUpdatedPage());
						ReleaseDC(hWnd, hDC);
					}
					break;
				default:
					break;
				}
			}
			break;

		case WM_CLOSE: // Quitter K!TV		
			RestoreBeforeClosing();

			if (IsPluginVideoRunning)
			{
				ChangeCH=TRUE;
				Plugin_Video_Stopper();
			}
			if(IsPluginAudioRunning)
				SendMessage(hWnd,WM_COMMAND,IDM_PLUGIN_AUDIO,0);
			DestroyWindow(hWnd);
			return 0;

		case WM_QUERYENDSESSION: //Fermeture de session/arret...
			ExitTV();
			LOG (1, "End Session");
            PostQuitMessage(0);
            return(TRUE); // On indique au systme que K!TV XP s'est ferme correctement: il peut des lors continuer a fermer...

        case WM_DESTROY: // Arret simple de l'application
			ExitTV();
            PostQuitMessage(0);
            return(FALSE); // On indique au systme que K!TV XP s'est ferme correctement

	}
	return(DefWindowProc(hWnd,message,wParam,lParam));
}
