/////////////////////////////////////////////////////////////////////////////
// K!TV-XP.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef KTV_H
#define KTV_H

#include "debuglog.h"
#include "lang.h"

#define INIT_HARDWARE        1800

//Cursor defines
#define CURSOR_DEFAULT 0x0000
#define CURSOR_HAND    0x0001

// Concerne Teletexte
#define WM_VIDEOTEXT		0x3001
#define VTM_REDRAWHEADER    0x0001


extern int Fail_Start;
extern char Text[255];

extern SYSTEMTIME SystemTime,LocalTime;

struct ZZoom
{
	int Actif;
	int Valeur;
	int Defaut;
};
extern struct ZZoom Zoom;

struct TShutdown
{
	BOOL Process;
	unsigned int Flag;
	unsigned char H;
	unsigned char M;
	char Text[255];
};
extern struct TShutdown Shutdown;

struct TLButton
{
	int x;
	int y;
	BOOL dbclk;
};
extern struct TLButton LButton;

extern BOOL Has_MSP;
extern int RES_index, RES_MAX_X;
extern BOOL VIA_FIX;
extern int VIA_FIX_X;

extern BOOL bAutoHideCursor;
extern BOOL bInMenuOrDialogBox;

extern BOOL bStartInFullScreen;
extern BOOL bMaximized,bMinimized;
extern BOOL bAlwaysOnTop;
extern BOOL bDisplayStatusBar;
extern BOOL bShowMenu;
extern BOOL bWindow43;
extern BOOL bSplashBox;
extern BOOL bBorderless;
extern BOOL bIsFullScreen;
extern BOOL bDoResize;	
extern int emsizex;
extern int emsizey;
extern int emstartx;
extern int emstarty;

extern HINSTANCE hInst;
extern HWND hWnd;
extern BOOL USETUNER;


extern unsigned char InitialHue;
extern unsigned char InitialBrightness[3];
extern int InitialContrast[3];
extern int InitialSaturationU[3];
extern int InitialSaturationV[3];
extern int InitialVolume;

extern char ChannelString[10];

extern int CardType;
extern int TunerType;
extern int VideoSource;
extern int AudioSource;
extern int TVTYPE;
extern char* ChaineVideoSource[];
extern BOOL ChangeCH;
extern int CurrentProgram;
extern int LastProgram;

extern BOOL Capture_Video ;
extern BOOL Capture_VBI;
extern BOOL OutDib;
extern BOOL ModeOverlay;
extern BOOL Overlay_NBB;
extern int WindowStyle;

extern int CurrentX,CurrentY;
extern int Res_X,Res_Y;
extern int CurrentFrame;
extern BOOL FullField;

extern int MovieBoost;
extern BOOL bAutoMovieBoost;
extern BOOL AutoMovieBoostEnable;

extern int MainProcessor, DisplayProcessor;
extern int PriorClassId;

extern HCURSOR hCursorDefault, hCursorHand;



/////////////////////////// Function headers //////////////////
void StatusBar_Create();
void StatusBar_Adjust();
void StatusBar_Update(int part, char * text);
int  StatusBar_Height();

#endif