/////////////////////////////////////////////////////////////////////////////
// Misc.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "K!TV-XP.h"
#include "misc.h"
#include "mixerdev.h"
#include "procs.h"
#include "osd.h"
#include "plugin.h"
#include "thread.h"
#include "bt848.h"
#include "btaudio.h"
#include "vbi-vt.h"
#include "ddraw.h"
#include "hardwaremisc.h"
#include "IR_haup.h"
#include "cpu.h"
#include "VBI_VideoText.h"
#include "settings.h"
#include "nextview.h"

HMENU hMenu, hMenuCont;
HWND SplashWnd = NULL;
BOOL bStartInTVMode = FALSE;	// Dmarrage en mode TV (touche F5)123

// Macro dfinie pour simplifier l'criture de la fonction UpdateMenuBar
#define CHECKUNCHECK(boolean)	(((boolean) ? MF_CHECKED : MF_UNCHECKED))
#define ENABLEGRAYED(boolean)	(((boolean) ? MF_ENABLED : MF_GRAYED   ))



void SetForegroundApp(BOOL bStart)
{
	if(!bStart)
	{
		SetFocus(hWnd);
		SetActiveWindow(hWnd);
		SetForegroundWindow(hWnd);
	}
	BringWindowToTop(hWnd);
	SetWindowPos(hWnd,bAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);
}


void SetDirectoryToExe()
{
    char szDriverPath[MAX_PATH];
    char* pszName;

    if (!GetModuleFileName(NULL, szDriverPath, sizeof(szDriverPath)))
    {
        LOG(1,"Cannot get module file name");
        return;
    }

    pszName = szDriverPath + strlen(szDriverPath);
    while (pszName >= szDriverPath && *pszName != '\\')
    {
        *pszName-- = 0;
    }

    SetCurrentDirectory(szDriverPath);
}


// Gere la ligne de commande DOS
void CommandLine(LPSTR cmdline)
{
	char *ptr;
	
	// Option dmarrage en mode TV
	bStartInTVMode = FALSE;
	ptr = strstr(cmdline, "-mtv");
	if (ptr != NULL){
		bStartInTVMode = TRUE;
		return;
	}
	
	// Option dmarrage en FullScreen
	bIsFullScreen = FALSE;
	ptr = strstr(cmdline, "-mfs");
	if (ptr != NULL)
		bIsFullScreen = TRUE;
}

static void Init_Erreur()
{
	// Si fichier ini et fichier program.set non presents
	if (Fail_Start==1 || Fail_Start==3) 
	{
		// Selection de la langue...
		DialogBox(hInst,"LANGAGE",hWnd,(DLGPROC)Langue_SelectProc);
		// Reglages...
		Langue_DialogBox(hInst,"REGLAGES_GENERAUX",hWnd,Reglages_GeneralSetupProc);
		Fail_Start-=1;
	}
	// On demande si on veut faire une recherche des canaux
	else if(Fail_Start == 2 && (MessageBox(hWnd, Langue_GetString(ID_PROC_CHAN_SEARCH), "K!TV XP",MB_ICONQUESTION|MB_YESNO)==IDYES))
	{
		Langue_DialogBox(hInst,"CANAUX_LISTE",hWnd,ProgramListProc);
		UpdateMenuBar();
		Fail_Start-=2;
	}
	else Fail_Start-=2;// Reponse NON a MessageBox ci dessus

}

// Fonction d'initialisation de K!TV
void OnCreateAppli()
{
	int i;
	char Text[255];
	SYSTEM_INFO SysInfo;

	GetSystemInfo(&SysInfo);

	SplashBox(NULL, NULL, NULL, NULL, NULL);	
	VBI_VT_Init();
	
	Channel_Load_Program_List();
	Channel_Load_Country_Settings();
	
	if ( USE_MIXER ) // Initialisation du mixer
	{
		SplashBox(Langue_GetString(ID_AUDIOSYS), NULL, NULL, NULL, NULL);
		Mixer_Enumerate_Sound_SubSystem();
		if ( SoundSystem.DeviceAnzahl == 0 )
		{
			SplashBox(NULL, Langue_GetString(ID_NOTHING), Langue_GetString(ID_AUDIOSYS), Langue_GetString(ID_FOUND), NULL);
		}
		else
		{
			if ( SoundSystem.DeviceAnzahl >= 1 ) SplashBox(NULL, SoundSystem.MixerDev[0].szPname, NULL, NULL, NULL);
			if ( SoundSystem.DeviceAnzahl >= 2 ) SplashBox(NULL, NULL, NULL, SoundSystem.MixerDev[1].szPname, NULL);
			if ( SoundSystem.DeviceAnzahl >= 3 ) SplashBox(NULL, NULL, NULL, NULL, SoundSystem.MixerDev[2].szPname);
			
			SplashBox(NULL, NULL, " "," "," ");
			
			if ( Volume.SoundSystem >= 0 ) 
				sprintf(Text,"%s",SoundSystem.MixerDev[Volume.SoundSystem].szPname);
			else 
				sprintf(Text,"%s",SoundSystem.MixerDev[0].szPname);
			SplashBox(NULL, Text, NULL,NULL,NULL);
			
			if ( Volume.SoundSystem >= 0 ) 
				sprintf(Text, Langue_GetString(ID_VOLUME2),SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].MixerConnections[Volume.Connection].szName);
			else 
				sprintf(Text,Langue_GetString(ID_NOVOLUME));
			SplashBox(NULL, NULL, Text, NULL,NULL);
									   						   
			Mixer_Set_Defaults();
			Mixer_Get_Volume_Param();
			if ( MIXER_CANAL_GAUCHE == -1 ) 
				Mixer_Get_Volume(&MIXER_CANAL_GAUCHE,&MIXER_CANAL_DROIT,FALSE);
			Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
		}
	}

	SplashBox(Langue_GetString(ID_SYSTEM), " "," "," "," ");
	
	sprintf(Text,Langue_GetString(ID_PROC),SysInfo.dwProcessorType);
	SplashBox(NULL,Text,NULL,NULL,NULL);
	sprintf(Text,Langue_GetString(ID_NUM_CPU),SysInfo.dwNumberOfProcessors);
	SplashBox(NULL,NULL,Text,NULL,NULL);
	
	if ( SysInfo.dwNumberOfProcessors > 1 )
	{
		if ( DisplayProcessor == 0 )
		{
			if ( SysInfo.dwNumberOfProcessors >= 2 )
			{
				MainProcessor=0;
				DisplayProcessor=1;
			}			
		}
		sprintf(Text,Langue_GetString(ID_MAIN_CPU),MainProcessor);
		SplashBox(Langue_GetString(ID_MULTIPROC),Text,NULL,NULL,NULL);
						
		sprintf(Text, Langue_GetString(ID_PLUG_CPU), DisplayProcessor);
		SplashBox(NULL,NULL, Text, NULL,NULL);
	}

	i=SetThreadAffinityMask (GetCurrentThread(), 1<<(MainProcessor));         
	SplashBox(Langue_GetString(ID_HARDWARE)," "," "," "," ");
	
	if ( !USETUNER )
		TunerType=4;

	DeterminerOS();

    if (IsWinNT)
        hCursorHand = LoadCursor(NULL, MAKEINTRESOURCE(32649));
    else
        hCursorHand = hCursorDefault;
	
	return;
}


//Initialisation du materiel
BOOL OnInitHardware() 
{
char Text[255];

	NexTView_Init(); // Initialisation de NexTView EPG

	/* Chargement du driver DSDrv							*/
	if ( !InitialiserDriver())
		return FALSE;

	/* Initialisation du Tuner								*/
	SetTimer(hWnd, TIMER_CHANNELCHANGE, 2000, NULL);
	if ( USETUNER )
	{
		sprintf(Text,Langue_GetString(ID_NOTUNER));
		if ( Tuner_Init(TunerType) ) 
			sprintf(Text,Langue_GetString(ID_TUNEROK));
	}
	else
		sprintf(Text, Langue_GetString(ID_TUNERDIS));
	SplashBox(NULL,NULL,NULL, Text, NULL);

	/* Initialisation de la partie audio (MSP et BT8X8)		*/
	if(CardType==4 || CardType==5) Audio_MSP_Hauppauge_Boot();
	MSPStatus[0]=0x00;
	BT8X8_SetAudioSource(AudioSource);
	if (Audio_Init(0x80,0x81))
	{
		sprintf(Text,Langue_GetString(ID_MSPOK));
		sprintf(MSPStatus,Langue_GetString(ID_MSPVERSION));
	}
	else
	{
		sprintf(Text, Langue_GetString(ID_NOMSP));
		sprintf(MSPStatus,Langue_GetString(ID_I2C_EMPTY));
	}
	SplashBox(NULL,NULL,NULL,NULL, Text);
	
	/* Initialisation de la partie affichage DIB et Overlay */
	if (!Affichage_Alloc_DIB())
	{
		RealErrorBox(Langue_GetString(ID_ERROR_DIB));
		return FALSE;
	}
	Affichage_InitDD(hWnd,FALSE, 0, 0);
	
	//On cree le repertoire des plugins s'il n'existe pas...
	CreateDirectory("Plugins",(LPSECURITY_ATTRIBUTES)NULL);	

	/* Initialisation des plugins (DScaler, Audio et Vido)	*/
    CPU_SetupFeatureFlag();
	InitializeCriticalSection(&PluginCrit);
	Plugin_DScaler_Charger();
	Plugin_Video_Charger(PlugVideoName);
	Plugin_Audio_Charger(PlugAudioName); 
	Langue_ChangeLang(AppLang,TRUE);

	SendMessage(hWnd,WM_COMMAND,IDM_UPDATEMENU,0);// Initialisation des menus

	if ( Has_MSP )
		SetTimer(hWnd,TIMER_MSP,2000,NULL);

	if(bIRACtive && ParametreCarte[CardType].IR_Haup)
	{
		IR_Hauppauge_Reset();
		SetTimer(hWnd,TIMER_IR,IRSampling,NULL);
	}

	KillTimer(hWnd,TIMER_SHUTDOWN);

	SetTimer(hWnd,TIMER_SHUTDOWN,1000,NULL);
	SetTimer (hWnd, TIMER_STATUS, 2500, NULL);
	SetTimer(hWnd, TIMER_MOVIEBOOST, 5000, NULL);

	// Priorit de l'application : A laisser ICI...
	SendMessage(hWnd, WM_COMMAND, IDM_PRIORCLASS_0 + PriorClassId, 0);
	
	// Rglage de la chaine:
	Channel_Change(TRUE);

	// Forcer la prise en compte des parametres INI de l'affichage
	if (bStartInTVMode) 
	{
  		Affichage_ToggleMenu();
	}
	Affichage_Overlay_Workout(TRUE);
  	
	DestroyWindow(SplashWnd);	// On detruit le splashbox...
	BringWindowToTop(hWnd);	// On met la fenetre de K!TV au premier plan
  	ShowWindow(hWnd, SW_SHOWNORMAL);	// On montre la fenetre
  	bDoResize = TRUE;
	SetForegroundApp(TRUE);
	if (bNXTVactive)	NexTView_Demarrer(TRUE);	// Dmarrage de NexTView EPG
	UpdateMenuBar();
	Init_Erreur(); //Fail Start
	LOG(1, "Fin Initialisation Hardware");
	return TRUE;
}


// Force la mise  jour de l'ensemble de la barre de menu
void UpdateMenuBar()
{
	int i;
	HMENU Menu;
	Menu=hMenu;

	for(i=0;i<2;i++)
	{
		if (Menu == NULL)
			continue;

		CheckMenuRadioItem( Menu, IDM_TREADPRIOR_0, IDM_TREADPRIOR_4, 
							ThreadClassId + IDM_TREADPRIOR_0, MF_BYCOMMAND);

		CheckMenuRadioItem( Menu, IDM_PRIORCLASS_0, IDM_PRIORCLASS_3, 
							PriorClassId + IDM_PRIORCLASS_0, MF_BYCOMMAND);

		CheckMenuRadioItem( Menu, IDM_FENETRE, IDM_OWN_RES, 
							WindowStyle + IDM_FENETRE, MF_BYCOMMAND);

		CheckMenuRadioItem( Menu, IDM_PIXELWIDTH_768, IDM_PIXELWIDTH_320, 
							RES_index + IDM_PIXELWIDTH_768, MF_BYCOMMAND);

		if(TVSettings[TVTYPE].wCropWidth!=768)
		{
			EnableMenuItem(Menu,IDM_PIXELWIDTH_768,MF_GRAYED);
			EnableMenuItem(Menu,IDM_PIXELWIDTH_754,MF_GRAYED);
			EnableMenuItem(Menu,IDM_PIXELWIDTH_720,MF_GRAYED);
		}
		else 
		{
			EnableMenuItem(Menu,IDM_PIXELWIDTH_768,MF_ENABLED);
			EnableMenuItem(Menu,IDM_PIXELWIDTH_754,MF_ENABLED);
			EnableMenuItem(Menu,IDM_PIXELWIDTH_720,MF_ENABLED);
		}

		CheckMenuItem( Menu, IDM_AUTOHIDE_CURSOR,	CHECKUNCHECK(bAutoHideCursor) );		
		CheckMenuItem( Menu, IDM_TOGGLE_BORDER,		CHECKUNCHECK (bBorderless));
		CheckMenuItem( Menu, IDM_ON_TOP,			CHECKUNCHECK (bAlwaysOnTop));
		CheckMenuItem( Menu, IDM_STATUSBAR,			CHECKUNCHECK (bDisplayStatusBar));
		CheckMenuItem( Menu, IDM_FFORMAT43,			CHECKUNCHECK (bWindow43));
		CheckMenuItem( Menu, IDM_AUTOMB,			CHECKUNCHECK (bAutoMovieBoost));

		CheckMenuItem(Menu,  IDM_MOVIEBOOST_NUL,	CHECKUNCHECK (MovieBoost == MOVIEBOOST_DESACTIVE));
		CheckMenuItem(Menu,  IDM_MOVIEBOOST_169,	CHECKUNCHECK (MovieBoost == MOVIEBOOST_16_9));
		CheckMenuItem(Menu,  IDM_MOVIEBOOST_209,	CHECKUNCHECK (MovieBoost == MOVIEBOOST_20_9));

		EnableMenuItem(Menu, IDM_OVERLAY,			ENABLEGRAYED (Can_Overlay));
		CheckMenuItem( Menu, IDM_OVERLAY,			CHECKUNCHECK (ModeOverlay));
		EnableMenuItem(Menu, IDM_OVERLAY_NBB,		ENABLEGRAYED (Can_Overlay));
		CheckMenuItem( Menu, IDM_OVERLAY_NBB,		CHECKUNCHECK (Overlay_NBB));
		CheckMenuItem( Menu, IDM_DIB,				CHECKUNCHECK (OutDib));
		CheckMenuItem( Menu, IDM_VIDEO,				CHECKUNCHECK (Capture_Video));
		CheckMenuItem( Menu, IDM_CAPTURE_PAUSE,		CHECKUNCHECK (CapturePaused));

		CheckMenuItem( Menu, IDM_VBI,				CHECKUNCHECK (Capture_VBI));
		CheckMenuItem( Menu, IDM_VIDEOTEXT,			CHECKUNCHECK (VTState!=VT_OFF));
		CheckMenuItem( Menu, IDM_SOUSTITRES,		CHECKUNCHECK (Sous_Titres.bActif));
		EnableMenuItem(Menu, IDM_VIDEOTEXT,			ENABLEGRAYED (Capture_VBI));		
		EnableMenuItem(Menu, IDM_VT_RESET,			ENABLEGRAYED (Capture_VBI));
		EnableMenuItem(Menu, IDM_SOUSTITRES,		ENABLEGRAYED (Capture_VBI));
		EnableMenuItem(Menu, IDM_VT_INFO,			ENABLEGRAYED (Capture_VBI));
		EnableMenuItem(Menu, IDM_VT_SEARCH,			ENABLEGRAYED (VTState!=VT_OFF));
		EnableMenuItem(Menu, IDM_VT_SEARCHNEXT,		ENABLEGRAYED (VTState!=VT_OFF));

		EnableMenuItem(Menu, IDM_NXTV,				ENABLEGRAYED (PluginNextViewPresent));
		CheckMenuItem( Menu, IDM_NXTV,				CHECKUNCHECK (bNXTVactive));
		EnableMenuItem(Menu, IDM_NXTV_PATH,			ENABLEGRAYED (PluginNextViewPresent));

		if(AutoProcessVideo)
		{
			EnableMenuItem(Menu, IDM_PLUGIN_VIDEO_FORCE, MF_ENABLED);
			CheckMenuItem( Menu, IDM_PLUGIN_VIDEO_FORCE, CHECKUNCHECK (ForcePluginVideo));
		}
		else
		{
			CheckMenuItem( Menu, IDM_PLUGIN_VIDEO_FORCE, MF_UNCHECKED );
			EnableMenuItem(Menu, IDM_PLUGIN_VIDEO_FORCE, MF_GRAYED);
		}
		CheckMenuItem(Menu, IDM_PLUGIN_AUDIO,		CHECKUNCHECK (IsPluginAudioRunning));
		CheckMenuItem(Menu, IDM_PLUGIN_VIDEO_ON,	CHECKUNCHECK (IsPluginVideoRunning));
		CheckMenuItem(Menu, IDM_AUTOSTEREO,			CHECKUNCHECK (AutoStereoSelect));

		if (Has_MSP)
		{
			EnableMenuItem(Menu,IDM_AUDIOSETTINGS_MSP,MF_ENABLED);
			EnableMenuItem(Menu,IDM_AUDIOSETTINGS_MSP_EQ,MF_ENABLED);
		}
		if ( !USETUNER )
		{
			EnableMenuItem(Menu,IDM_CHANNELPLUS,MF_GRAYED);
			EnableMenuItem(Menu,IDM_CHANNELMINUS,MF_GRAYED);
		}

		Menu=hMenuCont;
	}
}


// Modification du menu de K!TV pour greffer les menus des plugins
void ModifyAppMenu()
{
	HMENU men = 0;
	char buf[50];

	DestroyMenu(hMenu);
	hMenu=Langue_LoadMenu(hInst,"K!TV_MENU");
	
	if(PluginVideoPresent || PluginAudioPresent)
		ModifyMenu(GetSubMenu(hMenu, 3), 2, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL);
	else
		RemoveMenu(hMenu,ID_OPTIONS_SEPARATOR,MF_BYCOMMAND);
	
	if(PluginAudioPresent)
	{
		men = PluginAudio->GetPluginMenu(FALSE);
		if(men==NULL)	RemoveMenu(hMenu,ID_OPTIONS_AUDIO,MF_BYCOMMAND);
		else
		{
			// Recuperation du "label" du popup, on s'en sert pour ModifyMenu
			GetMenuString(men, 0, buf, 50, MF_BYPOSITION);
			ModifyMenu(GetSubMenu(hMenu, 3), 4, MF_BYPOSITION | MF_POPUP, (unsigned int)GetSubMenu(men, 0), buf );
			if(IsWinNT)	DestroyMenu(men);
		}
	}
	else	RemoveMenu(hMenu,ID_OPTIONS_AUDIO,MF_BYCOMMAND);
	

	if (PluginVideoPresent) 
	{	
		men = PluginVideo->GetPluginMenu(FALSE);
		if(men==NULL)	RemoveMenu(hMenu,ID_OPTIONS_VIDEO,MF_BYCOMMAND);
		else
		{
			// Recuperation du "label" du popup, on s'en sert pour ModifyMenu
			GetMenuString(men, 0, buf, 50, MF_BYPOSITION);
			ModifyMenu(GetSubMenu(hMenu, 3), 3, MF_BYPOSITION | MF_POPUP, (unsigned int)GetSubMenu(men, 0), buf );
			if(IsWinNT)	DestroyMenu(men);
		}
	}
	else	RemoveMenu(hMenu,ID_OPTIONS_VIDEO,MF_BYCOMMAND);
	
	if(bShowMenu)	SetMenu(hWnd,hMenu);
	UpdateMenuBar();
}


void ModifyAppContextMenu(LONG lParam)
{
	HMENU men = 0;
	char buf[50];
  
	DestroyMenu(hMenuCont);
	hMenuCont=GetSubMenu(Langue_LoadMenu(hInst,"K!TV_MENU_CONTEXT"),0);
  	
  	if (PluginVideoPresent || PluginAudioPresent)	ModifyMenu(hMenuCont, 5, MF_BYPOSITION | MF_SEPARATOR, NULL, NULL);
  	else	RemoveMenu(hMenuCont,ID_CONTEXT_SEPARATOR,MF_BYCOMMAND);
  	
	if (PluginAudioPresent) 
	{
		men = PluginAudio->GetPluginMenu(TRUE);
		if(men==NULL)	RemoveMenu(hMenuCont,ID_CONTEXT_AUDIO,MF_BYCOMMAND);
		else
		{
			GetMenuString(men, 0, buf, 50, MF_BYPOSITION);
			ModifyMenu(hMenuCont, 7, MF_BYPOSITION | MF_POPUP,	(unsigned int)GetSubMenu(men, 0), buf );
			if(IsWinNT)	DestroyMenu(men);
		}
	}
	else	RemoveMenu(hMenuCont,ID_CONTEXT_AUDIO,MF_BYCOMMAND);
  	
	if (PluginVideoPresent) 
	{
  		men = PluginVideo->GetPluginMenu(TRUE);
  		if(men==NULL)	RemoveMenu(hMenuCont,ID_CONTEXT_VIDEO,MF_BYCOMMAND);
		else
		{
			GetMenuString(men, 0, buf, 50, MF_BYPOSITION);
 			ModifyMenu(hMenuCont, 6, MF_BYPOSITION | MF_POPUP,	(unsigned int)GetSubMenu(men, 0), buf );
			if(IsWinNT)	DestroyMenu(men);
		}
	}
	else	RemoveMenu(hMenuCont,ID_CONTEXT_VIDEO,MF_BYCOMMAND);
  
	UpdateMenuBar();
	TrackPopupMenuEx(hMenuCont,TPM_LEFTBUTTON, LOWORD(lParam),HIWORD(lParam),hWnd,0);
	DestroyMenu(hMenuCont);	
}


// Selection du type de curseur a afficher (Pour le teletexte on utilise la main pour selectionner une page...)
int Cursor_SetType(int type)
{
    HCURSOR hCur;
    switch (type)
    {
		case CURSOR_HAND:
			hCur = hCursorHand;
			break;
		default:
	        hCur = hCursorDefault;
			break;
    }

    SetClassLong(hWnd, GCL_HCURSOR, (long) hCur);
    return TRUE;
}



// Affiche le texte en utilisant l'OSD et la barre de status
void __cdecl StatusBar_And_OSD_Display(char* String2Display, ...)
{
	int nBuf;
	char szBuffer[512];

	if (!String2Display) return;

	va_list args;
	va_start(args, String2Display);
	
	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer) / sizeof(WCHAR), String2Display, args);
	
	StatusBar_Display(szBuffer);
	OSD_ShowText_Center(hWnd, szBuffer);
	
	va_end(args);
}


// Affiche un texte sur la barre de status
void __cdecl StatusBar_Display(char* String2Display, ...)
{
	int nBuf;
	char szBuffer[512];

	if (!String2Display) return;

	va_list args;
	va_start(args, String2Display);
	
	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer) / sizeof(WCHAR), String2Display, args);
	StatusBar_Update(0, szBuffer);
	va_end(args);
}


// Affiche des infosdans le champ "Key"
void __cdecl StatusBar_Display_KeyField(char* String2Display, ...)
{
	int nBuf;
	char szBuffer[512];

	va_list args;
	va_start(args, String2Display);
	
	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer) / sizeof(WCHAR), String2Display, args);
	StatusBar_Update(3, szBuffer);
	
	va_end(args);
}


// Print information on the splash screen (from line 1 to 5 )
// - NULL (or "") doesn't update the line
// - " " erases the line
void SplashBox(LPSTR string1, LPSTR string2, LPSTR string3, LPSTR string4, LPSTR string5)
{
	if (WRITE_LOG)
	{
		char esp = ' ';

		if (string1 != NULL && string1[0] != esp) LOG(1, string1);
		if (string2 != NULL && string2[0] != esp) LOG(1, string2);
		if (string3 != NULL && string3[0] != esp) LOG(1, string3);
		if (string4 != NULL && string4[0] != esp) LOG(1, string4);
		if (string5 != NULL && string5[0] != esp) LOG(1, string5);
	}
	if (bSplashBox)
	{
		// The first time create the window ...
		if (SplashWnd == NULL)
		{
			SplashWnd=CreateDialog(hInst,"SPLASHBOX",hWnd,SplashProc);
			SetWindowPos(SplashWnd,HWND_TOPMOST,10,10,20,20,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOSIZE);
		}
		if (string1 != NULL) SetDlgItemText(SplashWnd, IDC_TEXT1, string1);
		if (string2 != NULL) SetDlgItemText(SplashWnd, IDC_TEXT2, string2);
		if (string3 != NULL) SetDlgItemText(SplashWnd, IDC_TEXT3, string3);
		if (string4 != NULL) SetDlgItemText(SplashWnd, IDC_TEXT4, string4);
		if (string5 != NULL) SetDlgItemText(SplashWnd, IDC_TEXT5, string5);
		Sleep (100);
	}
}


void Channel_Plus()
{
int i, NouveauCanal;
	i=CurrentProgram+1;
	NouveauCanal=-1;
	while ( i < MAXPROGS )
	{
		if ( Program[i].Active )
		{
			NouveauCanal=i;
			break;
		}
		i++;
	}
	
	if ( NouveauCanal == -1 )
	{
		i=1;
		while ( i < MAXPROGS )
		{
			if (Program[i].Active)
			{
				NouveauCanal=i;
				break;
			}
			i++;
		}
	}
	ChangementCanal(NouveauCanal);
}


void Channel_Minus()
{
int i, NouveauCanal;
	i=CurrentProgram-1;
	NouveauCanal=-1;
	while ( i > 0)
	{
		if ( Program[i].Active )
		{
			NouveauCanal=i;
			break;
		}
		i--;
	}
	
	if ( NouveauCanal == -1 )
	{
		i=MAXPROGS-1;
		while ( i > 0 )
		{
			if ( Program[i].Active )
			{
				NouveauCanal=i;
				break;
			}
			i--;
		} 
	}
	ChangementCanal(NouveauCanal);	
}


//Changement de canal/preselection avec selection source/format et commutation MSP34XX AM/Nicam + Affichage OSD
void Channel_Change(BOOL bForceSource)
{
	if(Program[CurrentProgram].Source==0) // Source Tuner
	{
		if(VideoSource!=0 || bForceSource) // Si la source precedente n'est pas le tuner ou si on force la commutation de source
		{
			Audio_MSP_Reset();
			Audio_Init(0x80,0x81);
			Stop_Capture(bForceSource);
			BT8X8_SetVideoSource(0);
			BT8X8_SetAudioSource(AudioSource);
			Affichage_Init_Screen_Struct();
			Start_Capture(bForceSource);
		}
		if(Program[CurrentProgram].Format==-1) // Format video identique a celui du tuner
		{
			if(TVTYPE!=Tuners[TunerType].format)
				SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+(Tuners[TunerType].format),0);
		}
		else // Format video specifique
		{
			if(TVTYPE!=Program[CurrentProgram].Format)
				SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+Program[CurrentProgram].Format,0);
		}

		Tuner_SetFrequency(TunerType,MulDiv(Program[CurrentProgram].freq*1000,16,1000000)); // Reglage de la frequence
		if(Has_MSP) // Si MSP34XX On commute sur le format audio aproprie
		{
			Sleep(25);
			Audio_MSP_Watch_Mode();
		}
		VT_Reset();
	}
	else // Source differente du tuner
	{
		if(VideoSource!=Program[CurrentProgram].Source || bForceSource) // Si la source precedente etait differente ou si on force la commutation de source
		{
			Audio_MSP_Reset();
			Stop_Capture(bForceSource);
			BT8X8_SetVideoSource(Program[CurrentProgram].Source);
			BT8X8_SetAudioSource(2);
			Affichage_Init_Screen_Struct();
			Start_Capture(bForceSource);
		}
		if(TVTYPE!=Program[CurrentProgram].Format)
			SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+Program[CurrentProgram].Format,0);
	}
	StatusBar_Display_KeyField("%d. %s ",CurrentProgram,Program[CurrentProgram].Name);
	NexTView_ChannelChange();
}


// Changement de canal par clavier (+, - ...)
void ChangementCanal(int NouveauCanal)
{
	if ( !USETUNER ) return;

	if (IsPluginVideoRunning)
	{
		ChangeCH=TRUE;
		Plugin_Video_Stopper();
		SetTimer(hWnd, TIMER_CHANNELCHANGE, 2000, NULL);
	}

	if(MovieBoost != MOVIEBOOST_DESACTIVE)
		SendMessage(hWnd,WM_COMMAND,IDM_MOVIEBOOST_NUL,0);
	
	// Coupure son avant changement de canal
	if(!System_In_Mute)
	{
		if(Has_MSP)
		{
			TVolume=InitialVolume;
			Audio_MSP_SetVolume(0);
			Sleep(100);
		}
		else	BT8X8_SetAudioSource(4);
	}

	LastProgram = CurrentProgram;
	CurrentProgram = NouveauCanal;

	if ( CurrentProgram > 0)
	{
		Channel_Change(FALSE);
		SetTimer(hWnd,TIMER_CHANNEL,500,NULL);
	}
	else 
		CurrentProgram=1;
	
	// restauration son aprs changement de canal
	if(!System_In_Mute)
	{
		if(Has_MSP)
		{
			Sleep(25);
			Audio_MSP_SetVolume(TVolume);
		}
		else	BT8X8_SetAudioSource((Program[CurrentProgram].Source==0)?AudioSource:2);
	}
}


// Nous sommes sur le point de quitter l'application
// Code commun  WM_CLOSE et  IDM_END_WIN
void RestoreBeforeClosing()
{
	if (bIsFullScreen)
		SendMessage(hWnd,WM_COMMAND,IDM_FULLSCREEN,0);
	if(!bShowMenu)
		SendMessage(hWnd,WM_COMMAND,IDM_TOGGLE_MENU,0);
	if(!bDisplayStatusBar)	
		Affichage_ToggleStatusBar();
	
	// Restauration de la fenetre
	if(bMinimized)	ShowWindow(hWnd,SW_RESTORE);
	if(bMaximized)	ShowWindow(hWnd,SW_RESTORE);
	ShowWindow(hWnd,SW_RESTORE);
}


// Termine et nettoie tout avant l'arret de K!TV
void ExitTV(void)
{
char FAILED[] = "Echec", SUCCESS[] = "Succs";

	LOG (1, "");
	LOG (1, "Fermeture de K!TV XP ...");

	__try
	{
		LOG_ (1, "Arrt timers");
		KillTimer(hWnd,TIMER_CHANNELCHANGE);
		KillTimer(hWnd,TIMER_CHAR);
		KillTimer(hWnd,TIMER_IR);
		KillTimer(hWnd,TIMER_LBUTTONUP);
		KillTimer(hWnd,TIMER_MOUSEWHEEL);
		KillTimer(hWnd,TIMER_MSP);
		KillTimer(hWnd,TIMER_SHUTDOWN);
		KillTimer(hWnd,TIMER_STATUS);
		KillTimer(hWnd,TIMER_ST);
		KillTimer(hWnd,TIMER_VISIBILITY);
		KillTimer(hWnd,TIMER_VTFLASHER);
		KillTimer(hWnd,TIMER_VTUPDATE);
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


	__try
	{
		LOG_ (1, "Arrt du thread de capture");
		Stop_Capture(TRUE);
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


	__try
	{
		LOG_ (1, "Fermeture du mixer et VBI");
		Mixer_Exit();
		VBI_VT_Exit();
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


	__try
	{
		LOG_ (1, "Ecriture du fichier INI");
		if(System_In_Mute && Has_MSP)
			InitialVolume=TVolume;
		INI_Ecrire("K!TV-XP.ini");
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


	__try
	{
		LOG_ (1, "Coupure sonore");
		if(Has_MSP)
		{
			if(Program[CurrentProgram].Source!=0)
				BT8X8_SetAudioSource(AudioSource);
			Audio_MSP_SetVolume(0);
		}
		else	
			BT8X8_SetAudioSource(4);
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


	__try
	{
		LOG_ (1, "Arrt du driver DSDrv");
		FermerDriver();
		NexTView_Exit();
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }

	__try
	{
		LOG_ (1, "Arrt de DirectDraw");
		Affichage_CloseDD();
		DeleteCriticalSection(&hDDCritSect);

		Affichage_FreeDIBmemory();
		Affichage_FreehDIB();
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


    __try
    {
		LOG_ (1, "Dchargement des plugins");
		Plugin_Video_Decharger();
		Plugin_Audio_Decharger();
		Plugin_DScaler_Decharger();
		Langue_DechargerPlugin();
		DeleteCriticalSection(&PluginCrit);
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }


    __try
    {
		LOG_ (1, "Chargement application IR Hauppauge");
		if(bIRACtive && ParametreCarte[CardType].IR_Haup && !Shutdown.Process)
			IR_Hauppauge_Start();
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }

    __try
    {
		LOG_ (1, "Arrt de Nextview");
		if(bNXTVactive)	NexTView_Fermer();
		LOG (1, SUCCESS);
	}
    __except (EXCEPTION_EXECUTE_HANDLER) { LOG (1, FAILED); }

	
	LOG (1, "L'application a t ferme.");
}
