/////////////////////////////////////////////////////////////////////////////
// Misc.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef MISC_H
#define MISC_H


// Definition des Timer utiliss par K!TV XP
#define TIMER_STATUS			1
#define TIMER_SPLASHBOX			2

#define TIMER_MSP				8
#define TIMER_IR				9
#define TIMER_MOVIEBOOST		10
#define TIMER_ST				12
#define TIMER_VTUPDATE			13
#define TIMER_CHANNEL			14
#define TIMER_VTFLASHER			15
#define TIMER_FOREGROUND		16

#define TIMER_SHUTDOWN			22

#define TIMER_LBUTTONUP			47
#define TIMER_MOUSEWHEEL		48
#define TIMER_CHANNELCHANGE		49
#define TIMER_VISIBILITY		50

#define TIMER_CHAR				99


// Dure de quelques Timers
#define TIMER_VTUPDATE_MS		110
#define TIMER_VTFLASHER_MS		500



////////////////////////////////////////////
void SetForegroundApp(BOOL bStart);

void SetDirectoryToExe();
void CommandLine(LPSTR cmdline);

void OnCreateAppli();
BOOL OnInitHardware();
void OnTimer(UINT );
void ExitTV(void);
void Channel_Change(BOOL bForceSource);
void ChangementCanal(int NouveauCanal);

void ModifyAppMenu();
void ModifyAppContextMenu(LONG);
void UpdateMenuBar();
void SplashBox(LPSTR string1, LPSTR string2, LPSTR string3, LPSTR string4, LPSTR string5);
int  Cursor_SetType(int type);
void Cursor_UpdateVisibility();
void RestoreBeforeClosing();
void Channel_Minus();
void Channel_Plus();

void __cdecl StatusBar_And_OSD_Display(char* String2Display, ...);
void __cdecl StatusBar_Display(char* String2Display, ...);
void __cdecl StatusBar_Display_KeyField(char* String2Display, ...);

////////////////////////////////////////////

enum MovieBoostValues
{ MOVIEBOOST_16_9 = 37,
  MOVIEBOOST_20_9 = 58,
  MOVIEBOOST_DESACTIVE = 0
};

// Pour le zoom
extern int DebutLigne, HauteurBandeNoire;

void SetMovieBoost(int param);
void SetZoom();
void SetZoomAvecPrecision(int param);

void Affichage_Overlay_Workout(BOOL bInit);
BOOL Affichage_Init_Screen_Struct();
void Affichage_FreeDIBmemory();
BOOL Affichage_Alloc_DIB();
void Affichage_FreehDIB();

void Affichage_ModeFenetre(HWND hWnd, int param);
void Affichage_ModeDDrawExclusif(HWND hWnd, int param);
void Affichage_Format(HWND hWnd, int param);
void Affichage_ToggleFullScreen();
void Affichage_ToggleStatusBar();
void Affichage_ToggleOnTop();
void Affichage_ToggleMenu();
void Affichage_Geo_Fenetre(WPARAM wParam, RECT *r, BOOL Move);

#endif