/////////////////////////////////////////////////////////////////////////////
// Mixerdev.c: Ansteuerung MixerDevice
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <windowsx.h>
#include <stdlib.h> 
#include <mmsystem.h>
#include <commctrl.h>

#include "MixerDev.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"
#include "K!TV-XP.h"


static unsigned int LastOpenMixer=0xffffffff;
static int MIXER_CANAL_GD;
static HMIXER hMixer=NULL;
struct TMixerAccess Volume={-1,0,0,0,-1};
struct TMixerAccess Wave={-1,0,0,0,-1};
struct TMixerAccess Record={-1,0,0,0,-1};

int  MIXER_CANAL_GAUCHE=-1;
int  MIXER_CANAL_DROIT=-1;
int MixerVolumeStep=-1;
int MixerVolumeMax=-1;
BOOL USE_MIXER=FALSE;
BOOL System_In_Mute=FALSE;
struct TSoundSystem SoundSystem;

extern int VolumeIn,VolumeOut;


static BOOL Mixer_Open_HMixer(UINT uMxId)
{
	MMRESULT mmresult;

	if ( uMxId != LastOpenMixer )
	{
		if ( hMixer != NULL )
		{
			mmresult=mixerClose(hMixer);
			hMixer=NULL;
		}
		mmresult = mixerOpen(&hMixer,uMxId,0,(DWORD)hInst,MIXER_OBJECTF_AUX);
		if ( mmresult != MMSYSERR_NOERROR )
		{
			// Ohhps kein auxiliary device 
            mmresult=mixerOpen(&hMixer,uMxId,0,(DWORD)hInst,MIXER_OBJECTF_MIXER);
		}
		if ( mmresult == MMSYSERR_NOERROR )
		{
			LastOpenMixer=uMxId;
            return(TRUE);
		}
		return(FALSE);
	} 
	return(TRUE);
}


static MMRESULT Mixer_Set_Control_Values( MIXERCONTROLDETAILS *Setting ,int Device )
{
	if ( SoundSystem.DeviceAnzahl == 0 ) return(1);
	Mixer_Open_HMixer(Device);
	return(mixerSetControlDetails((HMIXEROBJ) hMixer,Setting,MIXER_SETCONTROLDETAILSF_VALUE | MIXER_OBJECTF_HMIXER));
}


static MMRESULT Mixer_Get_Control_Values( MIXERCONTROLDETAILS *Setting,int Device  )
{
	if ( SoundSystem.DeviceAnzahl == 0 ) return(1);
	Mixer_Open_HMixer(Device);
	return(mixerGetControlDetails((HMIXEROBJ) hMixer,Setting,MIXER_GETCONTROLDETAILSF_VALUE | MIXER_OBJECTF_HMIXER));
}


void Mixer_Enumerate_Sound_SubSystem(void)
{
	MMRESULT     mmresult;
    int SoundSystemLoop;
    int DestinationLoop;
    int ConnectionLoop;
    int ControlLoop;
	int KanalLoop;
    MIXERLINECONTROLS   MixerLineControl;

	SoundSystem.DeviceAnzahl=mixerGetNumDevs();
	if ( SoundSystem.DeviceAnzahl == 0 ) return;

    SoundSystem.MixerDev=(MIXERCAPS *)calloc(sizeof(MIXERCAPS),SoundSystem.DeviceAnzahl);
	SoundSystem.To_Lines=(struct TMixerLines *)calloc(sizeof(struct TMixerLines),SoundSystem.DeviceAnzahl);

    for ( SoundSystemLoop = 0; SoundSystemLoop < SoundSystem.DeviceAnzahl; SoundSystemLoop++)
	{
		mmresult= mixerGetDevCaps(SoundSystemLoop, &SoundSystem.MixerDev[SoundSystemLoop], sizeof(MIXERCAPS) );

		if ( Mixer_Open_HMixer(SoundSystemLoop) )
		{
			// Enumerate Destinations
			SoundSystem.To_Lines[SoundSystemLoop].AnzahlLines=SoundSystem.MixerDev[SoundSystemLoop].cDestinations;
			SoundSystem.To_Lines[SoundSystemLoop].MixerLine=(MIXERLINE *)calloc(sizeof(MIXERLINE),SoundSystem.MixerDev[SoundSystemLoop].cDestinations);
			SoundSystem.To_Lines[SoundSystemLoop].To_Connection=(struct TMixerConnections *)calloc(sizeof(struct TMixerConnections),SoundSystem.MixerDev[SoundSystemLoop].cDestinations);

	        for (DestinationLoop=0; DestinationLoop < SoundSystem.To_Lines[SoundSystemLoop].AnzahlLines; DestinationLoop++)
			{
				SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].cbStruct      = sizeof(MIXERLINE);
				SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].dwDestination = DestinationLoop;
				mmresult = mixerGetLineInfo((HMIXEROBJ)hMixer,&SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop],MIXER_GETLINEINFOF_DESTINATION);
			
				if ( mmresult == MMSYSERR_NOERROR )
				{
					// Enumerate Connection
					SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].AnzahlConnections=SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].cConnections;
					SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections=(MIXERLINE *)calloc(sizeof(MIXERLINE),SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].cConnections);
					SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control=(struct TMixerControls *)calloc(sizeof(struct TMixerConnections),SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].cConnections);
					
					for (ConnectionLoop=0; ConnectionLoop < SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].AnzahlConnections; ConnectionLoop++)
					{
            			SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].cbStruct      = sizeof(MIXERLINE);
						SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwDestination = DestinationLoop;
						SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwSource      = ConnectionLoop;
						mmresult = mixerGetLineInfo((HMIXEROBJ)hMixer,&SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop],MIXER_GETLINEINFOF_SOURCE);
						if ( mmresult == MMSYSERR_NOERROR )
						{
							SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].AnzahlControls=SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].cControls;
							SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl=(MIXERCONTROL *)calloc(sizeof(MIXERCONTROL),SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].AnzahlControls);
							SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail=(MIXERCONTROLDETAILS  *)calloc(sizeof(MIXERCONTROLDETAILS),SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].AnzahlControls);
							MixerLineControl.cbStruct  = sizeof(MixerLineControl);

							MixerLineControl.dwLineID  = SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwLineID;
							MixerLineControl.cControls = SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].cControls;
					
							MixerLineControl.cbmxctrl  = sizeof(MIXERCONTROL);
							MixerLineControl.pamxctrl  = SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl;
							for (ControlLoop=0; ControlLoop < SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].AnzahlControls; ControlLoop++)
							{
								mmresult = mixerGetLineControls((HMIXEROBJ) hMixer,&MixerLineControl,MIXER_GETLINECONTROLSF_ALL);
                 				if ( mmresult == ERROR_SUCCESS)
								{
									// Detail Controls 
									SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cbDetails=0;
									SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].paDetails=NULL;

									switch ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].dwControlType&MIXERCONTROL_CT_UNITS_MASK)
									{
										case MIXERCONTROL_CT_UNITS_BOOLEAN:
											SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cbDetails      = sizeof( MIXERCONTROLDETAILS_BOOLEAN );
											SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].paDetails      = ( MIXERCONTROLDETAILS_BOOLEAN *)calloc(sizeof( MIXERCONTROLDETAILS_BOOLEAN ),MAXCANAL);
											break;
						   						   
										case MIXERCONTROL_CT_UNITS_UNSIGNED:
											SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cbDetails      = sizeof( MIXERCONTROLDETAILS_UNSIGNED );
											SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].paDetails      = ( MIXERCONTROLDETAILS_UNSIGNED *)calloc(sizeof( MIXERCONTROLDETAILS_UNSIGNED ),MAXCANAL);
											break;
									}
                      
									KanalLoop=MAXCANAL;
									while ( KanalLoop > 0 )
									{
										SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cbStruct       = sizeof( MIXERCONTROLDETAILS );
										SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].dwControlID    = SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].dwControlID;
										SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cChannels      = KanalLoop;                     
										SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].cMultipleItems = 0;
	
										if ( Mixer_Get_Control_Values(&SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop],SoundSystemLoop) == ERROR_SUCCESS )
										{
											KanalLoop=0;
											switch ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].dwControlType)
											{
												case MIXERCONTROL_CONTROLTYPE_MUTE:
													if ( Volume.ControlMute == -1 )
													{
														if ( SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_DST_SPEAKERS )
														{
															if (( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_LINE ) ||
																( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwComponentType ==  MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY ))
															{
																Volume.SoundSystem=SoundSystemLoop;
																Volume.Destination=DestinationLoop;
																Volume.Connection=ConnectionLoop;
													 			Volume.ControlMute=ControlLoop;
															} 
														}
													}

													if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].szName[0] == 0x00 )
													{
														strcpy(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].szName,"MUTE ID trouv");
													}
													break;

												case MIXERCONTROL_CONTROLTYPE_VOLUME:
													if ( Volume.SoundSystem == -1 )
													{
														if ( SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_DST_SPEAKERS )
														{
															if (( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_LINE ) ||
																( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwComponentType ==  MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY ))
															{
																Volume.SoundSystem=SoundSystemLoop;
																Volume.Destination=DestinationLoop;
																Volume.Connection=ConnectionLoop;
													 			Volume.Control=ControlLoop;
															} 
														}
													}
													if ( SoundSystem.To_Lines[SoundSystemLoop].MixerLine[DestinationLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_DST_SPEAKERS )
														{
															if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections[ConnectionLoop].dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT )
															{
																Wave.SoundSystem=SoundSystemLoop;
																Wave.Destination=DestinationLoop;
																Wave.Connection=ConnectionLoop;
													 			Wave.Control=ControlLoop;
															} 
														}

													break;

											}
 										}
										else
										{
											if ( KanalLoop == 0 ) strcpy(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl[ControlLoop].szName,"Nicht ladbar");
										}
										KanalLoop--;
									}
								}
							}
						}
					}		  
				}		  
			}
		}
	}
}


void Mixer_Exit( void )
{
	MMRESULT mmresult;
	int SoundSystemLoop;
	int DestinationLoop;
	int ConnectionLoop;
	int ControlLoop;

	if ( hMixer != NULL )
	{
		mmresult=mixerClose(hMixer);
		hMixer=0;
	}

	for ( SoundSystemLoop = 0; SoundSystemLoop < SoundSystem.DeviceAnzahl; SoundSystemLoop++)
	{
		SoundSystem.To_Lines[SoundSystemLoop].MixerLine=(MIXERLINE *)calloc(sizeof(MIXERLINE),SoundSystem.MixerDev[SoundSystemLoop].cDestinations);
		SoundSystem.To_Lines[SoundSystemLoop].To_Connection=(struct TMixerConnections *)calloc(sizeof(struct TMixerConnections),SoundSystem.MixerDev[SoundSystemLoop].cDestinations);

		for (DestinationLoop=0; DestinationLoop < SoundSystem.To_Lines[SoundSystemLoop].AnzahlLines; DestinationLoop++)
		{
			for (ConnectionLoop=0; ConnectionLoop < SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].AnzahlConnections; ConnectionLoop++)
			{
				for (ControlLoop=0; ControlLoop < SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].AnzahlControls; ControlLoop++)
				{
					if (SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].paDetails != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail[ControlLoop].paDetails);
				}     
                if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerControl);
                if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control[ConnectionLoop].MixerDetail);
			}
	        if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].MixerConnections);
      		if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection[DestinationLoop].To_Control);
		}
		if ( SoundSystem.To_Lines[SoundSystemLoop].MixerLine != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].MixerLine);
		if ( SoundSystem.To_Lines[SoundSystemLoop].To_Connection != NULL ) free(SoundSystem.To_Lines[SoundSystemLoop].To_Connection);
	}
	if ( SoundSystem.MixerDev != NULL ) free(SoundSystem.MixerDev);
	if ( SoundSystem.To_Lines != NULL ) free(SoundSystem.To_Lines);
}


static void Mixer_Set_BoolValue( MIXERCONTROLDETAILS *Setting ,int Device ,MIXERCONTROLDETAILS_BOOLEAN *Set )
{
	MMRESULT mmret;
	memcpy(Setting->paDetails,Set,sizeof(MIXERCONTROLDETAILS_BOOLEAN)*4);
	mmret=Mixer_Set_Control_Values(Setting,Device);
}


static void Mixer_Get_BoolValue(  MIXERCONTROLDETAILS *Setting ,int Device ,MIXERCONTROLDETAILS_BOOLEAN *Set)
{
	MMRESULT mmret;
	mmret=Mixer_Get_Control_Values(Setting,Device);
	if(mmret==0)	memcpy(Set,Setting->paDetails,sizeof(MIXERCONTROLDETAILS_BOOLEAN)*4);
}	


void Mixer_Set_UnsignedValue( MIXERCONTROLDETAILS *Setting ,int Device ,MIXERCONTROLDETAILS_UNSIGNED *Set )
{
	MMRESULT mmret;
	memcpy(Setting->paDetails,Set,sizeof(MIXERCONTROLDETAILS_UNSIGNED)*4);
	mmret=Mixer_Set_Control_Values(Setting,Device);
}


void Mixer_Get_UnsignedValue( MIXERCONTROLDETAILS *Setting,int Device ,MIXERCONTROLDETAILS_UNSIGNED *Set )
{
	MMRESULT mmret;
	mmret=Mixer_Get_Control_Values(Setting,Device);
	if(mmret==0)	memcpy(Set,Setting->paDetails,sizeof(MIXERCONTROLDETAILS_UNSIGNED)*4);
}


void Mixer_Get_Volume_Param(void)
{
	MixerVolumeMax=-1;
	MixerVolumeStep=-1;
	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	if ( Volume.SoundSystem < 0 ) return;
	MixerVolumeMax =SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].To_Control[Volume.Connection].MixerControl[Volume.Control].Bounds.dwMaximum;
	MixerVolumeStep=SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].To_Control[Volume.Connection].MixerControl[Volume.Control].Metrics.cSteps;
}


void Mixer_Get_Volume(int *Links, int *Rechts, BOOL Rec)
{
	MIXERCONTROLDETAILS_UNSIGNED UnsignedWert[4];
	struct TMixerAccess VolTemp={-1,0,0,0,-1};
	if(Rec)	VolTemp=Wave;
	else VolTemp=Volume;

	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	if ( VolTemp.SoundSystem < 0 ) return;
	Mixer_Get_UnsignedValue(&SoundSystem.To_Lines[VolTemp.SoundSystem].To_Connection[VolTemp.Destination].To_Control[VolTemp.Connection].MixerDetail[VolTemp.Control],VolTemp.SoundSystem,UnsignedWert);
	*Links=UnsignedWert[0].dwValue;
	*Rechts=UnsignedWert[1].dwValue;
}


void Mixer_Set_Volume(int Links, int Rechts, BOOL Rec)
{
	MIXERCONTROLDETAILS_UNSIGNED UnsignedWert[4];
	struct TMixerAccess VolTemp={-1,0,0,0,-1};
	if(Rec)	VolTemp=Wave;
	else VolTemp=Volume;

	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	if ( VolTemp.SoundSystem < 0 ) return;
	UnsignedWert[0].dwValue=Links;
	UnsignedWert[1].dwValue=Rechts;
	Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[VolTemp.SoundSystem].To_Connection[VolTemp.Destination].To_Control[VolTemp.Connection].MixerDetail[VolTemp.Control],VolTemp.SoundSystem,UnsignedWert);
}


/*void Mixer_Set_Record(int Links, int Rechts)
{
	MIXERCONTROLDETAILS_UNSIGNED UnsignedWert[4];
	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	if ( Record.SoundSystem < 0 ) return;
	UnsignedWert[0].dwValue=Links;
	UnsignedWert[1].dwValue=Rechts;
	Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Record.SoundSystem].To_Connection[Record.Destination].To_Control[Record.Connection].MixerDetail[Record.Control],Record.SoundSystem,UnsignedWert);
}*/


void Mixer_Set_Defaults( void )
{
	//int i;
	//MIXERCONTROLDETAILS_UNSIGNED UnsignedWert[4];
	if ( SoundSystem.DeviceAnzahl == 0 ) return;
}


void Mixer_Mute(void)
{
	MIXERCONTROLDETAILS_BOOLEAN BoolWert[4];
	if ( Volume.ControlMute < 0 ) return;
	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	BoolWert[0].fValue =1;
	BoolWert[1].fValue =1;
	BoolWert[2].fValue =1;
	BoolWert[3].fValue =1;
	Mixer_Set_BoolValue(&SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],Volume.SoundSystem,BoolWert);
}


void Mixer_UnMute(void)
{
	MIXERCONTROLDETAILS_BOOLEAN BoolWert[4];
	if ( Volume.ControlMute < 0 ) return;
	if ( SoundSystem.DeviceAnzahl == 0 ) return;
	BoolWert[0].fValue =0;
	BoolWert[1].fValue =0;
	BoolWert[2].fValue =0;
	BoolWert[3].fValue =0;
	Mixer_Set_BoolValue(&SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[Volume.Destination].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],Volume.SoundSystem,BoolWert);
}


BOOL APIENTRY MixerSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	int i,C1,C2,C3;
	HWND hVolumePlay = GetDlgItem( hDlg, IDC_S1 );
	HWND hVolumeRec = GetDlgItem( hDlg, IDC_S2 );
	HWND hVolumeWave = GetDlgItem( hDlg, IDC_S3 );

	//int ret;

	char Text[128];

	MIXERCONTROLDETAILS_BOOLEAN BoolWert[4];
	MIXERCONTROLDETAILS_UNSIGNED UnsignedWert[4];


	switch (message)
	{
		case WM_INITDIALOG:
			CheckDlgButton(hDlg, IDC_CHECK1, USE_MIXER);
			SendMessage(hDlg,WM_USER,1,0);
			break;

	    case WM_VSCROLL:
			if(USE_MIXER)
			{
				if((HWND)lParam == hVolumePlay)
				{
					MIXER_CANAL_GD = -SendMessage( hVolumePlay,   TBM_GETPOS, 0, 0 );
					MIXER_CANAL_GAUCHE=MIXER_CANAL_GD;
					MIXER_CANAL_DROIT=MIXER_CANAL_GD;
					Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
					sprintf(Text,"%d %%",(int)(((float)MIXER_CANAL_GD/MixerVolumeMax)*100));
					SetDlgItemText(hDlg,IDC_D1,Text);
				}
				else if((HWND)lParam == hVolumeRec)
				{
					VolumeIn = -SendMessage( hVolumeRec,   TBM_GETPOS, 0, 0 );
					if ( Record.SoundSystem >= 0 )
					{
						UnsignedWert[0].dwValue=VolumeIn;
						UnsignedWert[1].dwValue=VolumeIn;
						Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Record.SoundSystem].To_Connection[Record.Destination].To_Control[Record.Connection].MixerDetail[0],Record.SoundSystem,UnsignedWert);
						sprintf(Text,"%d %%",(int)(((float)VolumeIn/MixerVolumeMax)*100));
						SetDlgItemText(hDlg,IDC_D2,Text);
					}
				}
				else if((HWND)lParam == hVolumeWave)
				{
					VolumeOut = -SendMessage( hVolumeWave,   TBM_GETPOS, 0, 0 );
					if ( Wave.SoundSystem >= 0 )
					{
						Mixer_Set_Volume(VolumeOut,VolumeOut,TRUE);
						sprintf(Text,"%d %%",(int)(((float)VolumeOut/MixerVolumeMax)*100));
						SetDlgItemText(hDlg,IDC_D3,Text);
					}
				}
			}
			break;
	
		case WM_USER:

			if ( wParam == 1 )
			{
				if (( SoundSystem.DeviceAnzahl == 0 ) || ( !USE_MIXER ))
				{
					ShowWindow(GetDlgItem(hDlg,IDC_COMBO1),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_COMBO2),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_COMBO3),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_CHECK2),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_S1),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_S2),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_S3),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_D1),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_D2),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,IDC_D3),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT1),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT2),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT3),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT4),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT5),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT6),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT7),SW_HIDE);
					ShowWindow(GetDlgItem(hDlg,TEXT8),SW_HIDE);
					break;
				}
				ShowWindow(GetDlgItem(hDlg,IDC_COMBO1),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_COMBO2),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_COMBO3),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_CHECK2),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_S1),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_S2),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_S3),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_D1),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_D2),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_D3),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT1),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT2),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT3),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT4),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT5),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT6),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT7),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,TEXT8),SW_SHOW);

				ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
				ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO2));
				ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO3));
	
				if(USE_MIXER)
				{
			        for ( i =0; i < SoundSystem.DeviceAnzahl ; i++ )
					{
						ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO1), (LONG)(LPSTR)SoundSystem.MixerDev[i].szPname);
					}
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1), Volume.SoundSystem); 
	
					for ( i=0; i < SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[0].AnzahlConnections; i++ )
					{
						ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO2), (LONG)(LPSTR)SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[0].MixerConnections[i].szName);
					}
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO2), Volume.Connection); 
		
					for ( i=0; i < SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[1].AnzahlConnections; i++ )
					{
						ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO3), (LONG)(LPSTR)SoundSystem.To_Lines[Volume.SoundSystem].To_Connection[1].MixerConnections[i].szName);
					}
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO3), Record.Connection); 
	
					MIXER_CANAL_GD=(MIXER_CANAL_GAUCHE+MIXER_CANAL_DROIT)/2;

					C1=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
					if(Volume.ControlMute!=-1) 
					{
						Mixer_Get_BoolValue(&SoundSystem.To_Lines[C1].To_Connection[0].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],C1,BoolWert);
						CheckDlgButton(hDlg, IDC_CHECK2, BoolWert[0].fValue);
					}
	
					SendMessage( hVolumePlay, TBM_SETRANGEMAX, TRUE, 0 );
					SendMessage( hVolumePlay, TBM_SETRANGEMIN, TRUE, -MixerVolumeMax );
					SendMessage( hVolumePlay, TBM_SETTICFREQ, MixerVolumeMax/16, 0 );
					SendMessage( hVolumePlay,   TBM_SETPOS, TRUE, -MIXER_CANAL_GD );
					sprintf(Text,"%d %%",(int)(((float)MIXER_CANAL_GD/MixerVolumeMax)*100));
					SetDlgItemText(hDlg,IDC_D1,Text);
	
					SendMessage( hVolumeRec, TBM_SETRANGEMAX, TRUE, 0 );
					SendMessage( hVolumeRec, TBM_SETRANGEMIN, TRUE, -MixerVolumeMax );
					SendMessage( hVolumeRec, TBM_SETTICFREQ, MixerVolumeMax/16, 0 );
					SendMessage( hVolumeRec,   TBM_SETPOS, TRUE, -VolumeIn );
					sprintf(Text,"%d %%",(int)(((float)VolumeIn/MixerVolumeMax)*100));
					SetDlgItemText(hDlg,IDC_D2,Text);
		
					Mixer_Get_Volume(&VolumeOut,&VolumeOut,TRUE);
					SendMessage( hVolumeWave, TBM_SETRANGEMAX, TRUE, 0 );
					SendMessage( hVolumeWave, TBM_SETRANGEMIN, TRUE, -MixerVolumeMax );
					SendMessage( hVolumeWave, TBM_SETTICFREQ, MixerVolumeMax/16, 0 );
					SendMessage( hVolumeWave,   TBM_SETPOS, TRUE, -VolumeOut );
					sprintf(Text,"%d %%",(int)(((float)VolumeOut/MixerVolumeMax)*100));
					SetDlgItemText(hDlg,IDC_D3,Text);
				}
			}

			if ( wParam == 2 && USE_MIXER)
			{
				C1=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
				if (( C1 >= 0 ) && ( C1 < SoundSystem.DeviceAnzahl ))
				{
					ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO2));
					ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO3));
		
					for ( i=0; i < SoundSystem.To_Lines[C1].To_Connection[0].AnzahlConnections; i++ )
					{
						ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO2), (LONG)(LPSTR)SoundSystem.To_Lines[C1].To_Connection[0].MixerConnections[i].szName);
					}
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO2), 0); 
		
					for ( i=0; i < SoundSystem.To_Lines[C1].To_Connection[1].AnzahlConnections; i++ )
					{
						ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO3), (LONG)(LPSTR)SoundSystem.To_Lines[C1].To_Connection[1].MixerConnections[i].szName);
					}
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO3), 0); 

					SendMessage( hVolumePlay,   TBM_SETPOS, TRUE, MIXER_CANAL_GD );
				}
			}


			if ( wParam == 3 && USE_MIXER)
			{
			    C1=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
     			C2=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO2));
				if (( C2 >= 0 ) && ( C2 < SoundSystem.To_Lines[C1].To_Connection[0].AnzahlConnections ))
				{
					Volume.SoundSystem = C1;
		            Volume.Destination = 0;
			        Volume.Connection = C2; 
				    Volume.Control = 0;
					Volume.ControlMute = 1;

					Mixer_Get_Volume(&MIXER_CANAL_GAUCHE,&MIXER_CANAL_DROIT,FALSE);
					MIXER_CANAL_GD=(MIXER_CANAL_GAUCHE+MIXER_CANAL_DROIT)/2;
					SendMessage( hVolumePlay,   TBM_SETPOS, TRUE, -MIXER_CANAL_GD );
					sprintf(Text,"%d %%",(int)(((float)MIXER_CANAL_GD/MixerVolumeMax)*100));
					SetDlgItemText(hDlg,IDC_D1,Text);
					if(Volume.ControlMute!=-1) 
					{
						Mixer_Get_BoolValue(&SoundSystem.To_Lines[C1].To_Connection[0].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],C1,BoolWert);
						CheckDlgButton(hDlg, IDC_CHECK2, BoolWert[0].fValue);
					}
				}
			}

			if ( wParam == 4 && USE_MIXER)
			{
			    C1=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
     			C3=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO3));
				if (( C3 >= 0 ) && ( C3 < SoundSystem.To_Lines[C1].To_Connection[1].AnzahlConnections ))
				{
					Record.SoundSystem = C1;
					Record.Destination = 1;
					Record.Connection = C3; 
					Record.Control = 1;
					Record.ControlMute=1;
				}
			}
            break;

		case WM_COMMAND:

			switch (LOWORD(wParam))
			{
				case IDC_COMBO1:
					if ( HIWORD( wParam ) == CBN_SELCHANGE  ) SendMessage(hDlg,WM_USER,2,0);
                    break;

				case IDC_COMBO2:
                    if ( HIWORD( wParam ) == CBN_SELCHANGE  ) SendMessage(hDlg,WM_USER,3,0);
                    break;
			
				case IDC_COMBO3:
                    if ( HIWORD( wParam ) == CBN_SELCHANGE  ) SendMessage(hDlg,WM_USER,4,0);
                    break;

				case IDC_CHECK1:
					if (IsDlgButtonChecked(hDlg, IDC_CHECK1))
					{
						if ( SoundSystem.DeviceAnzahl == 0 ) Mixer_Enumerate_Sound_SubSystem();
						if ( SoundSystem.DeviceAnzahl > 0 )
						{
							if ( MIXER_CANAL_GAUCHE == -1 ) Mixer_Get_Volume(&MIXER_CANAL_GAUCHE,&MIXER_CANAL_DROIT,FALSE);
							Mixer_Set_Defaults();
							Mixer_Get_Volume_Param();
							Mixer_Set_Volume(MIXER_CANAL_GAUCHE,MIXER_CANAL_DROIT,FALSE);
							USE_MIXER=TRUE;
						 }
					}
					else
					{
						USE_MIXER=FALSE;
					}	 
					SendMessage(hDlg,WM_USER,1,0);
					break;

				case IDC_CHECK2:
					if(Volume.ControlMute==-1  && !USE_MIXER) break;
				    C1=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
					if (IsDlgButtonChecked(hDlg, IDC_CHECK2))
					{
						BoolWert[0].fValue =1;
						BoolWert[1].fValue =1;
						BoolWert[2].fValue =1;
						BoolWert[3].fValue =1;
						Mixer_Set_BoolValue(&SoundSystem.To_Lines[C1].To_Connection[0].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],C1,BoolWert);
					}
					else
					{
						BoolWert[0].fValue =0;
						BoolWert[1].fValue =0;
						BoolWert[2].fValue =0;
						BoolWert[3].fValue =0;
						Mixer_Set_BoolValue(&SoundSystem.To_Lines[C1].To_Connection[0].To_Control[Volume.Connection].MixerDetail[Volume.ControlMute],C1,BoolWert);
					}
					break;
						

				case IDOK:		 
				case IDCANCEL:		 
					EndDialog(hDlg,TRUE);
					break;
			}
	        return(TRUE);
	}
	return(FALSE);
}

