/////////////////////////////////////////////////////////////////////////////
// Mixerdev.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef MIXERDEV_H
#define MIXERDEV_H

#include <mmsystem.h>

#define MAXCANAL 4

struct TMixerAccess
{
    int SoundSystem;
    int Destination;
    int Connection;
    int Control;
	int ControlMute;
};

struct TMixerValues
{
    int Kanal1;
    int Kanal2;
    int Kanal3;
    int Kanal4;
};


extern struct TMixerAccess Volume;
extern struct TMixerAccess Wave;
extern struct TMixerAccess Record;
 

struct TMixerControls
{
             int AnzahlControls;
	         MIXERCONTROL          *MixerControl;
             MIXERCONTROLDETAILS   *MixerDetail;
};

struct TMixerConnections
{
	        int AnzahlConnections;
			MIXERLINE *MixerConnections;
			struct TMixerControls *To_Control;
};


struct TMixerLines
{
	        int AnzahlLines;
			MIXERLINE *MixerLine;
			struct TMixerConnections *To_Connection;
};



struct TSoundSystem {
	    int DeviceAnzahl;
        MIXERCAPS *MixerDev;
		struct TMixerLines *To_Lines;
};


extern struct TSoundSystem SoundSystem;

extern BOOL System_In_Mute;
extern BOOL USE_MIXER;
extern int  MIXER_CANAL_GAUCHE;
extern int  MIXER_CANAL_DROIT;
extern int MixerVolumeStep;
extern int MixerVolumeMax;



BOOL APIENTRY MixerSettingProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
void Mixer_Enumerate_Sound_SubSystem(void);
void Mixer_Get_Volume(int *Links, int *Rechts, BOOL Rec);
void Mixer_Set_Volume(int Links, int Rechts, BOOL Rec);
void Mixer_Get_Volume_Param(void);
void Mixer_Set_Defaults( void );
void Mixer_Mute(void);
void Mixer_UnMute(void);
void Mixer_Exit( void );


#endif