/////////////////////////////////////////////////////////////////////////////
// OSD.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
//
// OSD parts based on DScaler Copyright (c) 2000 John Adcock.  All rights reserved.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __OSD_H___
#define __OSD_H___

#include "Dscaler/DS_Control.h"


// Make sure that the timer ID does not conflict with those in DTV.H
#define OSD_TIMER_ID            42
#define OSD_TIMER_ID_TOP        43
#define OSD_TIMER_ID_TOP_MINI   44
#define OSD_TIMER_ID_CENTER     45
#define OSD_TIMER_DELAY         4000
#define OSD_TIMER_DELAY2        8000
#define OSD_TIMER_REFRESH_ID    41
#define OSD_TIMER_REFRESH_DELAY 750

#define OSD_MAX_TEXT            64

// Values for "ShowType" parameter in functions OSD_Show and OSD_RefreshInfosScreen
#define OSD_PERSISTENT      1
#define OSD_AUTOHIDE        2
#define OSD_REFRESH_DATA    3

enum eOSDTextXPos
{
    OSD_XPOS_LEFT = 0,
    OSD_XPOS_RIGHT,
    OSD_XPOS_CENTER,
};

typedef struct
{
    char            szText[512];        // Text of OSD
    double          Size;               // Size of OSD as percentage of screen height
    long            TextColor;          // Text color (RGB)
    long            BackgroundColor;    // Background color (RGB)
    eOSDBackground  BackgroundMode;     // Background mode
    eOSDTextXPos    TextXPos;           // Text position / Xpos
    double          XPos;               // X position (0 = left, 1 = right)
    double          YPos;               // Y position (0 = top, 1 = bottom)
    RECT            CurrentRect;        // MRS 2-24-01 Saves the current drawn rectangle (used to limit invalidation area)
} TOsdInfo;

extern BOOL Enable_OSD;
extern BOOL bAntiAlias;

void OSD_ClearAllTexts();
void OSD_AddText(LPCTSTR szText, double Size, long NewTextColor, long BackgroundColor, eOSDBackground BackgroundMode, eOSDTextXPos TextXPos, double XPos, double YPos, int NbTextForce);
void OSD_Show(HWND hWnd, int ShowType, int refresh_delay, int ID);
void OSD_ShowText(HWND hWnd, LPCTSTR szText, double Size);
void OSD_ShowTextPersistent(HWND hWnd, LPCTSTR szText, double Size);
void OSD_ShowTextOverride(HWND hWnd, LPCTSTR szText, double Size);
void OSD_Redraw(HWND hWnd, HDC hDC);
void OSD_Clear(HWND hWnd, int Type);

// Spcifique K!TV
void OSD_ShowText_Top(HWND hWnd, LPCTSTR szText);
void OSD_ShowText_TopMini(HWND hWnd, LPCTSTR szText, double dSize, BOOL bPersistent);
void OSD_ShowText_Center(HWND hWnd, LPCTSTR szText);
void OSD_GeneralInfo();

#endif
