/////////////////////////////////////////////////////////////////////////////
// Procs.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "K!TV-XP.h"     
#include "bt848.h"
#include "mixerdev.h"
#include "btaudio.h"
#include "procs.h"
#include "osd.h"
#include "plugin.h"
#include "vbi-vt.h"
#include "ddraw.h"
#include "thread.h"
#include "misc.h"
#include "hardwaremisc.h"
#include "coderisc.h"
#include "IR_haup.h"
#include "externe/HtmlHelp.H"
#include "VBI_VideoText.h"
#include "versionno.h"
#include "settings.h"

#define RESET_LIST           1802

BOOL LINK_UV=TRUE;
int  TVolume=800;
static int EditProgram;		// ne pas dplacer



BOOL APIENTRY SplashProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	switch (message)
	{
        case WM_INITDIALOG: 
			InvalidateRect(hDlg,NULL,TRUE); 
			SetTimer(hDlg,TIMER_SPLASHBOX,5000,NULL);
            return(TRUE);
 
        case WM_TIMER:

			if ( wParam == TIMER_SPLASHBOX )
			{
				KillTimer(hDlg,TIMER_SPLASHBOX);
                EndDialog(hDlg,0);
			}
			return(FALSE);
    }
    return (FALSE);
	UNREFERENCED_PARAMETER(lParam);
}


BOOL APIENTRY Langue_SelectProc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
	int i;

	switch (message)
	{
        case WM_INITDIALOG:
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
			for (i = 0; i < TotalLangages; i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO1), (LONG)(LPSTR)Langages[i].Lang);
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1), AppLang); 
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					i = ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
					Langue_ChangeLang(i,FALSE);

				case IDCANCEL:
					EndDialog(hDlg,0);
			}
			break;
	}
	return FALSE;
}


static BOOL APIENTRY ProgramEditProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	char ligne[140];
    unsigned long freq;
	float ffreq;
	int i;
	static int tmpsrc=0, tmpformat=0;

	switch (message)
	{
		case WM_INITDIALOG:
			tmpsrc=Program[EditProgram].Source;
			tmpformat=Program[EditProgram].Format;
			SetDlgItemInt(hDlg,IDC_PRGNR,EditProgram,FALSE);
            SetDlgItemText(hDlg,IDC_EDIT1,Program[EditProgram].Name);
			sprintf(ligne,"%10.3f",(float)Program[EditProgram].freq/1000);
            SetDlgItemText(hDlg,IDC_EDIT2,ligne);
		
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_FORMAT));
			if(Program[EditProgram].Source==0)
			{
				ComboBox_AddString(GetDlgItem(hDlg,IDC_FORMAT), (LONG)(LPSTR)Langue_GetString(ID_PROC_SAMETUNER));
				for(i=0;i<(sizeof(TVSettings) / sizeof(TVSettings[0]));i++)
					ComboBox_AddString (GetDlgItem(hDlg,IDC_FORMAT), (long)TVSettings[i].Name);
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FORMAT), tmpformat+1); 
			}
			else
			{
				for(i=0;i<(sizeof(TVSettings) / sizeof(TVSettings[0]));i++)
					ComboBox_AddString(GetDlgItem(hDlg,IDC_FORMAT), (long)TVSettings[i].Name);
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FORMAT), tmpformat); 
			}

			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_SOURCE));
			for(i=0;i<5;i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_SOURCE), (LONG)(LPSTR)ChaineVideoSource[i]);
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_SOURCE), tmpsrc); 
            
			if(Program[EditProgram].Active)
				CheckDlgButton(hDlg, IDC_ACTIVE, TRUE);
			
			return(TRUE);

        case WM_COMMAND:
						
			switch(LOWORD(wParam))
			{

			case IDC_FORMAT:
				tmpformat=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_FORMAT));
				if(tmpsrc==0)
				{
					if(tmpformat==0)
					{
						SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+(Tuners[TunerType].format),0);
					}
					else
					{
						SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL - 1 + tmpformat,0);
					}
				}
				else
				{
					SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+tmpformat,0);
				}
				break;

			case IDC_SOURCE:
				if(ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_SOURCE))==0)
				{
					ComboBox_ResetContent(GetDlgItem(hDlg,IDC_FORMAT));
					ComboBox_AddString(GetDlgItem(hDlg,IDC_FORMAT), (LONG)(LPSTR)Langue_GetString(ID_PROC_SAMETUNER));
					for(i=0;i<(sizeof(TVSettings) / sizeof(TVSettings[0]));i++)
						ComboBox_AddString(GetDlgItem(hDlg,IDC_FORMAT), (long)TVSettings[i].Name);
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FORMAT), 0); 
					tmpformat=0;
				}
				else if(ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_SOURCE))!=0)
				{
					ComboBox_ResetContent(GetDlgItem(hDlg,IDC_FORMAT));
					for(i=0;i<(sizeof(TVSettings) / sizeof(TVSettings[0]));i++)
						ComboBox_AddString(GetDlgItem(hDlg,IDC_FORMAT), (long)TVSettings[i].Name);
					tmpformat=TVTYPE;
					ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FORMAT), tmpformat); 
				}
				tmpsrc=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_SOURCE));
				SendMessage(hDlg,WM_COMMAND,IDC_FORMAT,0);
				BT8X8_SetVideoSource(tmpsrc);
				break;

			case IDOK:

				GetDlgItemText(hDlg,IDC_EDIT1,ligne,sizeof(ligne)); 
				if(strlen(ligne)==0)
				{
					MessageBox(hWnd, Langue_GetString(ID_PROC_ERRLABEL), "K!TV - Erreur", MB_ICONWARNING|MB_OK);
					break;
				}
				else
				{
					GetDlgItemText(hDlg,IDC_EDIT2,ligne,sizeof(ligne));
					ffreq=(float)atof(ligne);
					if(ffreq==0 && tmpsrc==0)
					{
						MessageBox(hWnd, Langue_GetString(ID_PROC_ERRTUNER), "K!TV - Erreur",MB_ICONWARNING|MB_OK);
						break;
					}
					GetDlgItemText(hDlg,IDC_EDIT1,Program[EditProgram].Name,sizeof(Program[EditProgram].Name)); 
					if (ffreq<0) ffreq=-ffreq;
					freq=(unsigned	long)(ffreq*1000);
					Program[EditProgram].freq=freq;

					if(IsDlgButtonChecked(hDlg, IDC_ACTIVE))	Program[EditProgram].Active=TRUE;
					else Program[EditProgram].Active=FALSE;

					Program[EditProgram].Source=tmpsrc;

					if(tmpformat!=-1)
					{
						if(tmpsrc==0)	Program[EditProgram].Format=tmpformat-1;
						else	Program[EditProgram].Format=tmpformat;	
					}
					KillTimer(hDlg,0);
					Channel_Write_Program_List();
					if(Has_MSP)	Audio_MSP_Watch_Mode();
					EndDialog(hDlg,TRUE);
				}
				break;
			
			case IDTEST:
				if (tmpsrc!=0)	break;
				GetDlgItemText(hDlg,IDC_EDIT2,ligne,sizeof(ligne));
				ffreq=(float)atof(ligne);
				freq=(unsigned	long)(ffreq*1000);
				Tuner_SetFrequency(TunerType,MulDiv(freq*1000,16,1000000));
				if(Has_MSP)	Audio_MSP_Watch_Mode();
				break;

			case IDB_FPLUS:
				if (tmpsrc!=0)	break;
				GetDlgItemText(hDlg,IDC_EDIT2,ligne,sizeof(ligne));
				ffreq=(float)atof(ligne);
				ffreq=ffreq+(float)0.05;
				freq=(unsigned	long)(ffreq*1000);
				Tuner_SetFrequency(TunerType,MulDiv(freq*1000,16,1000000));
				sprintf(ligne,"%10.3f",(float)ffreq);
				SetDlgItemText(hDlg,IDC_EDIT2,ligne);
				break;

			case IDB_FMINUS:
				if (tmpsrc!=0)	break;
				GetDlgItemText(hDlg,IDC_EDIT2,ligne,sizeof(ligne));
				ffreq=(float)atof(ligne);
				if(ffreq<0) ffreq=-ffreq;
				ffreq=ffreq-(float)0.05;
				freq=(unsigned	long)(ffreq*1000);
				Tuner_SetFrequency(TunerType,MulDiv(freq*1000,16,1000000));
				sprintf(ligne,"%10.3f",(float)ffreq);
				SetDlgItemText(hDlg,IDC_EDIT2,ligne);
				break;

            case IDCANCEL:
				BT8X8_SetVideoSource(Program[EditProgram].Source);
				if(Program[EditProgram].Format==0)
				{
					SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL+(Tuners[TunerType].format),0);
				}
				else
				{
					SendMessage(hWnd,WM_COMMAND, IDM_TYPEFORMAT_PAL - 1 + Program[EditProgram].Format,0);
				}
				if(Program[EditProgram].Source==0)	Tuner_SetFrequency(TunerType,MulDiv(Program[EditProgram].freq*1000,16,1000000));
				KillTimer(hDlg,0);
				EndDialog(hDlg,TRUE);
				break;
			}
			break;
	}
    return (FALSE);
    UNREFERENCED_PARAMETER(lParam);
}


static BOOL APIENTRY ChannelScanProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	char ligne[80];

	int i,j;

    PAINTSTRUCT wps;                   // paint structure
    HDC hdc;
    HDC             hMemDC;
    HBITMAP         hOldBm=NULL;
	BITMAP bm;

	static BOOL STOP;
    static unsigned int Freq;
    static int ChannelNr,ChannelNb;
    static unsigned int FirstFreq=0;
	static HBITMAP	LampeRouge,LampeVerte;

	MSG msg;
	char *ErrFreq = Langue_GetString(ID_PROC_ERRFREQ);

	switch (message)
	{
        case WM_INITDIALOG:
			LampeRouge = LoadBitmap(hInst,"Lampe_Rouge");
			LampeVerte =LoadBitmap(hInst,"Lampe_Verte");
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
            for ( i=0; i< 35; i++ )
				if (  Countries[i].Name[0]!=0x00 )
					ComboBox_InsertString(GetDlgItem(hDlg,IDC_COMBO1),i, (LPARAM)(LPSTR)Countries[i].Name);
					
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1),CountryCode);
            Channel_Load_Country_Specific_Settings(CountryCode);
            CheckDlgButton(hDlg, IDC_CHECK1, TRUE);
			ChannelNb=Channels.MinChannel;
			if ( !USETUNER ) EnableWindow(GetDlgItem(hDlg,IDSTART),TRUE);

			return(TRUE);

        case WM_PAINT:
	        hdc = BeginPaint(hDlg,&wps);
			hMemDC = CreateCompatibleDC(hdc);
            if ( VideoPresent() ) hOldBm = (HBITMAP)SelectObject(hMemDC, LampeVerte);
			else hOldBm = (HBITMAP)SelectObject(hMemDC, LampeRouge );
            GetObject(LampeVerte, sizeof(BITMAP), (LPSTR)&bm);

			BitBlt(hdc, 83, 90, bm.bmWidth, bm.bmHeight,hMemDC, 0, 0, SRCCOPY);// Signal

			SelectObject(hMemDC,hOldBm);
	        DeleteDC(hMemDC);
			DeleteDC(hdc);
            EndPaint(hDlg,&wps);
			return(FALSE);

		case WM_USER:
			if ( wParam == 0x101 )
			{
				if(Freq > 0)
				{
					sprintf(ligne,"%3.2f",(float)Freq/1000);
		            SetDlgItemText(hDlg,IDC_EDIT2,ligne);
					sprintf(ligne,"%d",ChannelNb);
		            SetDlgItemText(hDlg,IDC_EDIT3,ligne);
			        SetDlgItemText(hDlg,IDC_TEXT20, Langue_GetString(ID_PROC_CHAN_SCAN));
					InvalidateRect(hDlg,NULL,FALSE);
					UpdateWindow(hDlg);
					i=0;
					if (IsDlgButtonChecked(hDlg,IDC_CHECK1)) Sleep(400);
					SetDlgItemText(hDlg,IDC_TEXT20,"Synchronise");
					while ( (i < 75) && (!VideoPresent()) )
					{
						i++;
						if ( PeekMessage(&msg,NULL,0,0xffffffff,PM_REMOVE) )
						{
							SendMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);
						}
						if ( STOP ) return(TRUE);
						Sleep(1);
					}
	
					InvalidateRect(hDlg,NULL,FALSE);
					UpdateWindow(hDlg);
	
					if  ( VideoPresent() )
					{
						if ( FirstFreq == 0 ) FirstFreq=Freq;
						SetDlgItemText(hDlg,IDC_TEXT20, Langue_GetString(ID_PROC_SIGNALFOUND));
	                  	VPSLastName[0]=0x00;
						VT_ResetStation();
						Sleep(1000);
	                    j=1;
						while (( j < MAXPROGS) &&  ( Program[j].freq != Freq )) j++;
							
						if ( j >= MAXPROGS )
						{
							j=1;
							while (( j < MAXPROGS) &&  ( Program[j].Name[0]!=0x00 )) j++;
							if ( j > MAXPROGS )
							{
								MessageBox(hWnd, Langue_GetString(ID_PROC_NOPLACE), "K!TV XP",MB_ICONINFORMATION|MB_OK);
								return(TRUE);	
							}
						}
 						Program[j].freq=Freq;
	                    strcpy(Program[j].Name, Langue_GetString(ID_NOPDC));
						Freq=Freq+2500;
						if ( Capture_VBI )
						{
							i=0;
							while ( i < 100 )
							{
				 				if ( PeekMessage(&msg,NULL,0,0xffffffff,PM_REMOVE) )
								{
	            					SendMessage(msg.hwnd,msg.message,msg.wParam,msg.lParam);
								}
								Sleep(2);
								if ( VPSLastName[0] != 0x00 )
								{
									strcpy(Program[j].Name,VPSLastName);
									i=100;
								}
								else if ( VT_GetStation()[0] != 0x00 && !(strcmp(VT_GetStation(),"                    ")==0) )
								{
									strcpy(Program[j].Name, VT_GetStation());
									i=100;
								}
								i++;
							}  
						} 
						Program[j].Format=-1;
						Program[j].Source=0;
						Program[j].Active=TRUE;
						SetDlgItemText(hDlg,IDC_EDIT15,Program[j].Name);
					}
				}
				ChannelNb++;

				if ( STOP ) return(TRUE);
				
				if ( IsDlgButtonChecked(hDlg,IDC_CHECK1))
				{
					ChannelNr++;
					if ( ChannelNr < Channels.MaxChannel )
					{
						Freq=Channels.freq[ChannelNr];
                 		if(!Tuner_SetFrequency(TunerType,MulDiv((Freq*1000),16,1000000)))
						{   
        					StatusBar_Display(ErrFreq, (float)Freq/1000);
							return(TRUE);
						} 
					if ( !STOP ) PostMessage(hDlg,WM_USER,0x101,0);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDSTART),TRUE);
	                    if ( FirstFreq != 0 )  (void)Tuner_SetFrequency(TunerType,MulDiv((FirstFreq*1000),16,1000000));
					}
				}
				else
				{
					if( Freq < 870000 )
					{
						Freq=Freq+250;
                 		if(!Tuner_SetFrequency(TunerType,MulDiv((Freq*1000),16,1000000)))
						{   
        					StatusBar_Display(ErrFreq, (float)Freq/1000);
							return(TRUE);
						} 
						if ( !STOP ) PostMessage(hDlg,WM_USER,0x101,0);
					}
					else
					{
						EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDSTART),TRUE);
						if ( FirstFreq != 0 )  (void)Tuner_SetFrequency(TunerType,MulDiv((FirstFreq*1000),16,1000000));
					}
				}
			}
			break;
        
		case WM_COMMAND:
			
			if  ((HWND)lParam == GetDlgItem(hDlg,IDC_COMBO1))
			{
    			if (HIWORD(wParam)==CBN_SELCHANGE)
				{
					CountryCode=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
					Channel_Load_Country_Specific_Settings(CountryCode);
				}
			}
			
			if (LOWORD(wParam) == IDSTART )
			{
				if ( IsDlgButtonChecked(hDlg,IDC_CHECK1))
				{
					Freq=Channels.freq[0];
                    ChannelNr = 0 ;
					ChannelNb=Channels.MinChannel;
				}
				else 
				{
                    Freq = 41250;
				}
               
				STOP=FALSE;
				sprintf(ligne,"%10.2f",(float)Freq/1000);
				SetDlgItemText(hDlg,IDC_EDIT2,ligne);

 				BT8X8_SetVideoSource(0);
				if(!Tuner_SetFrequency(TunerType,MulDiv((Freq*1000),16,1000000)))
				{   
					StatusBar_Display(ErrFreq, (float)Freq/1000);
				} 
	
				KillTimer(hWnd,TIMER_STATUS); 	
				PostMessage(hDlg,WM_USER,0x101,0);
				EnableWindow(GetDlgItem(hDlg,IDSTART),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDOK),FALSE);
			}

            if ( LOWORD(wParam) == IDOK)
			{
				Channel_Write_Program_List();
				DeleteObject(LampeRouge);
				DeleteObject(LampeVerte);
				DeleteObject(hOldBm);
				EndDialog(hDlg,TRUE);
				SendMessage(hDlg,WM_COMMAND,IDM_RESET,0);
			}

            if ( LOWORD(wParam) == IDCANCEL)
			{
				STOP=TRUE;
                Channel_Load_Program_List();
                SetTimer (hWnd, TIMER_STATUS, 2000, NULL);
				DeleteObject(LampeRouge);
				DeleteObject(LampeVerte);
				DeleteObject(hOldBm);
				EndDialog(hDlg,TRUE);
			}
			break;
	}
	return (FALSE);
    UNREFERENCED_PARAMETER(lParam);
}


BOOL APIENTRY ProgramListProc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
	int i,j;
    struct TProgram save;
	char ligne[140];
	static BOOL NextBlock=FALSE;
	static int CurSel;
	static HWND ProgList;

    switch (message)
	{
        case WM_INITDIALOG:
			ProgList=GetDlgItem(hDlg,IDC_LIST1);
 			SetCapture(hDlg);
			CurSel=CurrentProgram-1;
			EditProgram=CurrentProgram;

		case RESET_LIST:
			SetDlgItemText(hDlg,IDC_NAME,Program[CurrentProgram].Name);

			sprintf(ligne,"%d",CurrentProgram);
			SetDlgItemText(hDlg,IDC_PRGNR,ligne);

			Channel_Change(FALSE);
			if(Program[CurrentProgram].Format!=-1)	SetDlgItemText(hDlg,IDC_FORMAT,TVSettings[Program[CurrentProgram].Format].Name);
			if(Program[CurrentProgram].Source==0)
			{
				if(Program[CurrentProgram].Format==-1)
				{
					strcpy(ligne, Langue_GetString(ID_PROC_SAMETUNER));
					SetDlgItemText(hDlg,IDC_FORMAT,ligne);
				}

				sprintf(ligne,"%3.3f",(float)Program[CurrentProgram].freq/1000);
				SetDlgItemText(hDlg,IDC_FREQUENCY,ligne);

				ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY),SW_SHOW);
				ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY2),SW_SHOW);
				strcpy(ligne, "Tuner");
			}
			else
			{
				strcpy(ligne, ChaineVideoSource[Program[CurrentProgram].Source]);
				ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY),SW_HIDE);
				ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY2),SW_HIDE);
			}
			SetDlgItemText(hDlg,IDC_SOURCE,ligne);

			if(Program[CurrentProgram].Active)	strcpy(ligne, Langue_GetString(ID_YES));
			else 	strcpy(ligne, Langue_GetString(ID_NO));
			SetDlgItemText(hDlg,IDC_ACTIVE,ligne);
            
	        ListBox_ResetContent(ProgList);

			i=1;
			while ( i < MAXPROGS )
			{
                if ( Program[i].Name[0]!=0x00 )
				{
                ListBox_AddString(ProgList, Program[i].Name);
				}
				i++;
			}
	        SetFocus(ProgList); 
            ListBox_SetCurSel(ProgList, CurSel);
			break;


        case WM_VKEYTOITEM:
			if ( (HWND)lParam == ProgList )
			{
				NextBlock=TRUE;
				i=LOWORD(wParam);
                if ( ( i == VK_ADD ) && ( EditProgram < ListBox_GetCount(ProgList) ) )// +
				{ 
					EditProgram++;
				}
                else if ( ( i	== VK_SUBTRACT ) && ( EditProgram > 1 ) )// -
				{ 
					EditProgram--;
				}

			}
			break;


        case WM_COMMAND:

			if ( (HWND)lParam==ProgList )
			{
				if (HIWORD(wParam)==LBN_SELCHANGE)
				{
					if ( NextBlock )
					{
						NextBlock=FALSE;
						i=EditProgram-1;
						ListBox_SetCurSel(ProgList, i);
					}
					else i=ListBox_GetCurSel(ProgList);
					
					if (( i >= 0 ) && ( i < MAXPROGS ))
					{
						CurSel=i;
						if ( (i+1) != CurrentProgram )
						{ 
							CurrentProgram=i+1;
							EditProgram=CurrentProgram;
                   			StatusBar_Display("%d. %s ",CurrentProgram,Program[CurrentProgram].Name);
							SetDlgItemText(hDlg,IDC_NAME,Program[CurrentProgram].Name);
	
							sprintf(ligne,"%d",CurrentProgram);
							SetDlgItemText(hDlg,IDC_PRGNR,ligne);
		
							Channel_Change(FALSE);
							if(Program[CurrentProgram].Format!=-1)	SetDlgItemText(hDlg,IDC_FORMAT,TVSettings[Program[CurrentProgram].Format].Name);
							if(Program[CurrentProgram].Source==0)
							{
								if(Program[CurrentProgram].Format==-1)
								{
									strcpy(ligne, Langue_GetString(ID_PROC_SAMETUNER));
									SetDlgItemText(hDlg,IDC_FORMAT,ligne);
								}

								sprintf(ligne,"%3.3f",(float)Program[CurrentProgram].freq/1000);
								SetDlgItemText(hDlg,IDC_FREQUENCY,ligne);
	
								ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY),SW_SHOW);
								ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY2),SW_SHOW);
								strcpy(ligne, "Tuner");
							}
							else
							{
								strcpy(ligne, ChaineVideoSource[Program[CurrentProgram].Source]);
								ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY),SW_HIDE);
								ShowWindow(GetDlgItem(hDlg,IDC_FREQUENCY2),SW_HIDE);
							}
							SetDlgItemText(hDlg,IDC_SOURCE,ligne);

							if(Program[CurrentProgram].Active)	strcpy(ligne, Langue_GetString(ID_YES));
							else 	strcpy(ligne, Langue_GetString(ID_NO));
							SetDlgItemText(hDlg,IDC_ACTIVE,ligne);
						}
					}
				}

				if (HIWORD(wParam)==LBN_DBLCLK)
				{
               		i=ListBox_GetCurSel(ProgList);
					EditProgram=i+1;
                    if (( i >= 0 ) && ( i < MAXPROGS ))
					{
						StatusBar_Display("%d. %s ",CurrentProgram,Program[CurrentProgram].Name);					  
						Langue_DialogBox(hInst,"CANAUX_REGLAGES",hDlg,(DLGPROC)ProgramEditProc);
						SetFocus(hDlg);
						SendMessage(hDlg,RESET_LIST,CurrentProgram,0);
					}
				}
			}

			if (LOWORD(wParam) == IDHELP )
			{
				HtmlHelp(hDlg, "Aide/K!TV-XP.chm::/options_rechercheCANAUX.htm", HH_DISPLAY_TOPIC, 0);
			}

			if (LOWORD(wParam) == IDC_BUTTON1 )
			{
				i=ListBox_GetCurSel(ProgList);
				if ( i>= 1  )
				{
					memcpy(&save,&Program[i+1],sizeof(struct TProgram));
                    memcpy(&Program[i+1],&Program[i],sizeof(struct TProgram));
                    memcpy(&Program[i],&save,sizeof(struct TProgram));
					CurSel--;
					CurrentProgram--;
					EditProgram=CurrentProgram;
         			Channel_Write_Program_List();
					SendMessage(hDlg,RESET_LIST,i,0);
				}
			}

			if (LOWORD(wParam) == IDC_BUTTON2 )
			{
				i=ListBox_GetCurSel(ProgList);
				if ( i+1 < ListBox_GetCount(ProgList))
				if ( i+1 < MAXPROGS )
				{
					memcpy(&save,&Program[i+1],sizeof(struct TProgram));
					memcpy(&Program[i+1],&Program[i+2],sizeof(struct TProgram));
					memcpy(&Program[i+2],&save,sizeof(struct TProgram));
					CurSel++;
					CurrentProgram++;
					EditProgram=CurrentProgram;
       				Channel_Write_Program_List();
					SendMessage(hDlg,RESET_LIST,i+2,0);
				}
			}

			if (LOWORD(wParam) == IDC_BUTTON3)
			{
				i=ListBox_GetCurSel(ProgList);
				EditProgram=i+1;
                if (( i >= 0 ) && ( i < MAXPROGS ))
				{
					StatusBar_Display("%d. %s ",CurrentProgram,Program[CurrentProgram].Name);					  
					Langue_DialogBox(hInst,"CANAUX_REGLAGES",hDlg,(DLGPROC)ProgramEditProc);
					SetFocus(hDlg);
					SendMessage(hDlg,RESET_LIST,CurrentProgram,0);
				}
			}

			if (LOWORD(wParam) == IDC_BUTTON4 )
			{
				Langue_DialogBox(hInst,"CANAUX_RECHERCHE",hDlg,(DLGPROC)ChannelScanProc);
				SetFocus(hDlg);
				if ( Program[CurrentProgram].Name[0] != 0x00 )
				{
					CurSel=CurrentProgram-1;
					EditProgram=CurrentProgram;
				}
				SendMessage(hDlg,RESET_LIST,CurrentProgram,0);
			}

            if ( LOWORD(wParam) == IDDEL)
			{
                i=ListBox_GetCurSel(ProgList)+1;
				Program[i].freq=0;
                Program[i].Name[0]=0x00;

                while ( i < MAXPROGS-1 )
				{
				  memcpy(&Program[i],&Program[i+1],sizeof(struct TProgram));
				  i++;
				};
                Program[i].freq = 0;
                Program[i].Name[0] = 0;
				CurrentProgram=1;
				EditProgram=1;
				Channel_Write_Program_List();
				SendMessage(hDlg,RESET_LIST,i-1,0);
			}

			if (LOWORD(wParam) == IDM_NEU )
			{
				i=1;
			
				while ( i < MAXPROGS )
				{
					if ( Program[i].Name[0] == 0x00 )
					{
						j=i;
						i=MAXPROGS;
					}
					i++;
				}
				Program[j].freq=0;
				Program[j].Name[0]=0x00;
				Program[j].Active=TRUE;
				Program[j].Source=0;
				Program[j].Format=-1;
				// ggf Mehr
                EditProgram=j;
				Langue_DialogBox(hInst,"CANAUX_REGLAGES",hDlg,(DLGPROC)ProgramEditProc);
				SetFocus(hDlg);
				if ( Program[j].Name[0] != 0x00 )
				{
					CurSel=j-1;
					CurrentProgram=j;
				}
				SendMessage(hDlg,RESET_LIST,CurrentProgram,0);
			}

			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
				EndDialog(hDlg,TRUE);
			break;
    }
    return (FALSE);
    UNREFERENCED_PARAMETER(lParam);
}


BOOL APIENTRY VideoSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	static int TZoom=0;
	static int LastSaturation=0x00;
	static int TSaturationU=0x80;
	static int TSaturationV=0x80;
	static unsigned char THue=0x00;
	static unsigned char TBrightness=0x00;
	static int TContrast=0xd8;

	int i,j;
	HWND hBrightness = GetDlgItem( hDlg, IDC_S1 );
	HWND hContrast = GetDlgItem( hDlg, IDC_S2 );
	HWND hHue = GetDlgItem( hDlg, IDC_S3 );
	HWND hSaturation = GetDlgItem( hDlg, IDC_S4 );
	HWND hSaturationU = GetDlgItem( hDlg, IDC_S5 );
	HWND hSaturationV = GetDlgItem( hDlg, IDC_S6 );
	HWND hZoom = GetDlgItem( hDlg, IDC_S7 );

	switch (message)
	{
        case WM_INITDIALOG:
			SendMessage( hBrightness, TBM_SETRANGEMAX, TRUE, 128 );
			SendMessage( hBrightness, TBM_SETRANGEMIN, TRUE, -127 );
			SendMessage( hBrightness, TBM_SETTICFREQ, 16, 0 );

			SendMessage( hContrast, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hContrast, TBM_SETRANGEMIN, TRUE, -511 );
			SendMessage( hContrast, TBM_SETTICFREQ, 32, 0 );

			SendMessage( hHue, TBM_SETRANGEMAX, TRUE, 127 );
			SendMessage( hHue, TBM_SETRANGEMIN, TRUE, -127 );
			SendMessage( hHue, TBM_SETTICFREQ, 16, 0 );

			SendMessage( hSaturation, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hSaturation, TBM_SETRANGEMIN, TRUE, -511 );
			SendMessage( hSaturation, TBM_SETTICFREQ, 32, 0 );

			SendMessage( hSaturationU, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hSaturationU, TBM_SETRANGEMIN, TRUE, -511 );
			SendMessage( hSaturationU, TBM_SETTICFREQ, 32, 0 );

			SendMessage( hSaturationV, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hSaturationV, TBM_SETRANGEMIN, TRUE, -511 );
			SendMessage( hSaturationV, TBM_SETTICFREQ, 32, 0 );

			SendMessage( hZoom, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hZoom, TBM_SETRANGEMIN, TRUE, -128 );
			SendMessage( hZoom, TBM_SETTICFREQ, 8, 0 );

            TBrightness=InitialBrightness[TVSettings[TVTYPE].format];
			TContrast=InitialContrast[TVSettings[TVTYPE].format];
			THue=InitialHue;

            TSaturationU=InitialSaturationU[TVSettings[TVTYPE].format];
            TSaturationV=InitialSaturationV[TVSettings[TVTYPE].format];
			LastSaturation = (InitialSaturationU[TVSettings[TVTYPE].format]+InitialSaturationV[TVSettings[TVTYPE].format])/2;

			TZoom=Zoom.Valeur;

			if(LINK_UV)
			{
				CheckDlgButton(hDlg, IDC_CHECK1, TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_S5),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_S6),FALSE);
			}
			else
			{
				CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_S4),FALSE);
			}

			if(Sleep_Interval==0) CheckDlgButton(hDlg, IDC_CHECK2, TRUE);

            if ( TBrightness < 128 ) i=TBrightness;
			else i=-(256-TBrightness);
			SendMessage( hBrightness,   TBM_SETPOS, TRUE, -i );
			SetDlgItemInt(hDlg,IDC_D1,i,TRUE);

			SendMessage( hContrast,   TBM_SETPOS, TRUE, -TContrast );
			SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);

            if ( THue < 128 ) i=THue;
			else i=-(256-THue);
			SendMessage( hHue,   TBM_SETPOS, TRUE, -i );
			SetDlgItemInt(hDlg,IDC_D3,i,TRUE);

			SendMessage( hSaturation,   TBM_SETPOS, TRUE, -LastSaturation );
			SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);

			SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
			SendMessage( hSaturationU,   TBM_SETPOS, TRUE, -TSaturationU );

			SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
			SendMessage( hSaturationV,   TBM_SETPOS, TRUE, -TSaturationV );

			SetDlgItemInt(hDlg,IDC_D7,TZoom,FALSE);
			SendMessage( hZoom,   TBM_SETPOS, TRUE, -TZoom );

			break;

	    case WM_VSCROLL:
		case WM_HSCROLL:
	        if((HWND)lParam == GetDlgItem(hDlg, IDC_S1))
			{
				TBrightness = (unsigned char)(-SendMessage( hBrightness,   TBM_GETPOS, 0, 0 ));
				if ( TBrightness < 128 ) i=TBrightness;
				else i=-(256-TBrightness);
				SetDlgItemInt(hDlg,IDC_D1,i,TRUE);
				BT8X8_SetBrightness(TBrightness);
			}
			else if((HWND)lParam == GetDlgItem(hDlg, IDC_S2))
			{ 
				TContrast = -SendMessage( hContrast,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D2,TContrast,TRUE);
				BT8X8_SetContrast(TContrast);
			}
			else if((HWND)lParam == GetDlgItem(hDlg, IDC_S3))
			{
				THue = (unsigned char)(-SendMessage( hHue,   TBM_GETPOS, 0, 0 ));
				if ( THue < 128 ) i=THue;
				else i=-(256-THue);
				SetDlgItemInt(hDlg,IDC_D3,i,TRUE);
				BT8X8_SetHue(THue);
			}
	        else if((HWND)lParam == GetDlgItem(hDlg, IDC_S4) || (HWND)lParam == GetDlgItem(hDlg, IDC_S5) || (HWND)lParam == GetDlgItem(hDlg, IDC_S6))
			{
				if(LINK_UV)
				{	
					i = -SendMessage( hSaturation,   TBM_GETPOS, 0, 0 );
					j=i-LastSaturation;
					if( (j+TSaturationU >= 0) && (j+TSaturationU <= 511) )
					TSaturationU+=j;
					if( (j+TSaturationV >= 0) && (j+TSaturationV <= 511) )
					TSaturationV+=j;
					LastSaturation = (TSaturationU+TSaturationV)/2; 
					SendMessage( hSaturation,   TBM_SETPOS, TRUE, -LastSaturation );
					SendMessage( hSaturationU,   TBM_SETPOS, TRUE, -TSaturationU );
					SendMessage( hSaturationV,   TBM_SETPOS, TRUE, -TSaturationV );
					SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
					SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
					SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
					BT8X8_SetSaturationU(TSaturationU);
					BT8X8_SetSaturationV(TSaturationV);
				}
				else
				{
					TSaturationU = -SendMessage( hSaturationU,   TBM_GETPOS, 0, 0 );
					TSaturationV = -SendMessage( hSaturationV,   TBM_GETPOS, 0, 0 );
					LastSaturation = (TSaturationU+TSaturationV)/2;

					SendMessage( hSaturation,   TBM_SETPOS, TRUE, -LastSaturation );
	
					SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
					SetDlgItemInt(hDlg,IDC_D5,TSaturationU,TRUE);
					SetDlgItemInt(hDlg,IDC_D6,TSaturationV,TRUE);

					BT8X8_SetSaturationU(TSaturationU);
					BT8X8_SetSaturationV(TSaturationV);
				}
			}
	        else if((HWND)lParam == GetDlgItem(hDlg, IDC_S7))
			{
				Zoom.Valeur = -SendMessage( hZoom,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D7,Zoom.Valeur,TRUE);
				SetZoomAvecPrecision(Zoom.Valeur);
				SetFocus(hDlg);
			}
			break;

        case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_CHECK1:
					if (IsDlgButtonChecked(hDlg, IDC_CHECK1))
						LINK_UV=TRUE;
					else
						LINK_UV=FALSE;
					EnableWindow(GetDlgItem(hDlg,IDC_S4), LINK_UV);
					EnableWindow(GetDlgItem(hDlg,IDC_S5), !LINK_UV);
					EnableWindow(GetDlgItem(hDlg,IDC_S6), !LINK_UV);
					break;

				case IDOK:
				{
					
					if(IsDlgButtonChecked(hDlg, IDC_CHECK2)) Sleep_Interval=0;
					else Sleep_Interval=1;
					InitialBrightness[TVSettings[TVTYPE].format]=TBrightness;
					InitialContrast[TVSettings[TVTYPE].format]=TContrast;
					InitialHue=THue;
					InitialSaturationU[TVSettings[TVTYPE].format]=TSaturationU;
					InitialSaturationV[TVSettings[TVTYPE].format]=TSaturationV;
	 			    EndDialog(hDlg,TRUE);
					break;
				}

				case IDCANCEL:
				{
					BT8X8_SetBrightness(InitialBrightness[TVSettings[TVTYPE].format]);
					BT8X8_SetContrast(InitialContrast[TVSettings[TVTYPE].format]);
					BT8X8_SetHue(InitialHue);
					BT8X8_SetSaturationU(InitialSaturationU[TVSettings[TVTYPE].format]);
					BT8X8_SetSaturationV(InitialSaturationV[TVSettings[TVTYPE].format]);
					SetZoomAvecPrecision(TZoom);
					SetFocus(hDlg);
					EndDialog(hDlg,TRUE);
					break;
				}

				case IDDEFAULT:
				{
					CheckDlgButton(hDlg, IDC_CHECK2, FALSE);
					THue=0x00;
					TBrightness=0x00;			   
					TContrast=0xd8;	
					Zoom.Valeur=0;

					if(TVSettings[TVTYPE].format==0)//PAL
					{
						TContrast=0xd8;
						TBrightness=30;
						TSaturationU=0xFE;
						TSaturationV=0xB4;
					}
					else if(TVSettings[TVTYPE].format==1)//NTSC
					{
						TContrast=0xcf;
						TBrightness=20;
						TSaturationU=0xFE;
						TSaturationV=0xDB;
					}
					else//SECAM
					{
						TContrast=0xd8;
						TBrightness=0;
						TSaturationU=0x80;
						TSaturationV=0x80;
					}

					LastSaturation = (TSaturationU+TSaturationV)/2; 
					BT8X8_SetBrightness(TBrightness);
					BT8X8_SetContrast(TContrast);
					BT8X8_SetHue(THue);
					BT8X8_SetSaturationU(TSaturationU);
					BT8X8_SetSaturationV(TSaturationV);
					SetZoomAvecPrecision(Zoom.Valeur);
					SetFocus(hDlg);

					if ( TBrightness < 128 ) i=TBrightness;
             		else i=-(256-TBrightness);
					SendMessage( hBrightness,   TBM_SETPOS, TRUE, -i );
     				SetDlgItemInt(hDlg,IDC_D1,i,TRUE);

					SendMessage( hContrast,   TBM_SETPOS, TRUE, -TContrast );
					SetDlgItemInt(hDlg,IDC_D2,TContrast,FALSE);
	
					if ( THue < 128 ) i=THue;
             		else i=-(256-THue);
					SendMessage( hHue,   TBM_SETPOS, TRUE, -i );
					SetDlgItemInt(hDlg,IDC_D3,i,TRUE);

					SendMessage( hSaturation,   TBM_SETPOS, TRUE, -LastSaturation );
					SetDlgItemInt(hDlg,IDC_D4,LastSaturation,FALSE);
					SendMessage( hSaturationU,   TBM_SETPOS, TRUE, -TSaturationU );
					SetDlgItemInt(hDlg,IDC_D5,TSaturationU,FALSE);
					SendMessage( hSaturationV,   TBM_SETPOS, TRUE, -TSaturationV );
					SetDlgItemInt(hDlg,IDC_D6,TSaturationV,FALSE);
					SendMessage( hZoom,   TBM_SETPOS, TRUE, -Zoom.Valeur );
     				SetDlgItemInt(hDlg,IDC_D7,Zoom.Valeur,TRUE);
					break;
			   
				} 
			}
    }
	return(FALSE);
}


BOOL APIENTRY AudioSettingProc_MSP( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{

	static char TBalance=0x00, TSpecial=0x00, TLoudness=0x00, TBass=0x00, 
	TTreble=0x00, TNicam=0x70, TAM=0x10;
	static BOOL TSuperBass;

	HWND hVolume = GetDlgItem( hDlg, IDC_S1 );
	HWND hSpecial = GetDlgItem( hDlg, IDC_S2 );
	HWND hLoudness = GetDlgItem( hDlg, IDC_S3 );
	HWND hBass = GetDlgItem( hDlg, IDC_S4 );
	HWND hTreble = GetDlgItem( hDlg, IDC_S5 );
	HWND hBalance = GetDlgItem( hDlg, IDC_S6 );
	HWND hNicam = GetDlgItem( hDlg, IDC_S7 );
	HWND hAM = GetDlgItem( hDlg, IDC_S8 );
   
	switch (message)
	{
        case WM_INITDIALOG:
            if ( !Has_MSP )
			{
                MessageBox(hWnd, Langue_GetString(ID_PROC_NOMSP), "K!TV XP",MB_ICONSTOP|MB_OK);
                EndDialog(hDlg,0);

			}

			SendMessage( hVolume, TBM_SETRANGEMAX, TRUE, 0 );
			SendMessage( hVolume, TBM_SETRANGEMIN, TRUE, -1000 );
			SendMessage( hVolume, TBM_SETTICFREQ, 100, 0 );

			SendMessage( hSpecial, TBM_SETRANGEMAX, TRUE, 100 );
			SendMessage( hSpecial, TBM_SETRANGEMIN, TRUE, -100 );
			SendMessage( hSpecial, TBM_SETTICFREQ, 20, 0 );
			
			SendMessage( hLoudness, TBM_SETRANGEMAX, TRUE, 68 );
			SendMessage( hLoudness, TBM_SETRANGEMIN, TRUE, 0 );
			SendMessage( hLoudness, TBM_SETTICFREQ, 4, 0 );

			SendMessage( hBass, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hBass, TBM_SETRANGEMIN, TRUE, -127 );
			SendMessage( hBass, TBM_SETTICFREQ, 8, 0 );
			
			SendMessage( hTreble, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hTreble, TBM_SETRANGEMIN, TRUE, -120 );
			SendMessage( hTreble, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hBalance, TBM_SETRANGEMAX, TRUE, 127 );
			SendMessage( hBalance, TBM_SETRANGEMIN, TRUE, -127 );
			SendMessage( hBalance, TBM_SETTICFREQ, 127, 0 );

			SendMessage( hNicam, TBM_SETRANGEMAX, TRUE, 127 );
			SendMessage( hNicam, TBM_SETRANGEMIN, TRUE, 0 );
			SendMessage( hNicam, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hAM, TBM_SETRANGEMAX, TRUE, 127 );
			SendMessage( hAM, TBM_SETRANGEMIN, TRUE, 0 );
			SendMessage( hAM, TBM_SETTICFREQ, 8, 0 );

            if(System_In_Mute) InitialVolume=TVolume;
			else TVolume=InitialVolume;

			TSpecial=InitialSpatial;
			TLoudness=InitialLoudness;
            TBass=InitialBass;
            TTreble=InitialTreble;
            TBalance=InitialBalance;
			TSuperBass=InitialSuperBass;
			TNicam=InitialNicam;
			TAM=InitialAM;

			SendMessage( hVolume,   TBM_SETPOS, TRUE, -InitialVolume );
			SetDlgItemInt(hDlg,IDC_D1,InitialVolume,FALSE);

			SendMessage( hSpecial,   TBM_SETPOS, TRUE, InitialSpatial );
			SetDlgItemInt(hDlg,IDC_D2,(unsigned int)(InitialSpatial/1.27),TRUE);

			SendMessage( hLoudness,   TBM_SETPOS, TRUE, InitialLoudness );
			SetDlgItemInt(hDlg,IDC_D3,InitialLoudness/4,TRUE);

			SendMessage( hBass,   TBM_SETPOS, TRUE, -InitialBass );
			if(InitialBass>0)	SetDlgItemInt(hDlg,IDC_D4,(int)(InitialBass/6.66),TRUE);
			else	SetDlgItemInt(hDlg,IDC_D4,InitialBass/8,TRUE);

			SendMessage( hTreble,   TBM_SETPOS, TRUE, -InitialTreble );
			SetDlgItemInt(hDlg,IDC_D5,InitialTreble/8,TRUE);

			SendMessage( hBalance,   TBM_SETPOS, TRUE, InitialBalance );
			SetDlgItemInt(hDlg,IDC_D6,InitialBalance,TRUE);

			SendMessage( hNicam,   TBM_SETPOS, TRUE, InitialNicam );

			SendMessage( hAM,   TBM_SETPOS, TRUE, InitialAM );

            CheckDlgButton(hDlg, IDC_CHECK1, InitialSuperBass);
			break;


	    case WM_VSCROLL:
	        if((HWND)lParam == hVolume)
			{
				InitialVolume = -SendMessage( hVolume,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_D1,InitialVolume,TRUE);
				if(System_In_Mute)	TVolume=InitialVolume;
				else	Audio_MSP_SetVolume(InitialVolume);
			}
	        else if((HWND)lParam == hBass)
			{
				InitialBass = (unsigned char)(-SendMessage( hBass,   TBM_GETPOS, 0, 0 ));
				if(InitialBass>0)	SetDlgItemInt(hDlg,IDC_D4,(int)(InitialBass/6.66),TRUE);
				else	SetDlgItemInt(hDlg,IDC_D4,InitialBass/8,TRUE);
				Audio_MSP_SetBass(InitialBass);
			}
	        else if((HWND)lParam == hTreble)
			{
				InitialTreble = (unsigned char)(-SendMessage( hTreble,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D5,InitialTreble/8,TRUE);
				Audio_MSP_SetTreble(InitialTreble);
			}
			break;

		case WM_HSCROLL:
	        if((HWND)lParam == hSpecial)
			{
				InitialSpatial = (unsigned char)(SendMessage( hSpecial,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D2,InitialSpatial,TRUE);
				Audio_MSP_SetSpatial(InitialSpatial); 
			}
	        else if((HWND)lParam == hLoudness)
			{
				InitialLoudness = (unsigned char)(SendMessage( hLoudness,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D3,InitialLoudness/4,TRUE);
				Audio_MSP_SetLoudness(InitialLoudness);
			}
	        else if((HWND)lParam == hBalance)
			{
				InitialBalance = (unsigned char)(SendMessage( hBalance,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D6,InitialBalance,TRUE);
				Audio_MSP_SetBalance(InitialBalance); // -127 - +128
			}
	        else if((HWND)lParam == hNicam)
			{
				InitialNicam = (unsigned char)(SendMessage( hNicam,   TBM_GETPOS, 0, 0 ));
				Audio_MSP_SetVolumeNicam(InitialNicam);
			}
	        else if((HWND)lParam == hAM)
			{
				InitialAM = (unsigned char)(SendMessage( hAM,   TBM_GETPOS, 0, 0 ));
				Audio_MSP_SetVolumeAM(InitialAM);
			}
			break;

        case WM_COMMAND:

         	switch(wParam)
			{
				
				case IDC_CHECK1:
					InitialSuperBass=IsDlgButtonChecked(hDlg, IDC_CHECK1);
					Audio_MSP_SetSuperBass(InitialSuperBass);
					break;

				case IDHELP:
					HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesMSP.htm", HH_DISPLAY_TOPIC, 0);
					break;

				case IDDEFAULT:
				    CheckDlgButton(hDlg, IDC_CHECK1, FALSE);
					BT8X8_SetAudioSource(4);
	 			    Audio_MSP_SetSuperBass(FALSE);
		            if(!System_In_Mute)Audio_MSP_SetVolume(800);
					else TVolume=800;
					Audio_MSP_SetVolumeNicam(0x70);
					Audio_MSP_SetVolumeAM(0x10);
					Audio_MSP_SetSpatial(0); 
					Audio_MSP_SetLoudness(0);
					Audio_MSP_SetBass(0);
					Audio_MSP_SetTreble(0);
					Audio_MSP_SetBalance(0); 

					SendMessage( hVolume,   TBM_SETPOS, TRUE, -InitialVolume );
					SetDlgItemInt(hDlg,IDC_D1,InitialVolume,FALSE);

					SendMessage( hSpecial,   TBM_SETPOS, TRUE, InitialSpatial );
					SetDlgItemInt(hDlg,IDC_D2,(unsigned int)(InitialSpatial/1.27),TRUE);

					SendMessage( hLoudness,   TBM_SETPOS, TRUE, InitialLoudness );
					SetDlgItemInt(hDlg,IDC_D3,InitialLoudness/4,TRUE);

					SendMessage( hBass,   TBM_SETPOS, TRUE, InitialBass );
					if(InitialBass>0)	SetDlgItemInt(hDlg,IDC_D4,(int)(InitialBass/6.66),TRUE);
					else	SetDlgItemInt(hDlg,IDC_D4,InitialBass/8,TRUE);

					SendMessage( hTreble,   TBM_SETPOS, TRUE, InitialTreble );
					SetDlgItemInt(hDlg,IDC_D5,InitialTreble/8,TRUE);

					SendMessage( hBalance,   TBM_SETPOS, TRUE, InitialBalance );
					SetDlgItemInt(hDlg,IDC_D6,InitialBalance,TRUE);

					SendMessage( hNicam,   TBM_SETPOS, TRUE, InitialNicam );

					SendMessage( hAM,   TBM_SETPOS, TRUE, InitialAM );

					BT8X8_SetAudioSource(AudioSource);
					break;

				case IDCANCEL:
					BT8X8_SetAudioSource(4);
   					Audio_MSP_SetSuperBass(TSuperBass);
					Audio_MSP_SetVolume(TVolume);
					Audio_MSP_SetVolumeNicam(TNicam);
					Audio_MSP_SetVolumeAM(TAM);
					Audio_MSP_SetSpatial(TSpecial); 
					Audio_MSP_SetLoudness(TLoudness);
					Audio_MSP_SetBass(TBass);
					Audio_MSP_SetTreble(TTreble);
					Audio_MSP_SetBalance(TBalance); 
					BT8X8_SetAudioSource(AudioSource);
					EndDialog(hDlg,TRUE);
					break;			

				case IDOK:
					EndDialog(hDlg,TRUE);
					break;
			}
			break;
	    }

	return(FALSE);
}


BOOL APIENTRY AudioSettingProc_MSP_EQ( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	static char TEqualizer1, TEqualizer2, TEqualizer3, TEqualizer4, TEqualizer5;

	HWND hEqualizer1 = GetDlgItem( hDlg, IDC_S1 );
	HWND hEqualizer2 = GetDlgItem( hDlg, IDC_S2 );
	HWND hEqualizer3 = GetDlgItem( hDlg, IDC_S3 );
	HWND hEqualizer4 = GetDlgItem( hDlg, IDC_S4 );
	HWND hEqualizer5 = GetDlgItem( hDlg, IDC_S5 );
   
	switch (message)
	{
        case WM_INITDIALOG:
            if ( !Has_MSP )
			{
                MessageBox(hWnd, Langue_GetString(ID_PROC_NOMSP), "K!TV XP",MB_ICONSTOP|MB_OK);
                EndDialog(hDlg,0);
			}
			SendMessage( hEqualizer1, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hEqualizer1, TBM_SETRANGEMIN, TRUE, -96 );
			SendMessage( hEqualizer1, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hEqualizer2, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hEqualizer2, TBM_SETRANGEMIN, TRUE, -96 );
			SendMessage( hEqualizer2, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hEqualizer3, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hEqualizer3, TBM_SETRANGEMIN, TRUE, -96 );
			SendMessage( hEqualizer3, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hEqualizer4, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hEqualizer4, TBM_SETRANGEMIN, TRUE, -96 );
			SendMessage( hEqualizer4, TBM_SETTICFREQ, 8, 0 );

			SendMessage( hEqualizer5, TBM_SETRANGEMAX, TRUE, 96 );
			SendMessage( hEqualizer5, TBM_SETRANGEMIN, TRUE, -96 );
			SendMessage( hEqualizer5, TBM_SETTICFREQ, 8, 0 );

            TEqualizer1=InitialEqualizer1;
			TEqualizer2=InitialEqualizer2;
			TEqualizer3=InitialEqualizer3;
            TEqualizer4=InitialEqualizer4;
            TEqualizer5=InitialEqualizer5;

			SendMessage( hEqualizer1,   TBM_SETPOS, TRUE, -InitialEqualizer1 );
			SetDlgItemInt(hDlg,IDC_D1,InitialEqualizer1/8,TRUE);

			SendMessage( hEqualizer2,   TBM_SETPOS, TRUE, -InitialEqualizer2 );
			SetDlgItemInt(hDlg,IDC_D2,InitialEqualizer2/8,TRUE);

			SendMessage( hEqualizer3,   TBM_SETPOS, TRUE, -InitialEqualizer3 );
			SetDlgItemInt(hDlg,IDC_D3,InitialEqualizer3/8,TRUE);

			SendMessage( hEqualizer4,   TBM_SETPOS, TRUE, -InitialEqualizer4 );
			SetDlgItemInt(hDlg,IDC_D4,InitialEqualizer4/8,TRUE);

			SendMessage( hEqualizer5,   TBM_SETPOS, TRUE, -InitialEqualizer5 );
			SetDlgItemInt(hDlg,IDC_D5,InitialEqualizer5/8,TRUE);

			break;

	    case WM_VSCROLL:
	        if((HWND)lParam == hEqualizer1)
			{
				InitialEqualizer1 = (unsigned char)(-SendMessage( hEqualizer1,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D1,InitialEqualizer1/8,TRUE);
				Audio_MSP_SetEqualizer1(InitialEqualizer1);
			}
	        else if((HWND)lParam == hEqualizer2)
			{
				InitialEqualizer2 = (unsigned char)(-SendMessage( hEqualizer2,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D2,InitialEqualizer2/8,TRUE);
				Audio_MSP_SetEqualizer2(InitialEqualizer2);
			}
	        else if((HWND)lParam == hEqualizer3)
			{
				InitialEqualizer3 = (unsigned char)(-SendMessage( hEqualizer3,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D3,InitialEqualizer3/8,TRUE);
				Audio_MSP_SetEqualizer3(InitialEqualizer3);
			}
	        else if((HWND)lParam == hEqualizer4)
			{
				InitialEqualizer4 = (unsigned char)(-SendMessage( hEqualizer4,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D4,InitialEqualizer4/8,TRUE);
				Audio_MSP_SetEqualizer4(InitialEqualizer4);
			}
	        else if((HWND)lParam == hEqualizer5)
			{
				InitialEqualizer5 = (unsigned char)(-SendMessage( hEqualizer5,   TBM_GETPOS, 0, 0 ));
				SetDlgItemInt(hDlg,IDC_D5,InitialEqualizer5/8,TRUE);
				Audio_MSP_SetEqualizer5(InitialEqualizer5);
			}
			break;

        case WM_COMMAND:
			switch(wParam)
			{
				case IDHELP:
					HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesMSP.htm", HH_DISPLAY_TOPIC, 0);
					break;

				case IDDEFAULT:
					BT8X8_SetAudioSource(4);
		     	    Audio_MSP_SetEqualizer1(0);
			 	    Audio_MSP_SetEqualizer2(0);
     			    Audio_MSP_SetEqualizer3(0);
	     			Audio_MSP_SetEqualizer4(0);
					Audio_MSP_SetEqualizer5(0);
				    BT8X8_SetAudioSource(AudioSource);

					SendMessage( hEqualizer1,   TBM_SETPOS, TRUE, -InitialEqualizer1 );
					SetDlgItemInt(hDlg,IDC_D1,InitialEqualizer1/8,TRUE);

					SendMessage( hEqualizer2,   TBM_SETPOS, TRUE, -InitialEqualizer2 );
					SetDlgItemInt(hDlg,IDC_D2,InitialEqualizer2/8,TRUE);

					SendMessage( hEqualizer3,   TBM_SETPOS, TRUE, -InitialEqualizer3 );
					SetDlgItemInt(hDlg,IDC_D3,InitialEqualizer3/8,TRUE);

					SendMessage( hEqualizer4,   TBM_SETPOS, TRUE, -InitialEqualizer4 );
					SetDlgItemInt(hDlg,IDC_D4,InitialEqualizer4/8,TRUE);

					SendMessage( hEqualizer5,   TBM_SETPOS, TRUE, -InitialEqualizer5 );
					SetDlgItemInt(hDlg,IDC_D5,InitialEqualizer5/8,TRUE);
					break;

				case IDCANCEL:
					BT8X8_SetAudioSource(4);
		 	        Audio_MSP_SetEqualizer1(TEqualizer1);
     		        Audio_MSP_SetEqualizer2(TEqualizer2);
     			    Audio_MSP_SetEqualizer3(TEqualizer3);
     				Audio_MSP_SetEqualizer4(TEqualizer4);
					Audio_MSP_SetEqualizer5(TEqualizer5);
		            BT8X8_SetAudioSource(AudioSource);
  					EndDialog(hDlg,TRUE);
					break;

				case IDOK:
					EndDialog(hDlg,TRUE);
					break;
			}
			break;
	}
	return(FALSE);
}


BOOL APIENTRY ResSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			emstartx=Res_X;
            emstarty=Res_Y;
			SetDlgItemInt(hDlg,IDC_RESX,Res_X,FALSE);
            SetDlgItemInt(hDlg,IDC_RESY,Res_Y,FALSE);
            break;

		case WM_TIMER:
            if (LOWORD(wParam) == 2 )
			{
				KillTimer(hDlg,TIMER_SPLASHBOX);
				Affichage_ModeFenetre(hWnd, IDM_FENETRE512x384);

				ShowWindow(hDlg,SW_SHOW);
				EnableWindow(GetDlgItem(hDlg,IDOK),FALSE);
				if ( MessageBox(hDlg, Langue_GetString(ID_PROC_TEST), "K!TV XP",MB_ICONQUESTION | MB_YESNO ) == IDYES )
					EnableWindow(GetDlgItem(hDlg,IDOK),TRUE);
			}
			break;

		case WM_COMMAND:

			if (LOWORD(wParam) == IDC_BUTTON1 )
			{
				Res_X=GetDlgItemInt(hDlg,IDC_RESX,NULL,FALSE);
				Res_Y=GetDlgItemInt(hDlg,IDC_RESY,NULL,FALSE);
				Affichage_ModeDDrawExclusif(hWnd, IDM_OWN_RES);

				ShowWindow(hDlg,SW_HIDE);
				SetTimer(hDlg,TIMER_SPLASHBOX, 1500, NULL);
			}

			if (LOWORD(wParam) == IDOK )
			{
				Res_X=GetDlgItemInt(hDlg,IDC_RESX,NULL,FALSE);
				Res_Y=GetDlgItemInt(hDlg,IDC_RESY,NULL,FALSE);
				Affichage_ModeDDrawExclusif(hWnd, IDM_OWN_RES);
				EndDialog(hDlg,TRUE);
			}
			
			if (LOWORD(wParam) == IDCANCEL )
			{
				Res_X=emstartx;
				Res_Y=emstarty;
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}


static BOOL DrawHTTPLink(HWND hwnd,LPARAM lParam,UINT c)
{
	DRAWITEMSTRUCT *di = (DRAWITEMSTRUCT *)lParam;
	if(di->CtlID == c)
	{
		HFONT hFont, hOldFont;	
		LOGFONT lFont;
		COLORREF oldTextColor;
		int length;
		char url[200] = "";

		length = GetDlgItemText(hwnd, di->CtlID, url, sizeof(url));

		if(di->itemAction == ODA_SELECT && (di->itemState & ODS_SELECTED))
			oldTextColor = SetTextColor(di->hDC,RGB(255,0,0));
		else
			oldTextColor = SetTextColor(di->hDC,RGB(0,0,255));

		GetObject(GetWindowFont(hwnd), sizeof(lFont), &lFont);
		lFont.lfUnderline = TRUE;
		hFont = CreateFontIndirect(&lFont);
		hOldFont = SelectFont(di->hDC, hFont);
		DrawText(di->hDC, url, length, &di->rcItem, DT_CENTER|DT_VCENTER|DT_SINGLELINE|DT_NOPREFIX);
		SelectFont(di->hDC, hOldFont);
		DeleteObject(hFont);
		return TRUE;
	}
	return FALSE;
}


BOOL APIENTRY AboutProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			char tempChar[100];
			sprintf (tempChar, "K!TV XP %s Copyright (C) 2000-2002 Quenotte", STRPRODUCTVER);
			SetWindowText(hDlg, tempChar);
			break;

	  	case WM_DRAWITEM:
			return DrawHTTPLink(hDlg,lParam,IDC_BUTTON2);

        case WM_COMMAND:
			if (LOWORD(wParam) == IDC_BUTTON1 )
			{
				Langue_DialogBox(hInst,"ABOUT1",hDlg,AboutProc1);
			}
			if (LOWORD(wParam) == IDC_BUTTON2 )
			{
				HtmlHelp(hWnd, "http://www.kastortv.com", HH_DISPLAY_TOPIC, 0);
			}
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL ))
			{
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}


BOOL APIENTRY AboutProc1( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	switch (message)
	{
        case WM_INITDIALOG:
			break;

		case WM_DRAWITEM:
			return DrawHTTPLink(hDlg,lParam,IDC_BUTTON1);

        case WM_COMMAND:
			if (LOWORD(wParam) == IDC_BUTTON1 )
			{
					HtmlHelp(hWnd, "http://www.gnu.org/copyleft/gpl.html", HH_DISPLAY_TOPIC, 0);
			}
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) 
			{
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}


BOOL APIENTRY VTInfoProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	int i;

	switch (message)
	{
		case WM_INITDIALOG:
            ShowVTInfo=hDlg;
			SetTimer(hDlg,0,1000,NULL);
			break;

        case WM_TIMER:
			for (i = 0; i < 12; i++)
			{
				if ( Sous_Titres.STPages[i] != 0 )
				{
					ShowWindow(GetDlgItem(hDlg,IDC_RADIO1+i),SW_SHOW);
					SetDlgItemInt(hDlg,IDC_RADIO1+i,Sous_Titres.STPages[i],FALSE);
				}
				else
					ShowWindow(GetDlgItem(hDlg,IDC_RADIO1+i),SW_HIDE);
			}

			for (i = 0; i < 12; i++)
			{
				if (Sous_Titres.PageActive == i) {
					CheckDlgButton(hDlg, IDC_RADIO1 + i, TRUE);
					break;
				}
			}
			SetDlgItemInt(hDlg,TEXT1,VTCachedPages,FALSE);
			break;

        case WM_COMMAND:
			switch (wParam)
			{
				case IDC_BUTTON1:
					SetSystemTime(&SystemTime);
					break; 
				 
				case IDOK :
					for (i = 0; i < 12; i++)
						if (IsDlgButtonChecked(hDlg,IDC_RADIO1+i))
							Sous_Titres.PageActive=i;

				case IDCANCEL :
        			KillTimer(hDlg,0);
					ShowVTInfo=NULL;
					EndDialog(hDlg,TRUE);
					break;
			}
	}
	return(FALSE);
}


BOOL APIENTRY ShutdownOptionProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		if ( Shutdown.Flag==0 ) CheckDlgButton(hDlg,IDC_RADIO1, TRUE );
        else if ( Shutdown.Flag&EWX_POWEROFF ) CheckDlgButton(hDlg,IDC_RADIO2, TRUE );
        else if ( Shutdown.Flag&EWX_REBOOT ) CheckDlgButton(hDlg,IDC_RADIO3, TRUE );
        else if ( Shutdown.Flag&EWX_SHUTDOWN ) CheckDlgButton(hDlg,IDC_RADIO4, TRUE );
		if ( Shutdown.Flag&EWX_FORCE ) CheckDlgButton(hDlg,IDC_CHECK1, TRUE );
		return(TRUE);

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK )
		{
			if (IsDlgButtonChecked(hDlg,IDC_RADIO1)) Shutdown.Flag=EWX_LOGOFF;
			else if (IsDlgButtonChecked(hDlg,IDC_RADIO2)) Shutdown.Flag=EWX_POWEROFF;
			else if (IsDlgButtonChecked(hDlg,IDC_RADIO3)) Shutdown.Flag=EWX_REBOOT;
			else if (IsDlgButtonChecked(hDlg,IDC_RADIO4)) Shutdown.Flag=EWX_SHUTDOWN;

			if (IsDlgButtonChecked(hDlg,IDC_CHECK1)) Shutdown.Flag+=EWX_FORCE;
			EndDialog(hDlg,TRUE);
		}

		if (LOWORD(wParam) == IDCANCEL )
		{
				EndDialog(hDlg,TRUE);
		}
		break;
    }
	return(FALSE);
}


BOOL APIENTRY ShutdownSetProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	char Ligne[32];
	int i;

	switch (message)
	{
		case WM_INITDIALOG:
			if ( Shutdown.H != 0xff )
			{
				sprintf(Ligne,"%02d",Shutdown.H);
				SetDlgItemText(hDlg,IDC_EDIT1,Ligne);
				sprintf(Ligne,"%02d",Shutdown.M);
				SetDlgItemText(hDlg,IDC_EDIT2,Ligne);
			}
			else
			{
				SetDlgItemText(hDlg,IDC_EDIT1,"");
				SetDlgItemText(hDlg,IDC_EDIT2,"");
			}
			GetLocalTime(&LocalTime);
			sprintf(Ligne,"%02d",LocalTime.wHour);
			SetDlgItemText(hDlg,IDC_EDIT3,Ligne);
			sprintf(Ligne,"%02d",LocalTime.wMinute);
			SetDlgItemText(hDlg,IDC_EDIT4,Ligne);

			SetFocus(GetDlgItem(hDlg,IDC_EDIT1));

			SetTimer(hDlg,TIMER_STATUS,1000,NULL);
			return(TRUE);

		case WM_TIMER:
			if ( wParam == 1 )
			{
				GetLocalTime(&LocalTime);
				sprintf(Ligne,"%02d",LocalTime.wHour);
				SetDlgItemText(hDlg,IDC_EDIT3,Ligne);
				sprintf(Ligne,"%02d",LocalTime.wMinute);
				SetDlgItemText(hDlg,IDC_EDIT4,Ligne);
			}
			break;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK )
			{
				GetDlgItemText(hDlg,IDC_EDIT1,Ligne,32);
				if (( Ligne[0] == 0x00 ) || ( Ligne[0] == 0x20 )) Shutdown.H = 0xff;
				else
				{
					i=atoi(Ligne);
					if (( i < 0 ) || ( i > 23 ))
					{
						MessageBox(hDlg, Langue_GetString(ID_PROC_ERRHOUR), "K!TV XP",MB_ICONSTOP|MB_OK);
						SetFocus(GetDlgItem(hDlg,IDC_EDIT1));
						break;
					}
					Shutdown.H=i;
				}
				GetDlgItemText(hDlg,IDC_EDIT2,Ligne,32);
	            if (( Ligne[0] == 0x00 ) || ( Ligne[0] == 0x20 )) Shutdown.H = 0xff;
				else
				{
					i=atoi(Ligne);
					if (( i < 0 ) || ( i > 59 ))
					{
						MessageBox(hDlg, Langue_GetString(ID_PROC_ERRMIN),"K!TV XP",MB_ICONSTOP|MB_OK);
						SetFocus(GetDlgItem(hDlg,IDC_EDIT2));
						break;
					}
					Shutdown.M=i;
				}
				EndDialog(hDlg,TRUE);
			}

			if (LOWORD(wParam) == IDCANCEL )
			{
				EndDialog(hDlg,TRUE);
			}
			break;
	}
	return(FALSE);
}


BOOL APIENTRY Stop_SystemProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	HANDLE hToken; 
    TOKEN_PRIVILEGES tkp; 

	static int Secondes = 10 ;

	switch (message)
	{
		case WM_INITDIALOG:

			if ( IsWinNT )
			{
				if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
				{
					SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT,Langue_GetString(ID_SHTDWN_RIGHT));
					break;
				}
				LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid); 
	 
				tkp.PrivilegeCount = 1;  // one privilege to set    
				tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
	 
				AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES) NULL, 0); 
	 
				if (GetLastError() != ERROR_SUCCESS)
				{
					SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT, Langue_GetString(ID_SHTDWN_RIGHT));
					break;
				}
	
			}
				
			SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT,Shutdown.Text);
			SetDlgItemInt(hDlg,IDC_TIMER,Secondes,FALSE);
			SetTimer(hDlg,TIMER_STATUS,1000,NULL);
			break;
	
		case WM_TIMER:
			if ( wParam == 1 )
			{
				Secondes--;
				if ( Secondes >= 0 ) SetDlgItemInt(hDlg,IDC_TIMER,Secondes,FALSE);
				else SetDlgItemInt(hDlg,IDC_TIMER,0,FALSE);
	            
				if ( Secondes < 0 )
				{
					KillTimer(hDlg,TIMER_STATUS);
					SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT, Langue_GetString(ID_SHTDWN_NOW));
					if (IsPluginVideoRunning)
					{
						ChangeCH=TRUE;
						Plugin_Video_Stopper();
					}
					if(IsPluginAudioRunning)	SendMessage(hWnd,WM_COMMAND,IDM_PLUGIN_AUDIO,0);
					Shutdown.Process=TRUE;
					ExitWindowsEx(Shutdown.Flag,0);
					EndDialog(hDlg,TRUE);
				}
			}
			break;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDCANCEL )
			{
				KillTimer(hDlg,TIMER_STATUS);
				SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT, Langue_GetString(ID_SHTDWN_CANCEL));
				Secondes = 10 ;
				EndDialog(hDlg,TRUE);
				break;	
			}
			if (LOWORD(wParam) == IDOK )
			{
				SetDlgItemText(hDlg,IDC_SHUTDOWNTEXT, Langue_GetString(ID_SHTDWN_NOW));
				Secondes=0;
				break;
			}
	}         
	return(FALSE);
}
