/////////////////////////////////////////////////////////////////////////////
// WinDisplay.c 
//
// Ce fichier regroupe toutes les fonctions lies  l'affichage 
// Changement de rsolution, changement de format, dimensionnement au 4/3, etc.
//
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "K!TV-XP.h"
#include "misc.h"
#include "bt848.h"
#include "ddraw.h"
#include "osd.h"
#include "plugin.h"
#include "hardwaremisc.h"


unsigned short  *pDIBMemory=NULL;
static HGLOBAL hDIB = NULL;
BITMAPINFO *pDIB = NULL;
int DebutLigne, HauteurBandeNoire;

extern HMENU hMenu;
extern HWND hwndStatusBar;


void Affichage_FreeDIBmemory()
{
	if ( pDIBMemory != NULL )
	{
		free(pDIBMemory);
		pDIBMemory=NULL;
	}
}


void Affichage_FreehDIB()
{
	if (hDIB != NULL)
	{
		GlobalUnlock(hDIB);
		GlobalFree(hDIB);
		hDIB = NULL;
		pDIB = NULL;
	}
}


BOOL Affichage_Alloc_DIB()
{
	DWORD dwDIB = 0;

	dwDIB = sizeof(pDIB->bmiHeader);
	hDIB = GlobalAlloc(GMEM_ZEROINIT | GMEM_MOVEABLE, dwDIB);
	if(hDIB == NULL)
	{
		RealErrorBox(Langue_GetString(ID_ERROR_MEMORY));
		return(FALSE);
	}
		  
	pDIB = (BITMAPINFO*)GlobalLock(hDIB);
	if(pDIB == NULL)
	{
		RealErrorBox(Langue_GetString(ID_ERROR_MEMORY));
		GlobalFree(hDIB);
		hDIB = NULL;
		return(FALSE);
	}	
	return TRUE;
}


static BOOL Affichage_AllocDIBMemory(int Width, int Height)
{
	int m_dwDisplaySize=0;

	if (pDIB==NULL) return FALSE;

	pDIB->bmiHeader.biSize          = sizeof(pDIB->bmiHeader);
	pDIB->bmiHeader.biWidth         = Width;
	pDIB->bmiHeader.biHeight        = Height;
	pDIB->bmiHeader.biPlanes        = 1;
	pDIB->bmiHeader.biBitCount      = 16;
	pDIB->bmiHeader.biCompression   = BI_RGB;
	pDIB->bmiHeader.biSizeImage     = Width * Height * 2 + 128;
	pDIB->bmiHeader.biXPelsPerMeter = 0;
	pDIB->bmiHeader.biYPelsPerMeter = 0;
	pDIB->bmiHeader.biClrUsed       = 0;
	pDIB->bmiHeader.biClrImportant  = 0;

	m_dwDisplaySize = (pDIB->bmiHeader.biSizeImage);
	pDIBMemory = (unsigned short *)malloc(m_dwDisplaySize+1024);
	if ( pDIBMemory == NULL )
	{
		RealErrorBox(Langue_GetString(ID_ERROR_MEMORY));
		SendMessage(hWnd,WM_DESTROY,0,0);
		return FALSE;
	}
	return TRUE;
}


// Zoom pour les missions 16/9 ou 20/9
//
// Comment ca marche ?
// La source Rect de l'Overlay est modifi dans Affichage_Overlay_Update()
// pour selectionner la zone qui nous interesse et DirectX se charge du reste ;-)
static void Affichage_Overlay_PreparationZoom(int HauteurOverlay)
{
	float ratio = (float)(4.0 / 3.0);
	float Xvisible, LargeurCapture;

	if (Zoom.Valeur == 0 || !ModeOverlay)
	{
		DebutLigne = 0;
		HauteurBandeNoire = 0;
		return;
	}

	// Quelle est la hauteur de la zone  zoomer ?
	if (!IsPluginVideoRunning)
	{
		HauteurBandeNoire = 4 * ((HauteurOverlay/2) * Zoom.Valeur/288);
		LargeurCapture = (float)HauteurOverlay * ratio;
	} 
	else if (FullField && IsPluginVideoRunning && DeInterlace!=2)
	{
		HauteurBandeNoire = 4 * Zoom.Valeur;
		LargeurCapture = (float)TVSettings[TVTYPE].wCropWidth;
	}
	else// if (!FullField && IsPluginVideoRunning)
	{
		HauteurBandeNoire = 2 * Zoom.Valeur;
		LargeurCapture = (float)(((float)TVSettings[TVTYPE].wCropWidth) / 2.0);
	}

	// Quel pourcentage de la largeur doit etre zoom ?
	Xvisible   = ((float) (HauteurOverlay-HauteurBandeNoire) * ratio) / LargeurCapture;
	
	// Application  la largeur de capture actuelle
	// Explication: 
	// la capture peut etre de 300 ou 600 pixels l'overlay se charge toujours du streching
	DebutLigne = CurrentX - (int) ( (float)CurrentX * Xvisible);

	DebutLigne /= 2;
	HauteurBandeNoire /= 2;

}


// Remarques concernant l'affichage overlay;
//
// La fenetre overlay est cr avec une taille fixe, la carte se charge ensuite
// de l'adapter  la taille de la fenetre k!tv (overlay streching).
//
BOOL Affichage_Init_Screen_Struct()
{
	RECT  sRect, rectscreen;
	int YOverlay;
	BOOL bFail=FALSE;

	//
	// Rcupration des dimensions de la fentre d'affichage
	//
	GetClientRect(hWnd, &rectscreen);
	ClientToScreen(hWnd, (POINT*)&rectscreen.left);
	ClientToScreen(hWnd, (POINT*)&rectscreen.right);
	if (rectscreen.left < 0) rectscreen.left=0;
	if (rectscreen.top < 0) rectscreen.top=0;
	if (rectscreen.right > GetSystemMetrics(SM_CXSCREEN)) rectscreen.right=GetSystemMetrics(SM_CXSCREEN);
	if (rectscreen.bottom > GetSystemMetrics(SM_CYSCREEN)) rectscreen.bottom=GetSystemMetrics(SM_CYSCREEN);
	
	sRect = rectscreen;
	
	Affichage_FreeDIBmemory();
    Affichage_Overlay_Destroy();
	if ( OutDib )
	{
		InvalidateRect(hWnd,NULL,TRUE); 
		//
		// Quelques vrifications et adaptations de la fentre d'affichage
		//
	  	CurrentX = 2 * (rectscreen.right-rectscreen.left)/2;
		CurrentY = (rectscreen.bottom-rectscreen.top);
  		if ( bDisplayStatusBar ) CurrentY -= StatusBar_Height();
		if ( CurrentY <= 10 ) CurrentY=10;
		if ( CurrentX <= 10 ) CurrentX=10;
		if ( CurrentX > TVSettings[TVTYPE].wCropWidth ) CurrentX=TVSettings[TVTYPE].wCropWidth;
		if ( CurrentY > TVSettings[TVTYPE].wCropHeight) CurrentY=TVSettings[TVTYPE].wCropHeight;
	}
	else
	{
		CurrentX=TVSettings[TVTYPE].wCropWidth;
		CurrentY=TVSettings[TVTYPE].wCropHeight;
	}
	if(CurrentX>RES_MAX_X)
	{ 
		if(RES_MAX_X<TVSettings[TVTYPE].wCropWidth)
		{
			if (RES_MAX_X!=TVSettings[TVTYPE].wCropWidth) CurrentX=RES_MAX_X;
		}
		else RES_MAX_X=TVSettings[TVTYPE].wCropWidth;
	}

    if ( IsPluginVideoRunning )
	{
		if(CurrentX>VIA_FIX_X && VIA_FIX)	CurrentX=VIA_FIX_X;//FIX VIA
	}
  	
 	//
 	// Initialisation de la structure pour l'affichage DIB
 	//
 	if (!Affichage_AllocDIBMemory(CurrentX, CurrentY)) 
 		return FALSE;
 
 	if (OutDib)
	{
		LOG(3, "DIB %dx%d", CurrentX, CurrentY);
 		BT8X8_SetGeoSize(CurrentX,CurrentY);
 		return !bFail;
 	}

 	//
 	// Initialisation pour l'affichage Overlay
 	//
 	if ( IsPluginVideoRunning)
	{
 		if (FullField )	YOverlay = CurrentY;
 		else YOverlay = CurrentY/2;
	} else	
		YOverlay = CurrentY;

	if(DeInterlace==2)
	{
		YOverlay/=2;
	}

 	if (ModeOverlay != Affichage_Overlay_Create(CurrentX, YOverlay))
 	{
 		// Si erreur overlay on passe en mode DIB
 		ModeOverlay=FALSE;
 		OutDib = TRUE;
 		BT8X8_SetGeoSize(CurrentX,CurrentY);
 		return TRUE;
 	}
	else	
		StatusBar_Update(0, "");
 
  	BT8X8_SetGeoSize(CurrentX,CurrentY);

	if ( bShowMenu && bDisplayStatusBar && !bIsFullScreen)
		sRect.bottom -= StatusBar_Height();
	
	Affichage_Overlay_Update(CurrentX, YOverlay, &sRect, DDOVER_SHOW,TRUE);
 	Affichage_Overlay_Clean();
 	return bFail;
}


// Passage en mode FullScreen (CooperativeLevel = EXCLUSIVE)
// IDM_640x480, IDM_800x600, IDM_1024x768, IDM_OWN_RES
//
void Affichage_ModeDDrawExclusif(HWND hWnd, int param)
{
	int sizeX, sizeY;
	BOOL SaveWINDOW43, SaveModeOverlay;

	if ( (param == IDM_OWN_RES) && (( Res_X==0 ) || ( Res_Y==0 ))  )
		return;
	
	SaveWINDOW43=bWindow43;
	bWindow43=FALSE;
	SaveModeOverlay=ModeOverlay;

	Stop_Capture(OutDib);
	
	if ( param == IDM_640x480)  { sizeX = 640; sizeY = 480; WindowStyle=4; }
	if ( param == IDM_800x600)  { sizeX = 800; sizeY = 600; WindowStyle=5; }
	if ( param == IDM_1024x768) { sizeX = 1024; sizeY = 768; WindowStyle=6; }
	if ( param == IDM_OWN_RES)  { sizeX = Res_X; sizeY = Res_Y; WindowStyle=7; }

	if ( Affichage_InitDD(hWnd,TRUE,sizeX,sizeY) )
	{
		MoveWindow(hWnd,0,0,sizeX,sizeY,TRUE);
	}
	else  // Sinon essayer 640x480
	{
		Affichage_InitDD(hWnd,FALSE,640,480);
		MoveWindow(hWnd,0,0,640,480,TRUE);
	}
	ModeOverlay=SaveModeOverlay;
	Affichage_Init_Screen_Struct();
	Start_Capture(OutDib);			 
	bWindow43=SaveWINDOW43;
	UpdateMenuBar();
	return;
}



// Slection du format d'affichage : Overlay ou DIB
void Affichage_Format(HWND hWnd, int param)
{
	if (param == IDM_OVERLAY && !Can_Overlay )
		return;

	Stop_Capture(TRUE);
	ModeOverlay = OutDib = FALSE;

	switch (param)
	{
		case IDM_OVERLAY :
			ModeOverlay=TRUE;
			break;

		case IDM_OVERLAY_NBB :
			ModeOverlay=TRUE;
			Overlay_NBB=!Overlay_NBB;
			break;
	
		case IDM_DIB :
			OutDib=TRUE;
			break;
	}
	Affichage_Init_Screen_Struct();
	Start_Capture(TRUE);
	return;
}


void Affichage_Geo_Fenetre(WPARAM wParam, RECT *r, BOOL Move)
{
	int cx, cy;
	float aspect = 0.75;     // aspect ratio Y/X = 3/4
	int i, j; 

	if(!Move) // Redimensionnement de la fenetre... On controle ce qui est fait...
	{
		cx = r->right - r->left; 
		cy = r->bottom - r->top;

		cx=((int)(cx/8))*8;//La res en X est multiple de 8 pour le MMX...sinon ca rame

		// Tenir compte des menus + statusbar
		i = 2 * GetSystemMetrics(SM_CXSIZEFRAME);
		j= 2*GetSystemMetrics(SM_CYSIZEFRAME);
		if (bShowMenu)
		{
			j+= GetSystemMetrics(SM_CYMENU) + GetSystemMetrics(SM_CYMENUSIZE);
			if (bDisplayStatusBar) j+= StatusBar_Height();
		}
	
		switch (wParam) 
		{
			// Redimensionnement par le centre des cts
			case WMSZ_LEFT:
				if ( bWindow43)	cy = (int)((cx-i) * aspect)+j;//mode 4/3
				r->bottom = r->top + cy ;
				r->left = r->left - (r->left % 8);	// Resolution mod 8
				break;

			case WMSZ_RIGHT:   
				if ( bWindow43)	cy = (int)((cx-i) * aspect)+j;//mode 4/3
				r->bottom = r->top + cy ;
				r->right = r->left + cx ;
				break;
				
			case WMSZ_TOP:
			case WMSZ_BOTTOM:   
				if ( bWindow43)	cx = (int) ((cy-j)/aspect)+i;//mode 4/3
				r->right = r->left + cx ;
				break;
			
			// Redimensionnement par les sommets de la fentre
			default:
				{	
					if ( bWindow43)	cy = (int)((cx-i) * aspect)+j;//mode 4/3
					switch(wParam)
					{
						case WMSZ_BOTTOMLEFT:
							r->bottom = r->top + cy;
							r->left = r->right - cx ;
							break;
						case WMSZ_BOTTOMRIGHT:
							r->bottom = r->top + cy;
							r->right = r->left + cx ;
							break;
						case WMSZ_TOPLEFT:
							r->top = r->bottom - cy;
							r->left = r->right - cx ;
							break;
						case WMSZ_TOPRIGHT:
							r->top = r->bottom - cy;
							r->right = r->left + cx ;
							break;
					}	
				}
		}
		WindowStyle=0;
		UpdateMenuBar();
	}
	// On veille a ne pas sortir de l'ecran lors des deplacements de fenetre...
	if(r->left<0) // On ne sort plus par le cote gauche de l'ecran...
	{
		r->right-=r->left;
		r->left=0;
	}
	if(r->right>GetSystemMetrics(SM_CXSCREEN)) // On ne sort plus par le cote droit de l'ecran...
	{
		r->left-=r->right-GetSystemMetrics(SM_CXSCREEN);
		r->right=GetSystemMetrics(SM_CXSCREEN);
	}
	if(r->top<0) // On ne sort plus par le haut de l'ecran...
	{
		r->bottom-=r->top;
		r->top=0;
	}
	if(r->bottom>GetSystemMetrics(SM_CYSCREEN)) // On ne sort plus par le bas de l'ecran...
	{
		r->top-=r->bottom-GetSystemMetrics(SM_CYSCREEN);
		r->bottom=GetSystemMetrics(SM_CYSCREEN);
	}
}


void Affichage_ModeFenetre(HWND hWnd, int param)
{
	int i,j;
	RECT rectscreen;
	
	if(bMinimized) ShowWindow(hWnd,SW_RESTORE); // Si fenetre iconifiee on la restaure a sa taille precedente...
	if(bMaximized) ShowWindow(hWnd,SW_RESTORE); // Si fenetre maximisee on la restaure a sa taille nominale...
	//
	// Si on passe du mode Fullscreen Exclusif en mode Fenetr
	// il faut rinitialiser entirement l'affichage
	if (WindowStyle >= 4)
	{
		Stop_Capture(TRUE);
		Affichage_InitDD(hWnd, FALSE, 0,0);
		Affichage_Init_Screen_Struct();
		Start_Capture(TRUE);
		Affichage_Overlay_Workout(FALSE);
	}

	GetWindowRect(hWnd,&rectscreen);

	switch(param)
	{
		case IDM_FENETRE:
			i=rectscreen.right-rectscreen.left;  j=rectscreen.bottom-rectscreen.top; 
			WindowStyle=0;
			break;
		case IDM_FENETRE392x294:
			i=392; j=294; WindowStyle=1;
			break;
		case IDM_FENETRE512x384:
			i=512; j=384; WindowStyle=2;
			break;
		case IDM_FENETRE768x576:
			if(GetSystemMetrics(SM_CYSCREEN)>600)
			{
				i=768; j=576; WindowStyle=3;
			}
			else
			{
				i=512; j=384; WindowStyle=2;
			}
			break;
	}

	if ( param != IDM_FENETRE)
	{
		i += 2*GetSystemMetrics(SM_CXSIZEFRAME);
		j += 2*GetSystemMetrics(SM_CYSIZEFRAME);
		if (bShowMenu)
		{
			j += GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYMENUSIZE);
			if ( bDisplayStatusBar ) j+= StatusBar_Height();
		}
	}
	
	// On veille a ne pas sortir de l'ecran..
	if(rectscreen.left+i>GetSystemMetrics(SM_CXSCREEN))
	{
		rectscreen.left-=rectscreen.left+i-GetSystemMetrics(SM_CXSCREEN);
		rectscreen.right=GetSystemMetrics(SM_CXSCREEN);
	}
	if(rectscreen.top+j>GetSystemMetrics(SM_CYSCREEN))
	{
		rectscreen.top-=rectscreen.top+j-GetSystemMetrics(SM_CYSCREEN);
		rectscreen.bottom=GetSystemMetrics(SM_CYSCREEN);
	}

	SetWindowPos(hWnd, 0, rectscreen.left,rectscreen.top, i, j, SWP_SHOWWINDOW);
	UpdateMenuBar();
	return;
}


static BOOL Affichage_IsFullScreen_OnChange(long NewValue)
{
    bDoResize = FALSE;
    bIsFullScreen = (BOOL)NewValue;

    // make sure that the window has been created
    if(hWnd != NULL)
    {
        if(!bIsFullScreen)
        {
            SetWindowPos(hWnd, 0, emstartx, emstarty, emsizex, emsizey, SWP_SHOWWINDOW);
            if (bDisplayStatusBar)
            {
//                SetTimer(hWnd, TIMER_STATUS, TIMER_STATUS_MS, NULL);
            }
        }
        else
        {
			RECT rectscreen;

			GetWindowRect(hWnd,&rectscreen);
			emstartx = rectscreen.left;
			emstarty = rectscreen.top;

			emsizex=rectscreen.right-rectscreen.left;
			emsizey=rectscreen.bottom-rectscreen.top;
        }
        Cursor_UpdateVisibility();
        InvalidateRect(hWnd, NULL, FALSE);
        Affichage_Overlay_Workout(FALSE);
    }
    bDoResize = TRUE;
    return FALSE;
}


void Affichage_ToggleFullScreen()
{
	BOOL SavebMaximized;

	SavebMaximized=bMaximized;
	if(SavebMaximized) ShowWindow(hWnd,SW_RESTORE);

	// Impossible si mode fullscreen Exclusif
	if (WindowStyle >= 4)
		return;

	bIsFullScreen = !bIsFullScreen;
	Affichage_IsFullScreen_OnChange(bIsFullScreen);
	bMaximized=SavebMaximized;
	if(!bIsFullScreen && bMaximized)	ShowWindow(hWnd,SW_SHOWMAXIMIZED);
}


void Affichage_ToggleMenu()
{
	int j;
	static BOOL bSaveDisplayStatusBar=TRUE;
	RECT rectscreen;

	bShowMenu = !bShowMenu;
	// Desactive galement l'affichage du statusbar
	if(!bShowMenu)
	{
		bSaveDisplayStatusBar=bDisplayStatusBar;
		bDisplayStatusBar = FALSE;
	}
	else	bDisplayStatusBar = bSaveDisplayStatusBar;

	Affichage_Overlay_Workout(FALSE);

	// si nous sommes en mode fullscreen Exclusif
	// la taille de la fenetre ne doit pas changer.
	if (WindowStyle < 4)
	{
		GetWindowRect(hWnd,&rectscreen);
		if(bShowMenu)	j=rectscreen.bottom-rectscreen.top+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYMENUSIZE)+ StatusBar_Height();
		else j=rectscreen.bottom-rectscreen.top-(GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYMENUSIZE)+ StatusBar_Height());
		SetWindowPos(hWnd,NULL,10,10,rectscreen.right-rectscreen.left,j,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOZORDER);
	}
	UpdateMenuBar();
}


void Affichage_ToggleStatusBar()
{
	int j;
	RECT rectscreen;
	
	bDisplayStatusBar= !bDisplayStatusBar;
	Affichage_Overlay_Workout(FALSE);

	GetWindowRect(hWnd,&rectscreen);
	if(bDisplayStatusBar)
		j=rectscreen.bottom-rectscreen.top + StatusBar_Height();
	else 
		j=rectscreen.bottom-rectscreen.top - StatusBar_Height();
	SetWindowPos(hWnd,NULL,10,10,rectscreen.right-rectscreen.left,j,SWP_NOMOVE|SWP_NOCOPYBITS|SWP_NOZORDER);

	if ( bDisplayStatusBar)
	{
		SetTimer (hWnd, TIMER_STATUS, 2000, NULL);
		OSD_ShowText_Center(hWnd, Langue_GetString(ID_STATUS_ON));
	}
	else
	{
		KillTimer(hWnd, TIMER_STATUS);
		OSD_ShowText_Center(hWnd,Langue_GetString(ID_STATUS_OFF));
	}
	UpdateMenuBar();
}


void Affichage_ToggleOnTop()
{
	bAlwaysOnTop = !bAlwaysOnTop;
	Affichage_Overlay_Workout(FALSE);
	if (bAlwaysOnTop)
		OSD_ShowText_Center(hWnd, Langue_GetString(ID_ONTOP));
	UpdateMenuBar();
}


static void Affichage_UpdateWindowState()
{
	long Style;
	static long SaveStyle;

    if(bIsFullScreen)
    {
        SaveStyle=Style=WS_VISIBLE;
		SetWindowLong(hWnd, GWL_STYLE, Style);
        SetMenu(hWnd, NULL);
		ShowWindow(hwndStatusBar,SW_HIDE);
        SetWindowPos(hWnd,
                    HWND_TOPMOST, // bAlwaysOnTopFull?HWND_TOPMOST:HWND_NOTOPMOST,
                    0,
                    0,
                    GetSystemMetrics(SM_CXSCREEN),
                    GetSystemMetrics(SM_CYSCREEN),
                    SWP_SHOWWINDOW);
    }
    else
    {

		if (!bShowMenu)
		{
			if ( bBorderless ) 
				Style = WS_VISIBLE;
			else  
				Style = WS_VISIBLE|WS_THICKFRAME;
		}
		else
			Style = WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_SYSMENU;

        if(SaveStyle!= Style)
		{
			SetWindowLong(hWnd, GWL_STYLE, Style);
			SaveStyle=Style;
		}
        SetMenu(hWnd, (bShowMenu)?hMenu:NULL);
		ShowWindow(hwndStatusBar, (bDisplayStatusBar&&bShowMenu) ? SW_SHOW:SW_HIDE);
        SetWindowPos(hWnd,bAlwaysOnTop?HWND_TOPMOST:HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);
    }
}


void Affichage_Overlay_Workout(BOOL bInit)
{
	BOOL retval;
	int YOverlay;
	static RECT rectscreen;
    static BOOL InFunction = FALSE;

    if(InFunction) return;
    InFunction = TRUE;

	if(!bInit)	Affichage_UpdateWindowState();
	if (OutDib)
	{
		InFunction = FALSE;
		return;
	}

//	LOG(1, "Mode Overlay %dx%d", CurrentX, CurrentY);
	GetClientRect(hWnd, &rectscreen);

	// La fenetre a t rduite dans la barre des taches
	// il est inutile de continuer
	if (rectscreen.left == 0 && rectscreen.right == 0 &&
		rectscreen.top  == 0 && rectscreen.bottom == 0 )
	{
		InFunction = FALSE;
		return;
	}

	if ( bShowMenu && bDisplayStatusBar && !bIsFullScreen)
		rectscreen.bottom -= StatusBar_Height();

    InvalidateRect(hWnd,NULL,FALSE);
	ClientToScreen(hWnd, (POINT*)&rectscreen.left);
	ClientToScreen(hWnd, (POINT*)&rectscreen.right);

	if ( IsPluginVideoRunning)
	{
 		if (FullField)	YOverlay = CurrentY;
  		else YOverlay = CurrentY/2;
	}
	else
		YOverlay = CurrentY;

	if (DeInterlace==2)
		YOverlay/=2;

 	Affichage_Overlay_PreparationZoom(YOverlay);

	retval = Affichage_Overlay_Update(CurrentX, YOverlay, &rectscreen, DDOVER_SHOW,TRUE);
	if (!retval )
		LOG(1, "Affichage_Overlay_Update Failed");
	InFunction = FALSE;
}



// Reglages des bandes noires (16:9/20:9...)
void SetMovieBoost(int param) 
{
	char TexteOSD[255];

	Stop_Capture(FALSE);
	switch(param)
	{
		case IDM_MOVIEBOOST_169:
			MovieBoost=MOVIEBOOST_16_9; 
			strcpy(TexteOSD, Langue_GetString(ID_MODE169));
			break;
		case IDM_MOVIEBOOST_209:
			MovieBoost=MOVIEBOOST_20_9; 
			strcpy(TexteOSD, Langue_GetString(ID_MODE209));
			break;
		case IDM_MOVIEBOOST_NUL:
			MovieBoost=MOVIEBOOST_DESACTIVE; 
			Zoom.Actif = 0;
			strcpy(TexteOSD, "");
			break;
		case IDM_MOVIEBOOST_MINUS:
			if ( MovieBoost > 0 ) MovieBoost--;
			sprintf(TexteOSD, Langue_GetString(ID_BLACKSTRIP), MovieBoost);
			break;
		case IDM_MOVIEBOOST_PLUS:
			if ( MovieBoost < 90 ) MovieBoost++;
			sprintf(TexteOSD, Langue_GetString(ID_BLACKSTRIP), MovieBoost);
			break;
		default:
			if ( (param >=0) && (param < 90) )
				MovieBoost=param;
			else MovieBoost=0;
			sprintf(TexteOSD, " ");
			break;
	}
	StatusBar_And_OSD_Display(TexteOSD);
	AutoMovieBoostEnable=FALSE;
	Start_Capture(FALSE);
	Affichage_Overlay_Workout(FALSE);
}


void SetZoom() 
{
	int ZoomMsgID;

	if (OutDib) return;

	switch(Zoom.Actif)
	{
	case 0:
		Zoom.Actif=1; Zoom.Defaut = Zoom.Valeur;
		Zoom.Valeur = MOVIEBOOST_16_9;
		ZoomMsgID = ID_ZOOM169;
		break;
	
	case 1:
		Zoom.Actif=2; Zoom.Valeur = MOVIEBOOST_20_9;
		ZoomMsgID = ID_ZOOM209;
		break;
	
	case 2:
		Zoom.Actif=0; Zoom.Valeur = Zoom.Defaut;
		ZoomMsgID = ID_ZOOMDEF;
		break;
	
	case 3:
		Zoom.Actif=0; Zoom.Valeur = 0;
		ZoomMsgID = ID_NOZOOM;
		break;
	}
	Affichage_Overlay_Workout(FALSE);
	StatusBar_And_OSD_Display(Langue_GetString(ZoomMsgID));
	UpdateMenuBar();
}


// Controle du Zoom plus prcis.
void SetZoomAvecPrecision(int param)
{
	if (OutDib) return;

	switch(param)
	{
	case IDM_OVERSCAN_PLUS:
		Zoom.Valeur++;
		if (Zoom.Valeur > 128) Zoom.Valeur = 128;
		StatusBar_And_OSD_Display(Langue_GetString(ID_ZOOM), Zoom.Valeur);
		break;

	case IDM_OVERSCAN_MINUS:
		Zoom.Valeur--; 
		if (Zoom.Valeur < 0) Zoom.Valeur = 0;
		StatusBar_And_OSD_Display(Langue_GetString(ID_ZOOM), Zoom.Valeur);
		break;
	
	default:
		if(param>=0 && param <129)
			Zoom.Valeur=param;
		else return;
		break;
	}
	Affichage_Overlay_Workout(FALSE);
	UpdateMenuBar();
}

