/////////////////////////////////////////////////////////////////////////////
// audiocapture.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <windowsx.h> 
#include <mmsystem.h> 

#include "resource.h"
#include "..\Plugins\ResCommun.h"
#include "audiocapture.h"
#include "K!TV-XP.h"
#include "plugin.h"



//-----------------------------------------------------------------------------


// WhiteAngel - New constant
#define BUFFERS    100
// WhiteAngel

int VolumeIn=52431;//strangers
int VolumeOut=52431;//Strangers
static BOOL canSound;


static WAVEHDR  *waveIHeader=NULL ;
static WAVEHDR  *waveOHeader=NULL ;
// WhiteAngel - Modification
static char     *bufferI[BUFFERS];
static char     *bufferO[BUFFERS];
// WhiteAngel
static HWAVEOUT hWaveO ;
static HWAVEIN  hWaveI ;
static MIXERCONTROLDETAILS_UNSIGNED valeurdepart[4];
static MIXERCONTROLDETAILS_UNSIGNED valeurdepartout[4];
static MIXERCONTROLDETAILS_UNSIGNED nouvelle[4];
static HANDLE Handleaudio=NULL;



//-----------------------------------------------------------------------------
//
// WaveStreamCallback:
//
//  Here we work with a chunk of sound
//
static void CALLBACK WaveStreamCallback ( HWAVEIN hwi , UINT uMsg , 
								   DWORD dwInstance , DWORD dwParam1 , DWORD dwParam2 )
{
	LPWAVEHDR wI , wO ;

	if ( !IsPluginAudioRunning )
		return ;

	if ( uMsg == WIM_DATA )
	{
		wI = (LPWAVEHDR) dwParam1 ;

		if ( wI -> dwBytesRecorded == wI -> dwBufferLength )
		{
			wO = (LPWAVEHDR) wI -> dwUser ;

			if (PluginAudioPresent) 
				PluginAudio->Traitement((PSHORT) wI -> lpData, (PSHORT) wO -> lpData);

			waveOutWrite( hWaveO , wO , sizeof(WAVEHDR) ) ;
			waveInAddBuffer( hWaveI , wI , sizeof(WAVEHDR) ) ;
		}
	}
	else
	if ( uMsg == WIM_OPEN )
	{
		DuplicateHandle(GetCurrentProcess(),GetCurrentThread(),GetCurrentProcess(),&Handleaudio,THREAD_SET_INFORMATION,FALSE,0);
		SetThreadPriority(Handleaudio, PluginAudio->Priorityaudio);
	}
	else
	if ( uMsg == WIM_CLOSE)
	{
		CloseHandle(Handleaudio);
		Handleaudio=NULL;
	}
}


//-----------------------------------------------------------------------------
//
// SoundCapture_Open:
//
//  Here we make the setup for the characteristics of the captured sound.
//
void SoundCapture_Open ()
{
	
	WAVEFORMATEX waveFormat ;
	int    i ;
	
	if (PluginAudioPresent) PluginAudio->Init();

	// Set up audio capture format...
  
	// WhiteAngel - Bug fixed - Don't forget to set the size of the structure
	ZeroMemory(&waveFormat, sizeof(WAVEFORMATEX));
	waveFormat.cbSize = sizeof(WAVEFORMATEX);
	// WhiteAngel

	waveFormat.wFormatTag      = WAVE_FORMAT_PCM ;
	waveFormat.nChannels       = 1 ;
	waveFormat.nSamplesPerSec  = PluginAudio->Soundfreq ;
	waveFormat.wBitsPerSample  = 16 ;
	waveFormat.nBlockAlign     = (waveFormat.nChannels * waveFormat.wBitsPerSample)/8 ;
	waveFormat.nAvgBytesPerSec = ((long)waveFormat.nSamplesPerSec * waveFormat.nBlockAlign) ;
  
	// WhiteAngel - Don't forget synchro tag
	canSound = (waveOutOpen( &hWaveO, WAVE_MAPPER, &waveFormat, 0, 0, CALLBACK_NULL | WAVE_ALLOWSYNC) == MMSYSERR_NOERROR) &&
		(waveInOpen( &hWaveI, WAVE_MAPPER, &waveFormat, (ULONG) WaveStreamCallback, 0, CALLBACK_FUNCTION | WAVE_ALLOWSYNC) == MMSYSERR_NOERROR) ;
	// WhiteAngel

	if ( canSound )
	{
		waveIHeader=(WAVEHDR *)malloc(PluginAudio->Buffers * sizeof(WAVEHDR));
		waveOHeader=(WAVEHDR *)malloc(PluginAudio->Buffers * sizeof(WAVEHDR));
		if ((!waveIHeader) || (!waveOHeader))
		{
			RealErrorBox(Langue_GetString(ID_ERROR_MEMORY));
			SoundCapture_Close() ;
			IsPluginAudioRunning = FALSE ;		
		}

		// WhiteAngel - Bug fixed - Resize the buffer
		for (i = 0; i < PluginAudio->Buffers; i++)
		{
			bufferI[i] = (char*)VirtualAlloc(NULL, PluginAudio->Buflen * sizeof(char) + 8, MEM_COMMIT, PAGE_READWRITE | PAGE_NOCACHE);
			bufferO[i] = (char*)VirtualAlloc(NULL, PluginAudio->Buflen * sizeof(char) + 8, MEM_COMMIT, PAGE_READWRITE | PAGE_NOCACHE);

			if ((!bufferI[i]) || (!bufferO[i]))
			{
				RealErrorBox(Langue_GetString(ID_ERROR_MEMORY));
				SoundCapture_Close() ;
				IsPluginAudioRunning = FALSE ;		
			}
		}
		// WhiteAngel

		for ( i = 0 ; i < PluginAudio->Buffers ; i ++ )
		{
			waveIHeader[i].dwUser		  = (ULONG) &waveOHeader[i] ;
			// WhiteAngel - Modification
			waveIHeader[i].lpData         = bufferI[i];
			// WhiteAngel
			waveIHeader[i].dwBufferLength = PluginAudio->Buflen ;
			// WhiteAngel - Modification
			waveIHeader[i].dwLoops        = 1 ;
			// WhiteAngel
			waveIHeader[i].dwFlags        = 0 ;
			// WhiteAngel - Don't do this for speed reason
			//if (i==0)	waveIHeader[i].dwFlags        = WHDR_BEGINLOOP  ;
			//if (i==PluginAudio->Buffers)	waveIHeader[i].dwFlags        = WHDR_ENDLOOP  ;
			// WhiteAngel
      
			// WhiteAngel - Modification
			waveOHeader[i].lpData         = bufferO[i] ;
			// WhiteAngel
			waveOHeader[i].dwBufferLength = PluginAudio->Buflen ;
			waveOHeader[i].dwLoops        = 1 ;
			waveOHeader[i].dwFlags        = 0 ;
			// WhiteAngel - Don't do this for speed reason
			//if (i==0)	waveOHeader[i].dwFlags        = WHDR_BEGINLOOP  ;
			//if (i==PluginAudio->Buffers)	waveOHeader[i].dwFlags    = WHDR_ENDLOOP  ;
			// WhiteAngel
      
			canSound = canSound && (waveInPrepareHeader(  hWaveI , &waveIHeader[i] , sizeof(WAVEHDR) ) 
				== MMSYSERR_NOERROR) && (waveInAddBuffer(      hWaveI , &waveIHeader[i] , sizeof(WAVEHDR) ) 
				== MMSYSERR_NOERROR) && (waveOutPrepareHeader( hWaveO , &waveOHeader[i] , sizeof(WAVEHDR) )
				== MMSYSERR_NOERROR) ;
      
			if ( !canSound )
				break ;
		}
	}

	if ( canSound )
	{
		if ( SoundSystem.DeviceAnzahl != 0 )
		{
			if((Record.SoundSystem >= 0 ))
			{
				//sauve valeur du volume
				Mixer_Get_UnsignedValue(&SoundSystem.To_Lines[Record.SoundSystem].To_Connection[Record.Destination].To_Control[Record.Connection].MixerDetail[0],Record.SoundSystem,valeurdepart);
				//place nouvelle valeur	
				nouvelle[0].dwValue=VolumeIn;
				nouvelle[1].dwValue=VolumeIn;
				Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Record.SoundSystem].To_Connection[Record.Destination].To_Control[Record.Connection].MixerDetail[0],Record.SoundSystem,nouvelle);
			}
			if((Wave.SoundSystem >= 0 ))
			{
				//sauve valeur du volume
				Mixer_Get_UnsignedValue(&SoundSystem.To_Lines[Wave.SoundSystem].To_Connection[Wave.Destination].To_Control[Wave.Connection].MixerDetail[0],Wave.SoundSystem,valeurdepartout);
				//place nouvelle valeur	
				nouvelle[0].dwValue=VolumeOut;
				nouvelle[1].dwValue=VolumeOut;
				Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Wave.SoundSystem].To_Connection[Wave.Destination].To_Control[Wave.Connection].MixerDetail[0],Wave.SoundSystem,nouvelle);
			}
		}
	}
	else
	{
		RealErrorBox(Langue_GetString(ID_ERROR_NOREC));
		SoundCapture_Close() ;
		IsPluginAudioRunning = FALSE ;		
	}
}


//-----------------------------------------------------------------------------
//
// SoundCapture_Close:
//
//  Here we shut down the sound devices
//
void SoundCapture_Close ()
{
	int i ;

	if ( !canSound )
		return ;

	SoundCapture_Stop() ;

	for ( i = 0 ; i < PluginAudio->Buffers ; i ++ )
	{
		 waveInUnprepareHeader( hWaveI , &waveIHeader[i] , sizeof(WAVEHDR) ) ;
		 waveOutUnprepareHeader( hWaveO , &waveOHeader[i] , sizeof(WAVEHDR) ) ;
	}

	waveInClose( hWaveI ) ;
	waveOutClose( hWaveO ) ;
	free(waveIHeader);
	free(waveOHeader);
	// WhiteAngel - Modification
	for (i = 0 ; i < PluginAudio->Buffers; i++)
	{
		VirtualFree(bufferI[i], (DWORD)NULL, MEM_RELEASE);
		VirtualFree(bufferO[i], (DWORD)NULL, MEM_RELEASE);
	}
	//restauration des ancien paramettre
	if (( SoundSystem.DeviceAnzahl != 0 ))
	{
		if(Record.SoundSystem >= 0 ) Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Record.SoundSystem].To_Connection[Record.Destination].To_Control[Record.Connection].MixerDetail[0],Record.SoundSystem,valeurdepart);
		if((Wave.SoundSystem >= 0 )) Mixer_Set_UnsignedValue(&SoundSystem.To_Lines[Wave.SoundSystem].To_Connection[Wave.Destination].To_Control[0].MixerDetail[0],Wave.SoundSystem,valeurdepartout);
	}		
	canSound = FALSE ;	
	if (PluginAudioPresent)
		PluginAudio->Stop();
}


//-----------------------------------------------------------------------------
//
// SoundCapture_Play/Stop:
//
//  Here we make the ball roll/stop
//
int SoundCapture_Play ()
{
	MMRESULT ret;

	if ( canSound )
	{
		ret=waveInStart( hWaveI );
        switch (ret)
		{
			case MMSYSERR_NOERROR :
				return(0);
			case MMSYSERR_INVALHANDLE :
				return(1);
			case MMSYSERR_NODRIVER :
				return(2);
			case MMSYSERR_NOMEM :
				return(3);
			default :
				return(4);
		}
	}
	return(5);
}


void SoundCapture_Stop ()
{
	MMRESULT ret;
	if ( canSound )
	{
		  ret=waveInReset( hWaveI ) ;
		  ret=waveOutReset( hWaveO ) ;
		  ret=waveInStop( hWaveI ) ;
	}
}
