/////////////////////////////////////////////////////////////////////////////
// Bt_io.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#ifndef BTIO_H
#define BTIO_H

extern CRITICAL_SECTION m_cCrit;

#include "externe/DSdrv.h" 

// General read/write function from DSdrv
#define BT8X8_ReadByte(dwOffset)			memoryReadBYTE(dwOffset)
#define BT8X8_ReadWord(dwOffset)			memoryReadWORD(dwOffset)
#define BT8X8_ReadDword(dwOffset)			memoryReadDWORD(dwOffset)
#define BT8X8_WriteByte(dwOffset,data)		memoryWriteBYTE(dwOffset, data)
#define BT8X8_WriteWord(dwOffset,data)		memoryWriteWORD(dwOffset, data)
#define BT8X8_WriteDword(dwOffset,data)		memoryWriteDWORD(dwOffset, data)


void BT8X8_MaskDataByte(int Offset, BYTE d, BYTE m);
void BT8X8_MaskDataWord(int Offset, WORD d, WORD m);
void BT8X8_AndOrDataDword(int Offset, DWORD d, DWORD m);
void BT8X8_AndDataByte(int Offset, BYTE d);
void BT8X8_AndDataWord(int Offset, short d);
void BT8X8_OrDataByte(int Offset, BYTE d);
void BT8X8_OrDataWord(int Offset, unsigned short d);

// I2C Bus stuff
BOOL I2CBus_AddDevice(BYTE I2C_Port);
BOOL I2CBus_Lock();
BOOL I2CBus_Unlock();
void I2CBus_Start();
void I2CBus_Stop();
void I2CBus_One();
void I2CBus_Zero();
BOOL I2CBus_SendByte(BYTE nData, int nWaitForAck);
BYTE I2CBus_ReadByte(BOOL bLast);
BYTE I2CBus_Read(BYTE nAddr);
BOOL I2CBus_Write(BYTE nAddr, BYTE nData1, BYTE nData2, BOOL bSendBoth);


#endif

