/////////////////////////////////////////////////////////////////////////////
// ddraw.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef BTDDRAW_H
#define BTDDRAW_H

#include <ddraw.h>

// cope with older DX header files
#if !defined(DDFLIP_DONOTWAIT)
    #define DDFLIP_DONOTWAIT 0
#endif


extern LPDIRECTDRAWSURFACE lpDDOverlay;
extern LPVOID lpOverlay;
extern BOOL Can_Overlay;
extern int OverlayPitch;
extern CRITICAL_SECTION hDDCritSect;
extern COLORREF OverlayColor;


void Affichage_Stop(HWND hWnd);
void Affichage_Start(HWND hWnd);

void Affichage_CloseDD();
void Affichage_Overlay_Clean();
BOOL Affichage_Overlay_Update(int x,int y,LPRECT pDestRect,DWORD  dwFlags,BOOL ColorKey);
void Affichage_Overlay_Destroy();
BOOL Affichage_Overlay_Create(int x,int y);
BOOL Affichage_InitDD( HWND hwnd , BOOL Fullscreen, int x , int y );
void Affichage_Overlay_PaintColorkey(HWND hWnd, BOOL bEnable, HDC hDC, RECT* PaintRect, BOOL bNoMiddlePainting = false);
void Affichage_GetDestRect(RECT* rect);
BOOL Affichage_Overlay_Flip(DWORD FlipFlag);
BOOL Affichage_Overlay_UnLock();
BOOL Affichage_Overlay_Lock();

#endif