/////////////////////////////////////////////////////////////////////////////
// hardwareproc.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <windowsx.h> 
#include <commctrl.h>
#include "externe/HtmlHelp.H"
#include "resource.h"
#include "..\Plugins\ResCommun.h"


#include "bt848.h"
#include "btaudio.h"
#include "K!TV-XP.h"
#include "ddraw.h"
#include "bt_io.h"
#include "hardwaremisc.h"
#include "osd.h"
#include "IR_haup.h"
#include "plugin.h"
#include "mixerdev.h"
#include "procs.h"
#include "misc.h"
#include "settings.h"


#define MAX_TAB_CONTROLS	10

static int SaveTuner;
static int SaveVideoSource;
static BOOL PluginsCherche=FALSE;
// Proc gnrique pour le TabControl Gnral
static HWND DiversDlg[MAX_TAB_CONTROLS];
static HWND hTab;

static BOOL APIENTRY Reglages_Tab_BT8X8_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
static BOOL APIENTRY Reglages_Tab_Divers_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
static BOOL APIENTRY Reglages_Tab_Video_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
static BOOL APIENTRY Reglages_Tab_IR_Hauppauge_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
static BOOL APIENTRY Reglages_Tab_Audio_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam);

// Place la bdd  l'intrieur du tab control
static void Reglages_Tab_Affiche_Control(HWND htab, HWND parhwnd, HWND hdlg) 
{ 
	RECT rect; 

	GetClientRect(parhwnd, &rect);
	TabCtrl_AdjustRect(htab,FALSE,&rect); 
	MoveWindow(hdlg, rect.left, rect.top, rect.right-rect.left-10, rect.bottom-rect.top-52,TRUE); 
	ShowWindow(hdlg,SW_SHOWNORMAL); 
}

static void Reglages_Tab_Chercher_Plugin(HWND hdlg)
{
	ChangeCH=TRUE;
	if (IsPluginVideoRunning)
		Plugin_Video_Stopper();
	Plugin_Chercher();
	PluginsCherche=TRUE;
	SendMessage(DiversDlg[1],WM_INITDIALOG,0,0);
	ChangeCH=FALSE;
	SetFocus(hdlg);
}


static void Reglages_Tab_Charger_Plugin(BOOL IsOK)
{
	int i;

	if(IsOK)
	{
		i = ComboBox_GetCurSel(GetDlgItem(DiversDlg[1],IDC_COMBO9));
		if (i > 0)
			strcpy(PlugVideoName, ListePluginsVideo[i-1].Name);
		else
			strcpy(PlugVideoName, "");

		i = ComboBox_GetCurSel(GetDlgItem(DiversDlg[1],IDC_COMBO10));
		if (i > 0)
			strcpy(PlugAudioName, ListePluginsAudio[i-1].Name);
		else
			strcpy(PlugAudioName, "");
	}
	
	Plugin_Video_Decharger();
	Plugin_Audio_Decharger();

	if(strlen(PlugVideoName))
		Plugin_Video_Charger(PlugVideoName);

	if(strlen(PlugAudioName))
		Plugin_Audio_Charger(PlugAudioName);
	SendMessage(hWnd,WM_COMMAND,IDM_UPDATEMENU,0);									
}


BOOL APIENTRY Reglages_GeneralSetupProc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{

	RECT rect;
	int i;
	static HWND hPrecedent;
	static int Max_tabs;
	static TCITEM item;

	switch (message)
	{
		case WM_INITDIALOG:
			hPrecedent = 0;

			hTab = GetDlgItem(hDlg, IDC_TAB1);
			
			item.mask= TCIF_TEXT;
			TabCtrl_DeleteAllItems(hTab);
			item.pszText = Langue_GetString(ID_TAB_TUNER);
			TabCtrl_InsertItem(hTab, 0, &item);
			item.pszText = Langue_GetString(ID_TAB_PLUGIN);
			TabCtrl_InsertItem(hTab, 1, &item);
			item.pszText = Langue_GetString(ID_TAB_AUDIO);
			TabCtrl_InsertItem(hTab, 2, &item);
			item.pszText = Langue_GetString(ID_TAB_IR);
			TabCtrl_InsertItem(hTab, 3, &item);
			item.pszText = Langue_GetString(ID_TAB_MISC);
			TabCtrl_InsertItem(hTab, 4, &item);

			// Le tab control est adapt  la taille de la fenetre
			GetClientRect(hDlg, &rect);
			MoveWindow(hTab, 5, 5, rect.right-10, rect.bottom-52, TRUE);

			DiversDlg[0] = Langue_CreateDialog(hInst, "REGLAGES_TAB_BT8X8", hTab, Reglages_Tab_BT8X8_Proc);
			DiversDlg[1] = Langue_CreateDialog(hInst, "REGLAGES_TAB_VIDEO", hTab, Reglages_Tab_Video_Proc);
			DiversDlg[2] = Langue_CreateDialog(hInst, "REGLAGES_TAB_AUDIO", hTab, Reglages_Tab_Audio_Proc);
			DiversDlg[3] = Langue_CreateDialog(hInst, "REGLAGES_TAB_IR_HAUPPAUGE",hTab, Reglages_Tab_IR_Hauppauge_Proc);
			DiversDlg[4] = Langue_CreateDialog(hInst, "REGLAGES_TAB_DIVERS",hTab, Reglages_Tab_Divers_Proc);
			Max_tabs = 5 ;

			// Activer le premier TAB
			hPrecedent = DiversDlg[0];
			Reglages_Tab_Affiche_Control(hTab, hDlg, hPrecedent);
			break;

		case WM_NOTIFY:
			{
				NMHDR FAR *tem = (NMHDR FAR *)lParam;
				hTab = GetDlgItem(hDlg, IDC_TAB1);
				if (tem->code== TCN_SELCHANGE)
				{
					int num=TabCtrl_GetCurSel(tem->hwndFrom);

					if (hPrecedent != 0)			ShowWindow(hPrecedent, SW_HIDE);					
					if (num >=0 && num < Max_tabs)	hPrecedent = DiversDlg[num];
					
					// Si slection de la BDD Video/Plugins, nous recherchons les plugins.
					// Cette opration prend du temps donc nous la retardons le + possible.
					if (num == 1 && !PluginsCherche)
						Reglages_Tab_Chercher_Plugin(hDlg);
					Reglages_Tab_Affiche_Control(hTab, hDlg, hPrecedent);
				}  
			}
			break;

        case WM_COMMAND:
			switch(LOWORD(wParam)) 
			{

				case IDOK :
					for (i=0; i < Max_tabs; i++)
						SendMessage(DiversDlg[i], WM_COMMAND, wParam, 0);

					if (Fail_Start>1 && 
						(MessageBox(hWnd, Langue_GetString(ID_PROC_CHAN_SEARCH), "K!TV XP",
						MB_ICONQUESTION|MB_YESNO) == IDYES))
						Langue_DialogBox(hInst,"CANAUX_LISTE",hWnd,ProgramListProc);
					Fail_Start-=2;
					EndDialog(hDlg,0);
					break;

				case IDHELP:
					if(hPrecedent==DiversDlg[0])
						HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesGENERAUX.htm#BT8x8", HH_DISPLAY_TOPIC, 0);
					else if(hPrecedent==DiversDlg[1])
						HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesGENERAUX.htm#Affichage", HH_DISPLAY_TOPIC, 0);
					else if(hPrecedent==DiversDlg[2])
						HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesGENERAUX.htm#Audio", HH_DISPLAY_TOPIC, 0);
					else if(hPrecedent==DiversDlg[3])
						HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesGENERAUX.htm#IR", HH_DISPLAY_TOPIC, 0);
					else if(hPrecedent==DiversDlg[4])
						HtmlHelp(hWnd, "Aide/K!TV-XP.chm::/options_reglagesGENERAUX.htm#Divers", HH_DISPLAY_TOPIC, 0);
					break;

				case IDCANCEL :
					for (i=0; i < Max_tabs; i++)
						SendMessage(DiversDlg[i], WM_COMMAND, wParam, 0);
				
					if (Fail_Start==2)	Fail_Start-=2;
					UpdateMenuBar();
					EndDialog(hDlg,TRUE);
					break;
			}
			break;
    }
	return(FALSE);
}


static BOOL APIENTRY Reglages_Tab_BT8X8_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
	
	int i;

	switch (message)
	{
        case WM_INITDIALOG:
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO2));
            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO3));
            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO8));
			
			for(i=0;i<(sizeof(ParametreCarte) / sizeof(ParametreCarte[0]));i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO1), (long)ParametreCarte[i].Name);

			for(i=0;i<(sizeof(Tuners) / sizeof(Tuners[0]));i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO2), (long)Tuners[i].Name);

			for(i=0;i<(sizeof(TVSettings) / sizeof(TVSettings[0]));i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO3), (long)TVSettings[i].Name);
	
			for(i=0;i<5;i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO8), (LONG)(LPSTR)ChaineVideoSource[i]);

			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1), CardType); 
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO2), TunerType); 
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO3), TVTYPE); 
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO8), VideoSource); 

			if ( INIT_PLL == 1 ) CheckDlgButton(hDlg, IDC_CHECK2, TRUE);
			else if ( INIT_PLL == 2 ) CheckDlgButton(hDlg, IDC_CHECK3, TRUE);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_COMBO1:
					ComboBox_SetCurSel(GetDlgItem(DiversDlg[2],IDC_COMBO4), ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].sourceaudio); 
					ComboBox_SetCurSel(GetDlgItem(DiversDlg[2],IDC_COMBO5), ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].mspmode); 
					ComboBox_SetCurSel(GetDlgItem(DiversDlg[2],IDC_COMBO6), ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].mspmajormode); 
					ComboBox_SetCurSel(GetDlgItem(DiversDlg[2],IDC_COMBO7), ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].mspminormode); 
					CheckDlgButton(hDlg, IDC_CHECK2, ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].pll==1);
					CheckDlgButton(hDlg, IDC_CHECK3, ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].pll==2);
					CheckDlgButton(DiversDlg[2], IDC_CHECK9, ParametreCarte[ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1))].autostereo);
					UpdateMenuBar();
					break;

				case IDC_COMBO8:
					if(ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO8))==0)
					{
						SendMessage(hWnd,WM_COMMAND, IDM_TUNER_0 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO2)),0);
					}
					else 
					{
						SendMessage(hWnd,WM_COMMAND,IDM_COMPOSITE - 1 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO8)),0);
					}
					break;

				case IDC_BUTTON1:
					Langue_DialogBox(hInst,"CARTE_PERSO",hDlg,(DLGPROC)CardSettingProc);
					break; 

				case IDC_BUTTON2:
					Langue_DialogBox(hInst,"TUNER_REGLAGES_MANUELS",hDlg,(DLGPROC)TunerSettingProc);
					break;

				case IDC_BUTTON3:
					Langue_DialogBox(hInst,"CANAUX_LISTE",hDlg,(DLGPROC)ProgramListProc);
					if(Fail_Start>1) Fail_Start-=2;
					break; 

				case IDC_CHECK2:
					CheckDlgButton(hDlg, IDC_CHECK3, FALSE);
					break;

				case IDC_CHECK3:
					CheckDlgButton(hDlg, IDC_CHECK2, FALSE);
					break;

				case IDOK:
					CardType=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));

					INIT_PLL=0;
					if ( IsDlgButtonChecked(hDlg, IDC_CHECK2) ) INIT_PLL=1;
					else if ( IsDlgButtonChecked(hDlg, IDC_CHECK3) ) INIT_PLL=2;
					BT8X8_Set_PLL(INIT_PLL);

					if(ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO8))==0)
					{
						SendMessage(hWnd,WM_COMMAND, IDM_TUNER_0 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO2)),0);
					}
					else 
					{
						SendMessage(hWnd,WM_COMMAND,IDM_COMPOSITE - 1 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO8)),0);
					}
					SendMessage(hWnd,WM_COMMAND,IDM_TYPEFORMAT_PAL + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO3)),0);
					break; 

				case IDCANCEL:
					EndDialog(hDlg,0);
				break;

			}
			break;
	}
	return FALSE;
}


static BOOL APIENTRY Reglages_Tab_Video_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{

	int i,CurSel;
	HWND combo1, combo2;

	switch (message)
	{
        case WM_INITDIALOG:
			CheckDlgButton(hDlg, IDC_CHECK11, Enable_OSD);
			for (i = 0; i < 7; i++)
				if (DeInterlace == i)
					CheckDlgButton(hDlg, IDC_RADIO1+i, TRUE);						
			CurSel=0;
			combo1 = GetDlgItem(hDlg,IDC_COMBO9);
			ComboBox_ResetContent(combo1);
			ComboBox_AddString(combo1, Langue_GetString(ID_NOTHING));
			for(i=0; i<TotalPluginVideo; i++)
			{
				ComboBox_AddString(combo1, ListePluginsVideo[i].Description);
				if(strcmp(ListePluginsVideo[i].Name,PlugVideoName)==0)
					CurSel=i+1;
			}
			ComboBox_SetCurSel(combo1, CurSel);
			
			CurSel=0;
			combo2 = GetDlgItem(hDlg,IDC_COMBO10);
			ComboBox_ResetContent(combo2);
			ComboBox_AddString(combo2, Langue_GetString(ID_NOTHING));
			for(i=0; i<TotalPluginAudio; i++)
			{
				ComboBox_AddString(combo2, ListePluginsAudio[i].Description);
				if(strcmp(ListePluginsAudio[i].Name,PlugAudioName)==0)
					CurSel=i+1;
			}
			ComboBox_SetCurSel(combo2, CurSel);
			break;


		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_BUTTON7:
					Langue_DialogBox(hInst,"VIDEO_REGLAGES",hDlg,VideoSettingProc);
					break;

				case IDC_BUTTON8:	// Bouton "Appliquer"
					ChangeCH=TRUE;
					if (IsPluginVideoRunning)
						Plugin_Video_Stopper();
					Stop_Capture(FALSE);
					Sleep(50);
					Reglages_Tab_Charger_Plugin(TRUE);
					Start_Capture(FALSE);
					Affichage_Overlay_Workout(FALSE);
					ChangeCH=FALSE;
					SetFocus(hDlg);
					break;

				case IDC_BUTTON9:	// Bouton "Rafrachir"
					Reglages_Tab_Chercher_Plugin(hDlg);
					break;
					
				case IDOK:
					Enable_OSD = IsDlgButtonChecked(hDlg, IDC_CHECK11);
					for (i = 0; i < 7; i++)
						if (IsDlgButtonChecked(hDlg, IDC_RADIO1 + i)) 
							DeInterlace=i;

				case IDCANCEL:
					if(PluginsCherche)
					{
						ChangeCH=TRUE;
						if (IsPluginVideoRunning)
							Plugin_Video_Stopper();
						Stop_Capture(FALSE);
						Sleep(50);
						Plugin_DScaler_Decharger();
						Plugin_DScaler_Charger();
						Reglages_Tab_Charger_Plugin(LOWORD(wParam)==IDOK);
						Start_Capture(FALSE);
						Affichage_Overlay_Workout(FALSE);
						ChangeCH=FALSE;
					}
					EndDialog(hDlg,0);
					break;
			}
			break;
	}
	return FALSE;
}


static BOOL APIENTRY Reglages_Tab_Audio_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
	switch (message)
	{
        case WM_INITDIALOG:
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO4));
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"Tuner");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"MSP/Radio");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"Externe");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"Interne");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"Sans Son");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO4), (LONG)(LPSTR)"Avec Son");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO4), AudioSource); 

            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO5));
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"AM-mono MSP3400");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"AM-mono MSP3410");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"FM Radio");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"TV Terrestre FM-mono + FM-stro");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"TV Sat FM-mono");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"NICAM B/G, D/K");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"NICAM I");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO5), (LONG)(LPSTR)"NICAM SECAM L");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO5), MSPMode); 

            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO6));
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO6), (LONG)(LPSTR)"NTSC");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO6), (LONG)(LPSTR)"PAL B/G");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO6), (LONG)(LPSTR)"PAL I");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO6), (LONG)(LPSTR)"PAL D/K + Sat + SECAM");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO6), MSPMajorMode); 

            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO7));
			ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL B/G FM-stro");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL B/G NICAM");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL D/K + SECAM  NICAM");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL D/K1 FM-Stro");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL D/K2 FM-Stro");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL SAT FM-stro s/b");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL SAT FM-stro s");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO7), (LONG)(LPSTR)"PAL SAT FM-stro b");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO7), MSPMinorMode); 
			
			if(MSPStereo==1)
				CheckDlgButton(hDlg, IDC_CHECK5, TRUE);
			else if(MSPStereo==2)
				CheckDlgButton(hDlg, IDC_CHECK6, TRUE);
			else if(MSPStereo==3)
				CheckDlgButton(hDlg, IDC_CHECK7, TRUE);
			else 
				CheckDlgButton(hDlg, IDC_CHECK8, TRUE);
			
			if (!Has_MSP)
			{
                EnableWindow(GetDlgItem(hDlg,IDC_CHECK5),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_CHECK6),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_CHECK7),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_CHECK8),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_CHECK9),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON4),FALSE);
				EnableWindow(GetDlgItem(hDlg,IDC_BUTTON5),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_COMBO5),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_COMBO6),FALSE);
                EnableWindow(GetDlgItem(hDlg,IDC_COMBO7),FALSE);
			}
			CheckDlgButton(hDlg, IDC_CHECK9, AutoStereoSelect);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_BUTTON4:
					Langue_DialogBox(hInst,"AUDIO_REGLAGES",hDlg,AudioSettingProc_MSP);
					break; 

				case IDC_BUTTON5:
					Langue_DialogBox(hInst,"AUDIO_REGLAGES_EGALISEUR",hDlg,AudioSettingProc_MSP_EQ);
					break; 

				case IDC_BUTTON6:
					Langue_DialogBox(hInst,"MIXER_REGLAGES",hDlg,MixerSettingProc);
					break; 

				case IDOK:
					SendMessage(hWnd,WM_COMMAND,IDM_AUDIO_0   + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO4)),0);
					if(Has_MSP)
					{
						SendMessage(hWnd,WM_COMMAND,IDM_MSPMODE_0 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO5)),0);
						SendMessage(hWnd,WM_COMMAND,IDM_MAJOR_CARRIER_0 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO6)),0);
						SendMessage(hWnd,WM_COMMAND,IDM_MINOR_CARRIER_0 + ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO7)),0);
	
						if ( IsDlgButtonChecked(hDlg, IDC_CHECK5))		MSPStereo=1;
						else if ( IsDlgButtonChecked(hDlg, IDC_CHECK6)) MSPStereo=2;
						else if ( IsDlgButtonChecked(hDlg, IDC_CHECK7)) MSPStereo=3;
						else MSPStereo=4;
						SendMessage(hWnd,WM_COMMAND, IDM_MSPSTEREO_1 - 1 + MSPStereo,0);
						AutoStereoSelect = IsDlgButtonChecked(hDlg, IDC_CHECK9);
						Audio_MSP_SetSpatial(InitialSpatial);
					}
					break;

				case IDCANCEL:
					EndDialog(hDlg,0);
					break;

			}
			break;
	}
	return FALSE;
}


static BOOL APIENTRY Reglages_Tab_IR_Hauppauge_Proc( HWND hDlg, UINT message, UINT wParam,LONG lParam)
{
static int tIRSampling;

	switch (message)
	{
        case WM_INITDIALOG:
			tIRSampling=IRSampling;
			SetDlgItemInt(hDlg,IDC_EDIT1,tIRSampling,TRUE);
			SetDlgItemText(hDlg,IDC_EDIT2,(const char *)IR_Start);
			if(bIRACtive)
				CheckDlgButton(hDlg, IDC_CHECK1, TRUE);
			break;

		case WM_SHOWWINDOW:

			// Mis a jour des controles uniquement lors de l'affichage
			if ((BOOL) wParam) {
				BOOL enabled;
				
				enabled = FALSE;
				if (ParametreCarte[ComboBox_GetCurSel(GetDlgItem(DiversDlg[0],IDC_COMBO1))].IR_Haup)
					enabled = TRUE;
				
				EnableWindow(GetDlgItem(hDlg,IDC_CHECK1),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_RADIO1),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_RADIO2),enabled);
				EnableWindow(GetDlgItem(hDlg,IDB_FMINUS),enabled);
				EnableWindow(GetDlgItem(hDlg,IDB_FPLUS),enabled);
				EnableWindow(GetDlgItem(hDlg,IDDEFAULT),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_EDIT2),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_S1),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_S2),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_S3),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_S4),enabled);
				EnableWindow(GetDlgItem(hDlg,IDC_S5),enabled);
			}
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDB_FPLUS:
					if(tIRSampling<300)
					{
						tIRSampling+=1;
						SetDlgItemInt(hDlg,IDC_EDIT1,tIRSampling,TRUE);
					}
					break;

				case IDB_FMINUS:
					if(tIRSampling>1)
					{
						tIRSampling-=1;
						SetDlgItemInt(hDlg,IDC_EDIT1,tIRSampling,TRUE);
					}
					break;

				case IDDEFAULT:
					tIRSampling=20;
					SetDlgItemInt(hDlg,IDC_EDIT1,tIRSampling,TRUE);
					SetDlgItemText(hDlg,IDC_EDIT2,"C:/Program Files/WinTV/ir.exe /QUIET");
					CheckDlgButton(hDlg, IDC_RADIO1, TRUE);
					break;

				case IDOK:
					bIRACtive=IsDlgButtonChecked(hDlg,IDC_CHECK1);
					IRSampling=tIRSampling;
					KillTimer(hWnd,TIMER_IR);
					if(bIRACtive)
					{
						IR_Hauppauge_Stop();
						SetTimer(hWnd,TIMER_IR,IRSampling,NULL);
					}
					GetDlgItemText(hDlg,IDC_EDIT2,(char *)IR_Start,255);

				case IDCANCEL:
					EndDialog(hDlg,0);
					break;
			}
			break;
	}
	return(FALSE);
}


static BOOL APIENTRY Reglages_Tab_Divers_Proc(HWND hDlg,UINT message,UINT wParam,LONG lParam)
{
int i;

	switch (message)
	{
        case WM_INITDIALOG:
			CheckDlgButton(hDlg, IDC_CHECK10, bSplashBox);
			CheckDlgButton(hDlg, IDC_CHECK4,  !USETUNER);
			CheckDlgButton(hDlg, IDC_CHECK11, WRITE_LOG);

			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
			for (i = 0; i < TotalLangages; i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO1), (LONG)(LPSTR)Langages[i].Lang);
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1), AppLang); 
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					USETUNER   = !IsDlgButtonChecked(hDlg, IDC_CHECK4);
					bSplashBox = IsDlgButtonChecked(hDlg, IDC_CHECK10);	
					WRITE_LOG  = IsDlgButtonChecked(hDlg, IDC_CHECK11);

					i = ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
					Langue_ChangeLang(i,FALSE);
					break;

				case IDCANCEL:
					EndDialog(hDlg,0);
					break;
			}
			break;
	}
	return FALSE;
}


BOOL APIENTRY ChipSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{	
	switch (message)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_TEXT12,BTMemInfo);
		SetDlgItemText(hDlg,IDC_TEXT6, BTVendorID);
		SetDlgItemText(hDlg,IDC_TEXT7, BTDeviceID);
		SetDlgItemText(hDlg,IDC_TEXT1, BTChipType);
		SetDlgItemText(hDlg,IDC_TEXT13,TunerStatus);
		SetDlgItemText(hDlg,IDC_TEXT14,MSPStatus);
		SetDlgItemText(hDlg,IDC_TEXT16,MSPVersion);
		break;	   
		   
	case WM_COMMAND:
		if ( (LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL ))
			EndDialog(hDlg,TRUE);		
		break;
    }
	return(FALSE);

}


BOOL APIENTRY TunerSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	int i;
	float ffreq;
	unsigned int freq;
	char Text[255];

	switch (message)
	{
		case WM_INITDIALOG:
			SaveTuner=TunerType;
			SaveVideoSource=VideoSource;

			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_COMBO1));
			for (i = 0; i < sizeof (Tuners)/sizeof (Tuners[0]); i++)
				ComboBox_AddString(GetDlgItem(hDlg,IDC_COMBO1), Tuners[i].Name);
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_COMBO1), TunerType); 

			sprintf(Text,"%10.3f",(float)Program[CurrentProgram].freq/1000);
			SetDlgItemText(hDlg,IDC_FREQ,Text);
			PostMessage(hDlg,WM_USER,1,0);
			break;

		case WM_USER:
			if ( wParam == 1 )
			{
	            i=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_COMBO1));
				if (( i >= 0 ) && ( i <= 8 ))
				{ 
					SetDlgItemInt(hDlg,IDT_THRESH1,Tuners[i].thresh1,FALSE);
					SetDlgItemInt(hDlg,IDT_THRESH2,Tuners[i].thresh2,FALSE);
					SetDlgItemInt(hDlg,IDT_VHF_L,Tuners[i].VHF_L,FALSE);
					SetDlgItemInt(hDlg,IDT_VHF_H,Tuners[i].VHF_H,FALSE);
					SetDlgItemInt(hDlg,IDT_UHF,Tuners[i].UHF,FALSE);
					SetDlgItemInt(hDlg,IDT_CONFIG,Tuners[i].config,FALSE);
					SetDlgItemInt(hDlg,IDT_I2C,Tuners[i].I2C,FALSE);
					SetDlgItemInt(hDlg,IDT_IFPCoff,Tuners[i].IFPCoff,FALSE);
				}
			}

			if ( wParam == 2 )
			{
				if ( TunerType != 8 )
				{
					TunerType=8;
					Tuner_Init(TunerType);
				}
				if (  VideoSource != 0 )
				{
					VideoSource = 0;   
					BT8X8_SetVideoSource(VideoSource);
				}

				Tuners[8].thresh1=GetDlgItemInt(hDlg,IDM_THRESH1,NULL,FALSE);
				Tuners[8].thresh2=GetDlgItemInt(hDlg,IDM_THRESH2,NULL,FALSE);
				Tuners[8].VHF_L=GetDlgItemInt(hDlg,IDM_VHF_L,NULL,FALSE);
				Tuners[8].VHF_H=GetDlgItemInt(hDlg,IDM_VHF_H,NULL,FALSE);
				Tuners[8].UHF=GetDlgItemInt(hDlg,IDM_UHF,NULL,FALSE);
				Tuners[8].config=GetDlgItemInt(hDlg,IDM_CONFIG,NULL,FALSE);
				Tuners[8].IFPCoff=GetDlgItemInt(hDlg,IDM_IFPCoff,NULL,FALSE);
				GetDlgItemText(hDlg,IDC_FREQ,Text,sizeof(Text));
 				ffreq=(float)atof(Text);
				freq=(unsigned	long)(ffreq*1000000);
				Tuner_SetFrequency(TunerType,MulDiv(freq,16,1000000));
				SendMessage(hDlg,WM_USER,1,0);
			}
	        break;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDC_COMBO1 )
			{
				if ( HIWORD( wParam ) == CBN_SELCHANGE  )
				{
					SendMessage(hDlg,WM_USER,1,0);
				}
			}

			if (LOWORD(wParam) == IDSET )
			{
				SendMessage(hDlg,WM_USER,2,0);
				SendMessage(hDlg,WM_USER,1,0);
			}
			
			if (LOWORD(wParam) == IDOK )
			{
				GetDlgItemText(hDlg,IDC_FREQ,Text,sizeof(Text));
    			ffreq=(float)atof(Text);
    			EndDialog(hDlg,TRUE);
			}
			
			if (LOWORD(wParam) == IDCANCEL )
			{
				VideoSource=SaveVideoSource;
				TunerType=SaveTuner;
				Tuner_Init(TunerType);
				BT8X8_SetVideoSource(VideoSource);
				Tuner_SetFrequency(TunerType,MulDiv(Program[CurrentProgram].freq*1000,16,1000000));
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}


BOOL APIENTRY CardSettingProc( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{

	switch (message)
	{
        case WM_INITDIALOG:
			SaveTuner=CardType;
			SaveVideoSource=AudioSource;
            PostMessage(hDlg,WM_USER,1,0);
            break;

		case WM_USER:
			if ( wParam == 1 )
			{
				SetDlgItemInt(hDlg,IDC_EDIT1,ParametreCarte[0].GPIO_OUT_EN,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT2,ParametreCarte[0].GPIO_REG_INP,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT3,ParametreCarte[0].GPIO_DATA_Tuner,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT4,ParametreCarte[0].GPIO_DATA_Radio,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT5,ParametreCarte[0].GPIO_DATA_Externe,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT6,ParametreCarte[0].GPIO_DATA_Interne,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT7,ParametreCarte[0].GPIO_DATA_Off,FALSE);
				SetDlgItemInt(hDlg,IDC_EDIT8,ParametreCarte[0].GPIO_DATA_On,FALSE);
			} 
            break;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDSET || LOWORD(wParam) == IDOK)
			{
				// Partie de lecture commune
				ParametreCarte[0].GPIO_OUT_EN=GetDlgItemInt(hDlg,IDC_EDIT1,NULL,FALSE);
				ParametreCarte[0].GPIO_REG_INP=GetDlgItemInt(hDlg,IDC_EDIT2,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_Tuner=GetDlgItemInt(hDlg,IDC_EDIT3,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_Radio=GetDlgItemInt(hDlg,IDC_EDIT4,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_Externe=GetDlgItemInt(hDlg,IDC_EDIT5,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_Interne=GetDlgItemInt(hDlg,IDC_EDIT6,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_Off=GetDlgItemInt(hDlg,IDC_EDIT7,NULL,FALSE);
				ParametreCarte[0].GPIO_DATA_On=GetDlgItemInt(hDlg,IDC_EDIT8,NULL,FALSE);
				if (LOWORD(wParam) == IDOK )
				{
					EndDialog(hDlg,TRUE);
					break;
				}
			
				CardType=0;
				AudioSource=0;
				for (int i = 0; i < 6; i++)
					if (IsDlgButtonChecked(hDlg, IDC_RADIO1 + i))
						AudioSource=i;
				BT8X8_SetAudioSource(AudioSource);            
			}

			if (LOWORD(wParam) == IDCANCEL )
			{
			  CardType=SaveTuner;
 			  AudioSource=SaveVideoSource;
              BT8X8_SetAudioSource(AudioSource);            
              EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}
