/////////////////////////////////////////////////////////////////////////////
// Misc_asm.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
//
// Ce fichier contient plusieurs fonctions optimises en ASM
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"


// Code extrait de DScaler - plugintest
void __cdecl memcpyMMX(void *Dest, void *Src, size_t nBytes)
{
    __asm
	{
	    push    edi
		push    esi
        mov     esi, dword ptr[Src]
        mov     edi, dword ptr[Dest]
        mov     ecx, nBytes
        shr     ecx, 6                      // nBytes / 64
	align 8
	CopyLoop:
        movq    mm0, qword ptr[esi]
        movq    mm1, qword ptr[esi+8*1]
        movq    mm2, qword ptr[esi+8*2]
        movq    mm3, qword ptr[esi+8*3]
        movq    mm4, qword ptr[esi+8*4]
        movq    mm5, qword ptr[esi+8*5]
        movq    mm6, qword ptr[esi+8*6]
        movq    mm7, qword ptr[esi+8*7]
        movq    qword ptr[edi], mm0
        movq    qword ptr[edi+8*1], mm1
        movq    qword ptr[edi+8*2], mm2
        movq    qword ptr[edi+8*3], mm3
        movq    qword ptr[edi+8*4], mm4
        movq    qword ptr[edi+8*5], mm5
        movq    qword ptr[edi+8*6], mm6
        movq    qword ptr[edi+8*7], mm7
        add     esi, 64
        add     edi, 64
        loop CopyLoop
        mov     ecx, nBytes
        and     ecx, 63
        cmp     ecx, 0
        je EndCopyLoop
	align 8
	CopyLoop2:
        mov dl, byte ptr[esi] 
        mov byte ptr[edi], dl
        inc esi
        inc edi
        dec ecx
        jne near CopyLoop2
	EndCopyLoop:
	    pop esi
		pop edi
		emms
    }
}


////////////////////////////////////////////////////////////////////////////////////
// Fonction de convertion YUV2 en format RGB15.  E-nek 1/6/2001
//
// Le code original de "void __fastcall HQAusgebenRGB15()" a t bidouill pour
// n'utiliser que des variables locales et pour desactiver la partie phase (PAL).
// Par bonheur, ca marche mais tout le dbut du code est inutile...
//
// Le prototypage est bizarre, c'est normal ! nous imitons memcpy().
////////////////////////////////////////////////////////////////////////////////////
void * __cdecl Affichage_RGB15(void *dest, void *src, unsigned int longueur)
{
__int64  nMinus128 = 0x8000800080008000;
__int64  nFaktoren = 0xf2fe20491989f9bf;
__int64  TableNulle = 0x2000000000002000;	// = ColFaktor = &NullTable[0] = {8192, 0, 0, 8192};
__int64 nMaske    = 0x00ff00ff00ff00ff;
	_asm
	{
//		mov eax,dword ptr [ColFaktor]
//		mov ecx,BytesOut
		mov ecx,longueur

//		movq mm7,qword ptr [eax]         // mm7 = *pColorFaktor (64Bit)
		movq mm7,qword ptr [TableNulle]
		movq mm4,qword ptr[nMaske]       // mm4 = 0x00ff00ff00ff00ff

//		mov esi,TmpPtr		// original
		mov esi,dest		// new 		
		mov edi,src			// new e-nek
		xor eax,eax

		jmp NaechsterPixel
	align 16

	NaechsterPixel:
		//movq mm0,qword ptr[edx+eax]          // mm0 = *pQuelle 
		movq mm0,qword ptr[edi+eax]				// new e-nek
		movq mm2,mm0

		psubb mm0,qword ptr[nMinus128]   // U-128 V-128
		pand mm2,mm4                     // UV ausmaskieren

		psraw mm0,8
//		movq mm6,qword ptr[edi+eax]  // mm6 = pLinebuffer+nBreiteQuelle*8

		movq mm1,mm0
		punpckldq mm0,mm0

		psrlw mm2,01
		pmaddwd mm0,mm7                  // mm0 += *pColorFaktor

		punpckhdq mm1,mm1
		movq mm5,mm2

		pmaddwd mm1,mm7					// pColorFaktor
		punpcklbw mm2,mm2

		psrad mm0,0x0a					// 0x0a marche mieux que 0x0b
		psrad mm1,0x0a
		packssdw mm0,mm1

//		movq qword ptr[edi+eax],mm0  // mm6 = pLinebuffer+nBreiteQuelle*8

//		paddsw mm0,mm6
		punpckhbw mm5,mm5

		movq mm6,mm0
		movq mm3,qword ptr[nFaktoren]

		punpckldq mm6,mm6

		pmulhw mm6,mm3
		punpckhdq mm0,mm0
		pmulhw mm0,mm3
		movq mm1,mm2
		psllq mm2,0x08
		movq mm3,mm6
		psrlq mm6,0x30
		por mm2,mm1
		paddsw mm6,mm3
		movq mm3,mm5
		psllq mm5,0x08
		packsswb mm6,mm6
		movq mm1,mm0
		psrlq mm0,0x30
		por mm5,mm3
		paddsw mm0,mm1
		pxor mm1,mm1
		packsswb mm0,mm0
		pxor mm3,mm3
		paddsb mm5,mm0
		paddsb mm2,mm6
		pcmpgtb mm3,mm5
		pandn mm3,mm5
		pcmpgtb mm1,mm2
		movq mm0,mm3
		pand mm3,mm4
		psrld mm0,0x0A
		pandn mm1,mm2
		pslld mm0,0x1A
		movq mm5,mm3
		psrlw mm3,2
		movq mm2,mm1
		psrld mm5,2
		pand mm1,mm4
		pslld mm5,0x15
		por mm5,mm0
		movq mm0,mm1
		psrlw mm1,2
		por mm5,mm3
		psrld mm0,2
		pslld mm0,0x15
		psrad mm5,0x10
		por mm1,mm0
		psrld mm2,0x0A
		pslld mm2,0x1A
		por mm2,mm1
		psrad mm2,0x10
		packssdw mm2,mm5
		movq qword ptr [esi+eax],mm2          // Pixel ausgeben
		add eax,8       
		cmp eax,ecx                          // nBreiteQuelle--
		jl near NaechsterPixel          // Sind noch weitere Pixel in dieser Zeile

		// Fin de code apparemment inutile 
/*
		mov eax,LinesAnzahl
		cmp eax,1
		jz  NixMehr

		mov ecx,BytesOut
		mov edx,CurrentPitch
		sub edx,ecx
		mov ebx,ecx
		mov edi,ScreenPtr
		shr ecx,2

	NextLine:
		rep movsd
		mov ecx,ebx
		sub esi,ebx
		shr ecx,2
		add edi,edx
		dec eax
		jnz NextLine
	NixMehr:
*/
		emms            
	}
	return dest;
}