/////////////////////////////////////////////////////////////////////////////
// Plugin.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef PLUGIN_H
#define PLUGIN_H

#include "../plugins/pluginAudio.h"
#include "../plugins/pluginVideo.h"

#include "DScaler/DS_deinterlace.h"
#include "DScaler/DS_ApiCommon.h"


#define MAX_PLUGINS		10

struct ListePlugins 
{
	char Name[50];
    char Description[50];
};
extern char PlugVideoName[255], PlugAudioName[255];

extern struct ListePlugins ListePluginsVideo[MAX_PLUGINS];
extern struct ListePlugins ListePluginsAudio[MAX_PLUGINS];

extern int TotalPluginVideo, TotalPluginAudio;
extern CRITICAL_SECTION PluginCrit;
extern BOOL AutoProcessVideo;
extern BOOL ForcePluginVideo;
extern BOOL AutoProcessAudio;


////////////////////////////////////////////////////////////////////////////
// Partie concernant le plugin Vido
typedef QuenotteTV_VideoPlugin* (WINAPI *tGetVPlugin)();
extern QuenotteTV_VideoPlugin *PluginVideo;
extern BOOL IsPluginVideoRunning, PluginVideoPresent;


////////////////////////////////////////////////////////////////////////////
// Partie concernant le plugin Audio
typedef QuenotteTV_AudioPlugin* (WINAPI *tGetPlugin)();
extern QuenotteTV_AudioPlugin *PluginAudio;
extern BOOL PluginAudioPresent, IsPluginAudioRunning;


////////////////////////////////////////////////////////////////////////////
// Partie concernant le plugin DSCALER
extern DEINTERLACE_INFO DIinfo;
extern DEINTERLACE_METHOD *DScalerMethod;

extern BOOL IsDScalerPluginRunning;
extern BOOL PluginDScalerPresent;
extern int DeInterlace;



////////////////////////////////////////////////////////////////////////////
void Plugin_Video_Charger(char *);
void Plugin_Audio_Charger(char *);
void Plugin_DScaler_Charger();

void Plugin_Video_Decharger();
void Plugin_Audio_Decharger();
void Plugin_DScaler_Decharger();

BOOL Plugin_Video_Demarrer();
BOOL Plugin_Video_Stopper();
void Plugin_Audio_StartStop();

void Plugin_Chercher();
void ReconnaissanceSignal();

#endif