/////////////////////////////////////////////////////////////////////////////
// IniHand.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"

#include "bt848.h"
#include "vbi-vt.h"
#include "K!TV-XP.h"
#include "mixerdev.h"
#include "audiocapture.h"
#include "btaudio.h"
#include "thread.h"
#include "procs.h"
#include "osd.h"
#include "plugin.h"
#include "misc.h"
#include "coderisc.h"
#include "IR_haup.h"
#include "settings.h"
#include "nextview.h"

#include "../readwriteini/readwriteini.h"

extern int RES_list[];
static char mixervol[255], mixerwave[255], mixerrecord[255];
struct TCountries Countries[35];

int CountryCode=0;
struct TChannels Channels;
struct TProgram Program[MAXPROGS+1];

// Configuration de K!TV-XP.ini
struct ConfigINI cfg[]={
//	parameter				type			variable		section		Array size (optional)

//CARTE
	{"Card"					,CFG_SECTION	, NULL			  },
	{"VIDEO_CARD"			,CFG_INT		,&CardType		},
	{"TUNER_USE"			,CFG_BOOL		,&USETUNER		},
	{"VIDEO_SOURCE"			,CFG_INT		,&VideoSource	},
	{"AUDIO_SOURCE"			,CFG_INT		,&AudioSource	},
	{"TUNER_TYPE"			,CFG_INT		,&TunerType		},
	{"TV_TYPE"				,CFG_INT		,&TVTYPE		},
	{"BT848_PLL"			,CFG_BYTE		,&INIT_PLL		},

//AUDIO
	{"Audio"				,CFG_SECTION	, NULL			  },
	{"BT848_GPIO_OUT_EN"	,CFG_INT		,&ParametreCarte[0].GPIO_OUT_EN	},
	{"BT848_GPIO_REG_INP"	,CFG_INT		,&ParametreCarte[0].GPIO_REG_INP	},
	{"BT848_GPIO_DATA_TUNER",CFG_INT		,&ParametreCarte[0].GPIO_DATA_Tuner	},
	{"BT848_GPIO_DATA_RADIO",CFG_INT		,&ParametreCarte[0].GPIO_DATA_Radio	},
	{"BT848_GPIO_DATA_EXTERN",CFG_INT		,&ParametreCarte[0].GPIO_DATA_Externe	},
	{"BT848_GPIO_DATA_INTERN",CFG_INT		,&ParametreCarte[0].GPIO_DATA_Interne	},
	{"BT848_GPIO_DATA_OFF"	,CFG_INT		,&ParametreCarte[0].GPIO_DATA_Off	},
	{"BT848_GPIO_DATA_ON"	,CFG_INT		,&ParametreCarte[0].GPIO_DATA_On	},

	{"MSP_MODE"				,CFG_INT		,&MSPMode				},
	{"MSP_MAJOR"			,CFG_INT		,&MSPMajorMode			},
	{"MSP_MINOR"			,CFG_INT		,&MSPMinorMode			},
	{"MSP_STEREO"			,CFG_INT		,&MSPStereo				},
	{"MSP_AUTO_STEREO"		,CFG_BOOL		,&AutoStereoSelect		},
	{"MSP_VOLUME"			,CFG_INT		,&InitialVolume			},
	{"MSP_SPATIAL"			,CFG_BYTE		,&InitialSpatial		},
	{"MSP_LOUDNESS"			,CFG_BYTE		,&InitialLoudness		},
	{"MSP_BASS"				,CFG_BYTE		,&InitialBass			},
	{"MSP_TREBLE"			,CFG_BYTE		,&InitialTreble			},
	{"MSP_BALANCE"			,CFG_BYTE		,&InitialBalance		},
	{"MSP_SUPERBASS"		,CFG_BOOL		,&InitialSuperBass		},
	{"MSP_NICAM"			,CFG_BYTE		,&InitialNicam			},
	{"MSP_AM"				,CFG_BYTE		,&InitialAM				},
	{"MSP_EQUALIZER1"		,CFG_BYTE		,&InitialEqualizer1		},
	{"MSP_EQUALIZER2"		,CFG_BYTE		,&InitialEqualizer2		},
	{"MSP_EQUALIZER3"		,CFG_BYTE		,&InitialEqualizer3		},
	{"MSP_EQUALIZER4"		,CFG_BYTE		,&InitialEqualizer4		},
	{"MSP_EQUALIZER5"		,CFG_BYTE		,&InitialEqualizer5		},

//TUNER
	{"Tuner"				,CFG_SECTION	, NULL					},
	{"TUNER_THRESH1"		,CFG_INT		,&Tuners[8].thresh1		},
	{"TUNER_THRESH2"		,CFG_INT		,&Tuners[8].thresh2		},
	{"TUNER_VHF_L"			,CFG_BYTE		,&Tuners[8].VHF_L		},
	{"TUNER_VHF_H"			,CFG_BYTE		,&Tuners[8].VHF_H		},
	{"TUNER_UHF"			,CFG_BYTE		,&Tuners[8].UHF			},
	{"TUNER_CONFIG"			,CFG_BYTE		,&Tuners[8].config		},
	{"TUNER_I2C"			,CFG_BYTE		,&Tuners[8].I2C			},
	{"TUNER_IFPCOFF"		,CFG_INT		,&Tuners[8].IFPCoff		},

//VIDEO
	{"Video"				,CFG_SECTION		, NULL					},
	{"BT848_CONTRAST_REGISTER_PAL",CFG_INT		,&InitialContrast[0]	},
	{"BT848_BRIGHTNESS_REGISTER_PAL",CFG_BYTE	,&InitialBrightness[0]	},
	{"BT848_SATURATION-U_REGISTER_PAL",CFG_INT	,&InitialSaturationU[0]	},
	{"BT848_SATURATION-V_REGISTER_PAL",CFG_INT	,&InitialSaturationV[0]	},
	{"BT848_HUE_REGISTER"	,CFG_BYTE			,&InitialHue			},
	{"BT848_CONTRAST_REGISTER_NTSC",CFG_INT		,&InitialContrast[1]	},
	{"BT848_BRIGHTNESS_REGISTER_NTSC",CFG_BYTE	,&InitialBrightness[1]	},
	{"BT848_SATURATION-U_REGISTER_NTSC",CFG_INT	,&InitialSaturationU[1]	},
	{"BT848_SATURATION-V_REGISTER_NTSC",CFG_INT	,&InitialSaturationV[1]	},
	{"BT848_CONTRAST_REGISTER_SECAM",CFG_INT	,&InitialContrast[2]	},
	{"BT848_BRIGHTNESS_REGISTER_SECAM",CFG_BYTE	,&InitialBrightness[2]	},
	{"BT848_SATURATION-U_REGISTER_SECAM",CFG_INT,&InitialSaturationU[2]	},
	{"BT848_SATURATION-V_REGISTER_SECAM",CFG_INT,&InitialSaturationV[2]	},
	{"LINK_UV"				,CFG_BOOL			,&LINK_UV				},

//AFFICHAGE	
	{"Display"				,CFG_SECTION	, NULL					},
	{"WINDOW_SIZE_X"		,CFG_INT		,&emsizex				},
	{"WINDOW_SIZE_Y"		,CFG_INT		,&emsizey				},
	{"WINDOW_START_X"		,CFG_INT		,&emstartx				},
	{"WINDOW_START_Y"		,CFG_INT		,&emstarty 				},
	{"RES_X"				,CFG_INT		,&Res_X 				},
	{"RES_Y"				,CFG_INT		,&Res_Y 				},
	{"OVERLAY_MODE"			,CFG_BOOL		,&ModeOverlay 			},
	{"OVERLAY_NBB"			,CFG_BOOL		,&Overlay_NBB 			},
	{"ZOOM"					,CFG_INT		,&Zoom.Valeur 			},
	{"TOP_MOST"				,CFG_BOOL		,&bAlwaysOnTop 			},
	{"WINDOW_43"			,CFG_BOOL		,&bWindow43	 			},
	{"AUTO_MOVIEBOOST"		,CFG_BOOL		,&bAutoMovieBoost 		},
	{"OSD_ENABLED"			,CFG_BOOL		,&Enable_OSD	 		},
	{"OSD_ANTIALIASED"		,CFG_BOOL		,&bAntiAlias	 		},
	{"RES_MAX_X"			,CFG_INT		,&RES_MAX_X		 		},
	{"AUTO_HIDE_CURSOR"		,CFG_BOOL		,&bAutoHideCursor 		},
	{"SLEEP_INTERVAL"		,CFG_INT		,&Sleep_Interval 		},

//PARAMETRES
	{"Parameters"			,CFG_SECTION	, NULL					},
	{"SHUTDOWN_OPTION"		,CFG_INT		,&Shutdown.Flag			},
	{"LAST_PROGRAM"			,CFG_INT		,&CurrentProgram		},
	{"COUNTRY_CODE"			,CFG_INT		,&CountryCode			},
	{"LANGUAGE"				,CFG_STRING		,&LangName				},
	{"SPLASH_BOX"			,CFG_BOOL		,&bSplashBox			},
	{"WRITE_LOG"			,CFG_BOOL		,&WRITE_LOG				},
	{"VBI_CAPTURE"			,CFG_BOOL		,&Capture_VBI			},

//MULTIPROCESSEURS
	{"Processors/Priorities",CFG_SECTION	, NULL					},
	{"WINDOW_PROCESSOR"		,CFG_INT		,&MainProcessor			},
	{"PLUGIN_PROCESSOR"		,CFG_INT		,&DisplayProcessor		},
	{"PROCESS_PRIORITY"		,CFG_INT		,&PriorClassId			},
	{"THREAD_PRIORITY"		,CFG_INT		,&ThreadClassId			},

//MIXER
	{"Mixer"				,CFG_SECTION	, NULL					},
	{"USE_MIXER"			,CFG_BOOL		,&USE_MIXER				},
	{"MIXER_VOLUME_LEFT"	,CFG_INT	,&MIXER_CANAL_GAUCHE	},
	{"MIXER_VOLUME_RIGHT"	,CFG_INT		,&MIXER_CANAL_DROIT	},
	{"MIXER_VOLUME_CONTROL"	,CFG_STRING		,&mixervol				},
	{"MIXER_WAVE"			,CFG_STRING		,&mixerwave				},
	{"MIXER_RECORD"			,CFG_STRING		,&mixerrecord			},

//IR Hauppauge
	{"IR Hauppauge"			,CFG_SECTION	, NULL					},
	{"IR_HAUPPAUGE_ACTIVE"	,CFG_BOOL		,&bIRACtive			 	},
	{"IR_HAUPPAUGE_SAMPLING",CFG_INT		,&IRSampling		 	},
	{"IR_HAUPPAUGE_DIR"		,CFG_STRING		,&IR_Start			 	},

// MISCS
	{"Divers"				,CFG_SECTION	, NULL					},
	{"DEINTERLACE"			,CFG_INT		,&DeInterlace		 	},
	{"NEXTVIEW_EPG"			,CFG_BOOL		,&bNXTVactive		 	},
	{"NEXTVIEW_EPG_PATH"	,CFG_STRING		,&NextViewPath		 	},
	{"NEXTVIEW_EPG_AUTO"	,CFG_BOOL		,&bNextViewAuto		 	},
	{"PLUGIN_VIDEO"			,CFG_STRING		,&PlugVideoName		 	},
	{"PLUGIN_AUDIO"			,CFG_STRING		,&PlugAudioName		 	},
	{"FULL_FIELD"			,CFG_BOOL		,&FullField		 		},
	{"VIA_FIX"				,CFG_BOOL		,&VIA_FIX 				},
	{"VIA_FIX_X"			,CFG_INT		,&VIA_FIX_X				},
	{"REC_VOL"				,CFG_INT		,&VolumeIn				},
	{"PLAY_VOL"				,CFG_INT		,&VolumeOut				},

	{NULL , 0 ,NULL}
};



BOOL INI_Charger(LPSTR INIFileName) // Chargement du fichier ini
{

	int read;
	struct TMixerAccess EmptyMixer = {-1,0,0,0};

	if (!ChargerINI(cfg, INIFileName))
		return FALSE;

	if ( TVTYPE == 5 ) TVTYPE=0;
	
	// mixer settings
	Volume = Wave = Record = EmptyMixer;
	read = sscanf(mixervol, "%03d %03d %03d %03d %03d",&Volume.SoundSystem,&Volume.Destination,&Volume.Connection,&Volume.Control,&Volume.ControlMute);
	if ( read != 5 ) Volume = EmptyMixer;
	
	read = sscanf(mixerrecord, "%03d %03d %03d %03d",&Wave.SoundSystem,&Wave.Destination,&Wave.Connection,&Wave.Control);
	if ( read != 4 ) Wave = EmptyMixer;

	read = sscanf(mixerrecord, "%03d %03d %03d %03d",&Record.SoundSystem,&Record.Destination,&Record.Connection,&Record.Control);
	if ( read != 4 ) Record = EmptyMixer;

	for (int i = 0; i < 7; i++)
		if (RES_list[i] == RES_MAX_X)
		{
			RES_index = i;
			break;
		}
	if (!ModeOverlay  && !OutDib)
		OutDib = TRUE;
	if (ModeOverlay && OutDib)
		OutDib = FALSE;
	if ( emsizex < 37 )
	{
		emsizex=450;
		emstartx=10;
	}
	if ( emsizey < 37 )
	{
		emsizey=350;
		emstarty=10;
	}
	if ( emstartx > GetSystemMetrics(SM_CXSCREEN) || emstartx < 0) emstartx=10;
	if ( emstarty > GetSystemMetrics(SM_CYSCREEN) || emstarty < 0) emstarty=10;

	return TRUE;
}


BOOL INI_Ecrire(LPSTR INIFileName) // Ecriture du fichier ini
{
	RECT nowRect; 

	// Taille et position de la fenetre avant de quitter
	GetWindowRect(hWnd,&nowRect);
	emsizex=nowRect.right-nowRect.left;
	emsizey=nowRect.bottom-nowRect.top;
	emstartx=nowRect.left;
	emstarty=nowRect.top;
	if (!bShowMenu )
	{
		emsizex+=2*GetSystemMetrics(SM_CXSIZEFRAME)+6;
		emsizey+=GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYMENUSIZE)+(2*GetSystemMetrics(SM_CYSIZEFRAME))+ StatusBar_Height();
	}
	sprintf(mixervol,		"%03d %03d %03d %03d %03d",Volume.SoundSystem,Volume.Destination,Volume.Connection,Volume.Control,Volume.ControlMute);
	sprintf(mixerwave,		"%03d %03d %03d %03d",Wave.SoundSystem,Wave.Destination,Wave.Connection,Wave.Control );
	sprintf(mixerrecord,	"%03d %03d %03d %03d",Record.SoundSystem,Record.Destination,Record.Connection,Record.Control );
	Zoom.Valeur=((Zoom.Actif==0)?Zoom.Valeur:Zoom.Defaut);
	SauverINI(cfg, INIFileName);
	return TRUE;
} 


void Channel_Load_Country_Settings() // Chargement de la liste des canaux : informations sur les pays
{
	FILE* iniFile;
	char ligne[128];
	char *Pos;
	char *Pos1;
	char *SemmelPos;
	unsigned int i;
	
	for ( i=0; i< 32; i++ )
	{
		Countries[i].Name[0]=0x00;
	}
	
	if ((iniFile=fopen("Channel.lst","r")) == NULL )
	{
		RealErrorBox(Langue_GetString(ID_ERROR_CHANNEL));
        return;
	}
	i=0;
	
	while ( fgets(ligne,sizeof(ligne),iniFile) != NULL ) 
	{
		if ( i >= 35 )
		{
			RealErrorBox(Langue_GetString(ID_ERROR_CHANFOR));
			fclose(iniFile);
			return;
		}
		SemmelPos=strstr(ligne,";");
		if ( SemmelPos==NULL )	 SemmelPos=strstr(ligne,"\n");
		
		
		if (((Pos=strstr(ligne,"[")) != 0) && ( SemmelPos > Pos ) && ((Pos1=strstr(ligne,"]")) != 0) )
		{
			
			Pos++;
			Pos1=&Countries[i].Name[0];
			i++;
			while ( *Pos != ']' ) {
				*(Pos1++)=*(Pos++);
				*Pos1=0x00;
			}
		}
		
	}
	
	fclose(iniFile);
}


void Channel_Load_Country_Specific_Settings(int LPos) // Chargement de la liste des canaux : canaux par pays
{
	int i,j,k;
	FILE* iniFile;
	char ligne[128];
	char txt[128];
	char *Pos;
	char *Pos1;
	char *SemmelPos;
	
	
	if ((iniFile=fopen("Channel.lst","r")) == NULL )
	{
		RealErrorBox(Langue_GetString(ID_ERROR_CHANNEL));
        return;
	}
	i=0;
	k=0;
	
	while ( fgets(ligne,sizeof(ligne),iniFile) != NULL ) 
	{	
		SemmelPos=strstr(ligne,";");
		if ( SemmelPos==NULL )	 SemmelPos=strstr(ligne,"\n");
		
		sprintf(txt,"[%s]",Countries[LPos].Name);
		
		if ( strstr(ligne,txt) != 0 ) {
			strcpy(Channels.Name,Countries[LPos].Name);
			while ( fgets(ligne,sizeof(ligne),iniFile) != NULL )
			{
				SemmelPos=strstr(ligne,";");
				if ( SemmelPos==NULL )	 SemmelPos=strstr(ligne,"\n");
				
				if (((Pos=strstr(ligne,"[")) != 0) && ( SemmelPos > Pos ) && ((Pos1=strstr(ligne,"]")) != 0) )
				{
					fclose(iniFile);
					return;
				}
				
				if (((Pos=strstr(ligne,"KanalLow=")) != 0) && ( SemmelPos > Pos ))
				{
					Pos=Pos+9;
					j=0;
					txt[j]=0x00;
					while ( Pos < SemmelPos)
					{
						if ( *Pos != 0x20 )
						{
							txt[j]=*Pos;
							j++;
							txt[j]=0x00;
						}
						Pos++;
					}
					Channels.MinChannel=atoi(txt);
				}
				else if (((Pos=strstr(ligne,"KanalHigh=")) != 0) && ( SemmelPos > Pos ))
				{
					Pos=Pos+10;
					j=0;
					txt[j]=0x00;
					while ( Pos < SemmelPos)
					{
						if ( *Pos != 0x20 )
						{
							txt[j]=*Pos;
							j++;
							txt[j]=0x00;
						}
						Pos++;
					}
					Channels.MaxChannel=atoi(txt);
				}
				else 
				{
					Pos=&ligne[0];
					j=0;
					txt[j]=0x00;
					while ( Pos < SemmelPos)
					{
						if (( *Pos >= '0') && ( *Pos <= '9'))
						{
							txt[j]=*Pos;
							j++;
							txt[j]=0x00;
						}
						Pos++;
					}
					if ( txt[0] != 0x00 ) 
					{
						Channels.freq[k]=atol(txt);
						Channels.freq[k]=Channels.freq[k]/1000;
						k++;
					}
				}
			}
			
		}
	}
	fclose(iniFile);
	return;
}


// 
// Load ascii formatted program list
//
// 9 Novemeber 2000 - Michael Eskin, Conexant Systems
//
// List is a simple text file with the following format:
// Name <display_name>
// Freq <frequency_KHz>
// Name <display_name>
// Freq <frequency_KHz>
// ...
//
void Channel_Load_Program_List() // Chargement de la liste des preselections
{
	int i, j, ch;
	char sbuf[256];
    int Format = -1;
    int Source = -1;
    BOOL Active = TRUE;
	FILE *SettingFile;

	// Zero out the program list
	for (i = 0; i < MAXPROGS+1; i++)
	{
		memset(&Program[i].Name[0], 0x00, sizeof(struct TProgram));
		Program[i].Active=FALSE;
		Program[i].Source=0;
		Program[i].Format=-1;
	}
	
	if ((SettingFile = fopen("program.set", "r")) != NULL)
	{
		i=1;

		while (TRUE)
		{
			// Read the name (may contain white space)
            if (fscanf(SettingFile, "%s ", sbuf) == EOF) // Skip past "Name: "
                break;
            j = 0;
            while (TRUE)
            {
                if (j == sizeof(sbuf) - 1 || (ch = getc(SettingFile)) == '\n')
                    break;

                if (ch == EOF)
                    goto error;

                if (ch != '\r')
                    sbuf[j++] = (char)ch;
            }
            sbuf[j] = '\0';
            strcpy(Program[i].Name, sbuf);

			// Read the frequency
			if (fscanf(SettingFile, "%s %ld\n", sbuf, &Program[i].freq) == EOF)
			{
				// Error condition - premature EOF
				goto error;
			}
			// Read the Format
			if (fscanf(SettingFile, "%s %d\n", sbuf, &Program[i].Format) == EOF)
			{
				// Error condition - premature EOF
				goto error;
			}
			// Read the Source
			if (fscanf(SettingFile, "%s %d\n", sbuf, &Program[i].Source) == EOF)
			{
				// Error condition - premature EOF
				goto error;
			}
			// Read the Active status
			if (fscanf(SettingFile, "%s %d\n", sbuf, &Program[i].Active) == EOF)
			{
				// Error condition - premature EOF
				goto error;
			}

			i++;
		}

		fclose(SettingFile);
	}
	else Fail_Start+=2;
	return;

	error:
	// Close the file
	fclose(SettingFile);
	
	// Reset program list
	for (i = 0; i < MAXPROGS+1; i++)
	{
		memset(&Program[i].Name[0], 0x00, sizeof(struct TProgram));
	}
	Fail_Start+=2;
}


// 
// Save ascii formatted program list
//
// 9 Novemeber 2000 - Michael Eskin, Conexant Systems
//
// List is a simple text file with the following format:
// Name <display_name>
// Freq <frequency_KHz>
// Name <display_name>
// Freq <frequency_KHz>
// ...
//
void Channel_Write_Program_List() // Ecriture de la liste des preselections
{
	int i, j;
	FILE *SettingFile;
	
	i = 1;
	while (i < MAXPROGS+1)
	{
		if (Program[i].Name[0] == 0x00)
		{
			// i has the number of valid programs
			break;
		}
		i++;
	}

	if (i)
	{
		if ((SettingFile = fopen("program.set", "w")) != NULL)
		{
			for (j=1;j<i;++j)
			{
				fprintf(SettingFile, "Name: %s\n", Program[j].Name);
				fprintf(SettingFile, "Freq: %ld\n", Program[j].freq);
				fprintf(SettingFile, "Format: %d\n", Program[j].Format);
				fprintf(SettingFile, "Source: %d\n", Program[j].Source);
				fprintf(SettingFile, "Actif: %d\n", Program[j].Active);
			}

			fclose(SettingFile);
		}
	}
}
