/////////////////////////////////////////////////////////////////////////////
// Settings.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef SETTINGS_H
#define SETTINGS_H

#define MAXPROGS 256

typedef struct TProgram
{
	char Name[30];
    unsigned long freq;
	int Format;
	int Source;
	BOOL Active;
} TProgram;
extern struct TProgram Program[MAXPROGS+1];

typedef struct TChannels
{
        char Name[128];
		int MinChannel;
		int MaxChannel;
        unsigned long freq[512];
} TChannels;

typedef struct TCountries
{
        char Name[128];
} TCountries;

extern struct TCountries Countries[35];
extern struct TChannels Channels;
extern int CountryCode;



void Channel_Load_Country_Settings();
void Channel_Load_Country_Specific_Settings(int LPos);

void Channel_Load_Program_List();
void Channel_Write_Program_List();

BOOL INI_Charger(LPSTR Name);
BOOL INI_Ecrire(LPSTR Name);

#endif