/////////////////////////////////////////////////////////////////////////////
// VBI.c
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000 John Adcock.  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//  This file is subject to the terms of the GNU General Public License as
//  published by the Free Software Foundation.  A copy of this license is
//  included with this software distribution in the file COPYING.  If you
//  do not have a copy, you may obtain a copy by writing to the Free
//  Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on Multidec 5.6 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
// Code adapt de Dscaler (VBI.cpp)
// Copyright (c) 2000 John Adcock.  All rights reserved.
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "windows.h"
#include "resource.h"
#include "..\Plugins\ResCommun.h"

#include "bt848.h"
#include "vbi-vt.h"
#include "K!TV-XP.h"
#include "hardwaremisc.h"
#include "osd.h"
#include "misc_asm.h"
#include "misc.h"
#include "VBI_VideoText.h"
#include "nextview.h"


BYTE VBI_thresh;
BYTE VBIOffset;
int VTStep;
int VPSStep;

HWND ShowVPSInfo=NULL, ShowVTInfo;
struct TSous_Titres Sous_Titres;


static void VBI_AGC(BYTE* Buffer, int start, int stop, int step)
{
    int i, min = 255, max = 0;

    for (i = start; i < stop; i += step)
    {
        if (Buffer[i] < min)
        {
            min = Buffer[i];
        }
        else if (Buffer[i] > max)
        {
            max = Buffer[i];
        }
    }
    VBI_thresh = (max + min) / 2;
    VBIOffset = 128 - VBI_thresh;
}


static void VBI_DecodeLine(unsigned char* VBI_Buffer, int line)
{
    VTStep = (int) ((35.468950 / 6.9375) * FPFAC + 0.5);
    VPSStep = (int) ((35.468950 / 5.0) * FPFAC + 0.5);

    // set up threshold and offset data
    VBI_AGC(VBI_Buffer, 120, 450, 1);

    // all kinds of data with videotext data format: videotext, intercast, ... 
    VT_DecodeLine(VBI_Buffer, line, FALSE);

    // VPS information with channel name, time, VCR programming Info, etc. 
    if (line == 9)
    {
        VTS_DecodeLine(VBI_Buffer);
    }
}


void VBI_Decode() 
{
	int line;
	BYTE  *pVBI;
	static int PreviousFrame = -1;
	
	
	// Si le VBI a dj t dcod nous sortons
	if (PreviousFrame == CurrentFrame)
		return;
	else
		PreviousFrame = CurrentFrame;
	
	NexTView_AcqNewVbiFrame(0);
	pVBI = (LPBYTE) pVBILines[CurrentFrame];
	
	// MAJ des infos VBI
	for (line=0; line < 2 * TVSettings[TVTYPE].VBILines; line++)
		VBI_DecodeLine(pVBI + line * 2048, line);
}


void UpdateSTpages(unsigned char c, int VTCurrentPage )
{
/*
	int i;

	if ( (c & 0x08) != 0x08)
		return;

	i=0;
	while (i < Sous_Titres.STCount && i < 12 && Sous_Titres.STPages[i] != VTCurrentPage) i++;
	if (i < 12 && i >= Sous_Titres.STCount)
	{
		Sous_Titres.STPages[Sous_Titres.STCount]=VTCurrentPage;
		Sous_Titres.STCount++;
	}
*/
	int i=0;
	
	if ( (c & 0x08) == 0x08) // La page comporte des sous titres...
	{
		while (i < Sous_Titres.STCount && i < 12 && Sous_Titres.STPages[i] != VTCurrentPage)
			i++;
		if (i < 12 && i >= Sous_Titres.STCount) // Si elle n'est pas repertoriee on la rajoute...
		{
			Sous_Titres.STPages[Sous_Titres.STCount]=VTCurrentPage;
			Sous_Titres.STCount++;
		}
	}
	else // La page comporte n'en comporte pas...
	{
		while (i < 12 && Sous_Titres.STPages[i] != VTCurrentPage)
			i++;
		if (i < 12) // Si elle etait repertoriee on l'efface...
		{
			Sous_Titres.STPages[i]=0;
			Sous_Titres.STCount--;
			if(Sous_Titres.STCount>i+1) // Et on reordonne les pages...
			{
				while (i < Sous_Titres.STCount && i < 11) 
				{
					Sous_Titres.STPages[i]=	Sous_Titres.STPages[i+1];
					i++;
				}
			}
		}
	}
}


void SetVTPage(int Page, int SubPage, BOOL SubPageValid, BOOL LockSubPage)
{
    if ((Page < 100) || (Page > 899))
        return;

    VTPage = Page;
    VTShowHidden = FALSE;
    if (SubPageValid)
    {
        VTSubPage = SubPage;
        VTSubPageLocked = VT_CompleteSubPages(VTPage - 100) && LockSubPage;
        //TODO: It will be good idea to set timer for removing lock
        //after 2-3 mins and switching back to the most recent 
        //received subpage.
    }
    else
    {
        //Find first available SubPage with most lowest index
        VTSubPage = VT_SubPageNext(VTPage - 100, -1, 1, FALSE);
        VTSubPageLocked = FALSE;
    }

	VT_PurgeRedrawCache();	// nouveau code 1020
    VT_DoUpdate_Page(VTPage - 100, VTSubPage);
    VT_UpdateFlashTimerStatus();
    Cursor_VTUpdate(FALSE, 0, 0);
    InvalidateRect(hWnd, NULL, FALSE);
}


void SetVTShowHidden(BOOL Enabled)
{
    if ((Enabled && !VTShowHidden) || (!Enabled && VTShowHidden))
    {
        VTShowHidden = Enabled;
        VT_DoUpdate_Page(VTPage - 100, VTSubPage);
        InvalidateRect(hWnd, NULL, FALSE);
    }
}


void Cursor_VTUpdate(BOOL PosValid, int x, int y)
{
    POINT pt;
    int a;

    if (VTState == VT_OFF)
    {
        Cursor_SetType(CURSOR_DEFAULT);
    }
    else 
    {
        if (!PosValid) 
        {
            GetCursorPos(&pt);
            ScreenToClient(hWnd, &pt);
            x = pt.x; y = pt.y;
        }

        a = VT_GetPageNumberAt(VTPage-100, VTSubPage, x, y);
        if ((a >= 100) && (a <= 899))
        {
            Cursor_SetType(CURSOR_HAND);
        }
        else
        {
            Cursor_SetType(CURSOR_DEFAULT);
        }
    }
}

// Fonction appele 3 fois par seconde par le Timer TIMER_VT
// 
void VT_Refresh(BOOL bFlash)
{
	if(bFlash)
	{
		static bool Show = true;
		Show=!Show;
		if(VTState!=VT_OFF || Sous_Titres.bRun)
		{
			HDC hDC = GetDC(hWnd);
			//VT_Redraw(hWnd, hDC, FALSE, Show);
			VT_RedrawFlash(hWnd, hDC, Show);
			OSD_Redraw(hWnd, hDC);
			ReleaseDC(hWnd, hDC);
		}
	}
	else
	{
		HDC hDC = GetDC(hWnd);                    
		// On met a jour le teletexte...
		VT_ProcessRedrawCache(hWnd, hDC);
		// On met a jour l'OSD par dessus...
		OSD_Redraw(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
		VT_UpdateFlashTimerStatus();
	}
}


void Toggle_SousTitres()
{
	Sous_Titres.bActif = !Sous_Titres.bActif;
	
	if(Sous_Titres.bActif)
	{
		OSD_ShowText_Center(hWnd, Langue_GetString(ID_SUBTITLE_ON));
		SetTimer(hWnd, TIMER_ST, 3000, NULL);
		Sous_Titres.PageActive=0;
		
		if(Sous_Titres.STCount!=0)
		{
			Sous_Titres.bRun=TRUE;
			VTPage=Sous_Titres.STPages[Sous_Titres.PageActive];
			VTSubPage=0;
			SetVTPage(VTPage, VTSubPage, TRUE, FALSE);
			if(!Sous_Titres.bTeleTexte) SetTimer(hWnd, TIMER_VTUPDATE, TIMER_VTUPDATE_MS, NULL);
		}
		else
		{
			Sous_Titres.bRun=FALSE;
			if(!Sous_Titres.bTeleTexte)
				KillTimer(hWnd,TIMER_VTUPDATE);
		}
	}
	else
	{
		Sous_Titres.bRun=FALSE;
		KillTimer(hWnd,TIMER_ST);
		OSD_ShowText_Center(hWnd,Langue_GetString(ID_SUBTITLE_OFF));
		if(!Sous_Titres.bTeleTexte)
			KillTimer(hWnd,TIMER_VTUPDATE);
	}
	InvalidateRect(hWnd,NULL,FALSE);
	Affichage_Overlay_Workout(FALSE);
	UpdateMenuBar();
}


BOOL SearchGotoVTPage(BOOL bSearchAllPages)
{
    BOOL bFound = FALSE;

    //Check searchstring
    if( VTSearchString[0] == 0x00 ) 
    {
        ; //Complain bitterly
        return bFound;
    }
    
    //Search in all pages or in all following pages/subpages
    if( bSearchAllPages )
    {
        bFound = VT_SearchAllPages();
    }
    else
    {
        bFound = VT_SearchFrom(VTPage, VTSubPage);
    }

    //Act on results
    if( bFound )
    {
       SetVTPage(VTSearchPage, VTSearchSubPage, true, true);
    }
    else
    {
        ; //Nothing found
    }

    return bFound;
}
