/////////////////////////////////////////////////////////////////////////////
// NextViewPlugin.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <time.h>

#include "epgctl/mytypes.h"

#include "epgvbi/btdrv.h"
#include "epgvbi/winshm.h"
#include "epgvbi/btdrv.h"
#include "tvsim/winshmclnt.h"

#include "nextviewplugin.h"

// TODO :
// - Grant Tuner 

TVApp CurrentTVApp;
volatile EPGACQ_BUF *pVbiBuf;

bool WinSharedMemClient_SetStation( const char * pChanName, uint cni, uint inputSrc, uint freq );
bool WinSharedMemClient_SetInputFreq( uint inputSrc, uint freq );

void TtxDecode_AddPacket( const uchar * data );
void TtxDecode_AddVpsData( const uchar * data );
bool TtxDecode_NewVbiFrame( unsigned int frameSeqNo );



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


__declspec(dllexport) TVApp* InitThisPlugin()
{
	CurrentTVApp.Init			= (char (__cdecl *)(const WINSHMCLNT_TVAPP_INFO *, int *))WinSharedMemClient_Init;
	CurrentTVApp.Exit			= WinSharedMemClient_Exit;

	CurrentTVApp.AddPacket		= TtxDecode_AddPacket;
	CurrentTVApp.AddVpsData		= TtxDecode_AddVpsData;
	CurrentTVApp.AcqNewVbiFrame = TtxDecode_NewVbiFrame;

	CurrentTVApp.SetStation		= (char (__cdecl *)(const char *, unsigned int, unsigned int, unsigned int))WinSharedMemClient_SetStation;
	CurrentTVApp.GetEpgEvent    = (int (__cdecl *)(void))WinSharedMemClient_GetEpgEvent;
	CurrentTVApp.GetProgInfo    = WinSharedMemClient_GetProgInfo;
	CurrentTVApp.GetCmdArgv     = WinSharedMemClient_GetCmdArgv;
	CurrentTVApp.GetErrorMsg    = WinSharedMemClient_GetErrorMsg;

	return &CurrentTVApp;
}
