/////////////////////////////////////////////////////////////////////////////
// PluginVideo.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#ifndef VIDEOPLUGIN
#define VIDEOPLUGIN

#include <windows.h>

// version actuelle du plugin
#define VIDEO_PLUGIN_VERSION	1011


//////////////////////////////////////////////////////////////////////////////////
// Structure utilise pour communiquer avec le plugin
// Pour plus de dtails voir K!TV et le code du plugin test.
//
// Remarques sur les variables (R/W):
// W : le plugin doit donner une valeur  cette variable.
// R : le plugin ne doit pas modifier cette variable (lecture seule).
// RW: la variable peut etre modifie par le plugin et par K!TV.
//////////////////////////////////////////////////////////////////////////////////

typedef struct 
{
	int			version;		// W: Version du plugin  (= VIDEO_PLUGIN_VERSION)
	char		*description;	// W: Format obligatoire : nom_du_plugin espace (nom_de_l_auteur)
	
	HWND		hwndParent;		// R: Handle de K!TV
	HINSTANCE	hDllInstance;	// R: Handle du plugin

	BOOL FullField;				// R: Affichage simple (HF) ou double (FF) trame
	
	BOOL VIA_FIX;				// RW: Capture en rsolution infrieure a 768 active
	BOOL AutoProcessVideo;		// RW: Dmarrage automatique du plugin (Si DetecteSignal = TRUE)
	BOOL DeInterlace;			// R: Dsentrelacement activ
	BOOL bIsBT878;				// R: La carte TV est un BT878 

	int CurrentX;				// R: Largeur actuelle de la trame capture
	int CurrentFrame;			// R: Trame courante (pour acceder aux *EvenLines)
	int MovieBoost;				// R: Acclration pour mode 16/9 (bandes noires)
	int VIA_FIX_X;				// RW: Si VIA_FIX=TRUE, modifie la largeur de capture
	WORD LangID;				// R: Langage courant (obtenu avec MAKELANGID)

	ACCEL *accel;				// W: Liste des raccourcis claviers dfinis
	int NbAccel;				// W: Nombre de raccouris dfinis

	short *EvenLines[5][288], *OddLines[5][288];			// Lignes captures
	short *OutEvenLines[5][288], *OutOddLines[5][288];		// Lignes  afficher

	// Fonctions de controle
	BOOL (__cdecl *Start)();
	BOOL (__cdecl *Stop)();

	// Fonctions lis au thread d'affichage
	void (__cdecl *InitStuff)();
	void (__cdecl *DoStuff)(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);
	void (__cdecl *CheckStuff)();

	// Fonctions de l'interface utilisateur
	void (__cdecl *ShowDialog)();
	HMENU(__cdecl *GetPluginMenu)(BOOL ContextMenu);
	BOOL (__cdecl *ProcessMessage)(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);

	// Diverses fonctions
	void (__cdecl *GetStatus)(char * Text, BOOL Nb);
	void (__cdecl *SetLow)(unsigned char bBrightness);
	BOOL (__cdecl *AutoMovieBoostFound)();
	BOOL (__cdecl *DetecteSignal)(BYTE *VBI);

} QuenotteTV_VideoPlugin;


#endif